#if !defined(AFX_ATSELECTDLG_H__FACEC72E_7C9F_4C5F_AB9A_79CE31DBB69A__INCLUDED_)
#define AFX_ATSELECTDLG_H__FACEC72E_7C9F_4C5F_AB9A_79CE31DBB69A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ATSelectDlg.h : header file
//
#include "SuckLessDialog.h"

class CSNDevice;
class CCSFAbstractTree;
class CCSFATButtonList;
class CCSFATPanelList;
class CProntoString;
class CCSFButtonPath;

/////////////////////////////////////////////////////////////////////////////
// CATSelectDlg dialog

class CATSelectDlg : public CSuckLessDialog
{
public:
	enum PathType
	{
		PT_BUTTON,
		PT_PANEL
	};

	CATSelectDlg(PathType pathType,
				 bool bAllowNonUnique,
				 LPCTSTR szTitle,
				 CProntoString *pPSDev,
				 CProntoString *pPSPan,
				 CProntoString *pPSBut,
				 const CCSFAbstractTree *pAbstractTree,
				 CWnd* pParent);

	// Dialog Data
	//{{AFX_DATA(CATSelectDlg)
	enum { IDD = IDD_ATSELECT_DIALOG };
	CButton	m_ctrlButtonOK;
	CTreeCtrl	m_ctrlTree;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CATSelectDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	enum
	{
		ILIDX_DEVICE			= 0,
		ILIDX_MACROGROUP		= 1,
		ILIDX_PANEL				= 2,
		ILIDX_BUTTON			= 3,
		ILIDX_HARDBUTTONS		= 4,
		ILIDX_DEVICE_CROSS		= 5,
		ILIDX_MACROGROUP_CROSS	= 6,
		ILIDX_PANEL_CROSS		= 7,
		ILIDX_BUTTON_CROSS		= 8,
		ILIDX_HARDBUTTONS_CROSS	= 9
	};

	bool populateTree(void);
	
	bool populateTreePanels(const CCSFATPanelList *pPanelList,
							HTREEITEM htItemDev,
							bool bSelectDev);

	bool populateTreeHardButtons(const CCSFATButtonList *pButtonList,
								 HTREEITEM htItemDev,
								 bool bSelectDev);

	bool populateTreeButtons(const CCSFATButtonList *pButtonList,
							 HTREEITEM htItemDev,
							 HTREEITEM htItemPan,
							 bool bSelectPan);

	BOOL validateSelection(HTREEITEM htItem);

protected:
	CString m_csTitle;

	CProntoString *m_pPSDev;
	CProntoString *m_pPSPan;
	CProntoString *m_pPSBut;

	PathType m_pathType;
	bool m_bAllowNonUnique;
	CSNDevice *m_pSNDevice;
	const CCSFAbstractTree *m_pAbstractTree;

	CImageList m_treeImageList;

	// Generated message map functions
	//{{AFX_MSG(CATSelectDlg)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangedTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkTree(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ATSELECTDLG_H__FACEC72E_7C9F_4C5F_AB9A_79CE31DBB69A__INCLUDED_)
