// ArtistDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ArtistDlg.h"
#include "SNVolume.h"
#include "ProntoStringDlg.h"
#include "SNConfig.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CArtistDlg dialog

CArtistDlg::CArtistDlg(ISNUITreeDlg *pTreeDlg,
						const CSNArtist *pTemplateArtist, const CSNArtist *pUpdateArtist, const CSNArtist *pToAddBelow,
						const CSNArtist **ppArtistOut,
						ISNUITreeVolume *pParentVolume,
						CWnd* pParent)
	: CSuckLessDialog(CArtistDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CArtistDlg)
	m_editName = _T("");
	m_editShortName = _T("");
	m_editSortAs = _T("");
	//}}AFX_DATA_INIT

	m_pNewArtist = new CSNArtist();

	if (NULL != pTemplateArtist)
	{
		m_pNewArtist->Set(pTemplateArtist);
	}

	m_pUpdateArtist = pUpdateArtist;
	m_pToAddBelow = pToAddBelow;
	m_pParentVolume = pParentVolume;
	m_pTreeDlg = pTreeDlg;

	m_ppArtistOut = ppArtistOut;

	if (NULL != m_ppArtistOut)
	{
		(*m_ppArtistOut) = NULL;
	}
}

CArtistDlg::~CArtistDlg()
{
	delete m_pNewArtist;
	m_pNewArtist = NULL;
}

void CArtistDlg::DoDataExchange(CDataExchange* pDX)
{
	CSuckLessDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CArtistDlg)
	DDX_Control(pDX, IDC_EDIT_SORTAS, m_ctrlEditSortAs);
	DDX_Control(pDX, IDC_EDIT_SHORTNAME, m_ctrlEditShortName);
	DDX_Control(pDX, IDC_EDIT_NAME, m_ctrlEditName);
	DDX_Text(pDX, IDC_EDIT_NAME, m_editName);
	DDX_Text(pDX, IDC_EDIT_SHORTNAME, m_editShortName);
	DDX_Text(pDX, IDC_EDIT_SORTAS, m_editSortAs);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CArtistDlg, CSuckLessDialog)
	//{{AFX_MSG_MAP(CArtistDlg)
	ON_BN_CLICKED(IDC_BUTTON_NAME, OnButtonName)
	ON_BN_CLICKED(IDC_BUTTON_SHORTNAME, OnButtonShortname)
	ON_BN_CLICKED(IDC_BUTTON_SORTAS, OnButtonSortas)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CArtistDlg message handlers

BOOL CArtistDlg::OnInitDialog() 
{
	CSuckLessDialog::OnInitDialog();
	
	UpdateData(TRUE);

	this->setWindowIcon(IDR_MAINFRAME);

	CString winTitle;
	GetWindowText(winTitle);
	if (NULL != m_pUpdateArtist)
	{
		winTitle += " -- (";
		winTitle += m_pUpdateArtist->GetName()->GetPrintable(true);
		winTitle += ")";
	}
	else
	{
		winTitle += " -- <New>";
	}
	SetWindowText(winTitle);

	// -- Initial contents --

	if (NULL != g_pProntoFont)
	{
		m_ctrlEditName.SetFont(g_pProntoFont);
		m_ctrlEditShortName.SetFont(g_pProntoFont);
		m_ctrlEditSortAs.SetFont(g_pProntoFont);
	}

	m_editName		= m_pNewArtist->GetName()->GetPronto(true);
	m_editShortName	= m_pNewArtist->GetShortName()->GetPronto(true);
	m_editSortAs	= m_pNewArtist->GetSortAsName()->GetPronto(true);

	// -- Control setup --

	addControlInfo(IDC_STATIC_NAMEFRAME);

	addControlInfo(IDC_STATIC_NAME);
	addControlInfo(IDC_EDIT_NAME);
	addControlInfo(IDC_BUTTON_NAME);

	addControlInfo(IDC_STATIC_SHORTNAME);
	addControlInfo(IDC_EDIT_SHORTNAME);
	addControlInfo(IDC_BUTTON_SHORTNAME);
	addControlInfo(IDC_STATIC_SHORTNAMEINFO);

	addControlInfo(IDC_STATIC_SORTAS);
	addControlInfo(IDC_EDIT_SORTAS);
	addControlInfo(IDC_BUTTON_SORTAS);
	addControlInfo(IDC_STATIC_SORTASINFO);

	addControlInfo(IDC_BUTTON_HELP);

	addControlInfo(IDOK);
	addControlInfo(IDCANCEL);

	setControlRelationship(IDC_STATIC_NAMEFRAME,		IDD, CControlInfo::ACOMMON_RESIZEHEIGHT_RESIZEWIDTH);

	setControlRelationship(IDC_STATIC_NAME,				IDD, CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_NAME,				IDD, CControlInfo::ACOMMON_TOP_RESIZEWIDTH);
	setControlRelationship(IDC_BUTTON_NAME,				IDD, CControlInfo::ACOMMON_TOP_RIGHT);

	setControlRelationship(IDC_STATIC_SHORTNAME,		IDD, CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_SHORTNAME,			IDD, CControlInfo::ACOMMON_TOP_RESIZEWIDTH);
	setControlRelationship(IDC_BUTTON_SHORTNAME,		IDD, CControlInfo::ACOMMON_TOP_RIGHT);
	setControlRelationship(IDC_STATIC_SHORTNAMEINFO,	IDD, CControlInfo::ACOMMON_TOP_RIGHT);

	setControlRelationship(IDC_STATIC_SORTAS,			IDD, CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_SORTAS,				IDD, CControlInfo::ACOMMON_TOP_RESIZEWIDTH);
	setControlRelationship(IDC_BUTTON_SORTAS,			IDD, CControlInfo::ACOMMON_TOP_RIGHT);
	setControlRelationship(IDC_STATIC_SORTASINFO,		IDD, CControlInfo::ACOMMON_TOP_RIGHT);

	setControlRelationship(IDC_BUTTON_HELP,				IDD, CControlInfo::ACOMMON_BOTTOM_LEFT);

	setControlRelationship(IDOK,						IDD, CControlInfo::ACOMMON_BOTTOM_RIGHT);
	setControlRelationship(IDCANCEL,					IDD, CControlInfo::ACOMMON_BOTTOM_RIGHT);

	controlAndFrameInfoIsSetup();

	setMinXToCurrent();
	setMinYToCurrent();
	setMaxYToCurrent();

	UpdateData(FALSE);

	this->setRememberWindowPosition(SN_REG_PATH_WINDOWPOS, SN_REG_VALUE_WINDOWPOS_ARTIST);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CArtistDlg::OnButtonName() 
{
	CProntoStringDlg *pSLDlg = new CProntoStringDlg(&m_ctrlEditName, "Artist Name", this);
	this->openPseudoModalChild(pSLDlg, CProntoStringDlg::IDD, false, true);
}

void CArtistDlg::OnButtonShortname() 
{
	CProntoStringDlg *pSLDlg = new CProntoStringDlg(&m_ctrlEditShortName, "Artist Name (short version)", this);
	this->openPseudoModalChild(pSLDlg, CProntoStringDlg::IDD, false, true);
}

void CArtistDlg::OnButtonSortas() 
{
	CProntoStringDlg *pSLDlg = new CProntoStringDlg(&m_ctrlEditSortAs, "Artist Name (for sorting)", this);
	this->openPseudoModalChild(pSLDlg, CProntoStringDlg::IDD, false, true);
}

void CArtistDlg::OnOK() 
{
	UpdateData(TRUE);

	// -- Put any unsaved values into the artist. --

	m_pNewArtist->GetName()->SetPronto(LPCTSTR(m_editName));
	m_pNewArtist->GetShortName()->SetPronto(LPCTSTR(m_editShortName));
	m_pNewArtist->GetSortAsName()->SetPronto(LPCTSTR(m_editSortAs));

	// -- Try to add to/update the list. --

	CTypedError tError;

	const CSNArtist *pAddUpdateResult = NULL;

	if (NULL != m_pUpdateArtist)
	{
		pAddUpdateResult = m_pParentVolume->SNUIT_UpdateArtist(m_pTreeDlg, &tError, m_pNewArtist, m_pUpdateArtist);
	}
	else
	{
		pAddUpdateResult = m_pParentVolume->SNUIT_AddBelowAndOwnArtist(m_pTreeDlg, &tError, m_pNewArtist, m_pToAddBelow);
	}

	if (NULL == pAddUpdateResult)
	{
		MessageBox(CTypedError::SafeGetFullErrorTextTempBuffer(&tError),
				   NULL != m_pUpdateArtist ? "Cannot update artist" : "Cannot add artist",
				   MB_OK | MB_ICONEXCLAMATION);
	}
	else
	{
		if (NULL == m_pUpdateArtist)
		{
			// We no longer own the volume
			// and should not delete it on destruction.
			m_pNewArtist = NULL;
		}

		if (NULL != m_ppArtistOut)
		{
			(*m_ppArtistOut) = pAddUpdateResult;
		}

		CSuckLessDialog::OnOK();
	}
}
