// CSVDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SNConfig.h"
#include "CSVDlg.h"
#include "CSVFile.h"
#include "SNCSVLine.h"
#include "SNLibrary.h"
#include "ListingDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCSVDlg dialog


CCSVDlg::CCSVDlg(bool bImport, CSNConfig *pConfig, const char *szFilename, CWnd* pParent)
	: CSuckLessDialog(CCSVDlg::IDD, pParent),
	  m_bImport(bImport),
	  m_pConfig(pConfig),
	  m_strFilename(szFilename),
	  m_bUpdatingCheckEditSpin(false),
	  m_bInputPreviewDone(false),
	  m_bInitDone(false),
	  m_pCSVPreviewFile(NULL),
	  m_pCSVPreviewData(NULL)
{
	//{{AFX_DATA_INIT(CCSVDlg)
	//}}AFX_DATA_INIT

	m_listSpinAssoc.push_back(SSpinAssoc(&m_ctrlCheckListName,			&m_ctrlEditListName,			&m_ctrlSpinListName,			SN_REG_VALUE_CSV_LISTNAME,			&m_csvMap.m_nColListName));
	m_listSpinAssoc.push_back(SSpinAssoc(&m_ctrlCheckSNDevName,			&m_ctrlEditSNDevName,			&m_ctrlSpinSNDevName,			SN_REG_VALUE_CSV_SNDEVNAME,			&m_csvMap.m_nColSNDevName));
	m_listSpinAssoc.push_back(SSpinAssoc(&m_ctrlCheckArtistName,		&m_ctrlEditArtistName,			&m_ctrlSpinArtistName,			SN_REG_VALUE_CSV_ARTISTNAME,		&m_csvMap.m_nColArtistName));
	m_listSpinAssoc.push_back(SSpinAssoc(&m_ctrlCheckArtistShortName,	&m_ctrlEditArtistShortName,		&m_ctrlSpinArtistShortName,		SN_REG_VALUE_CSV_ARTISTSHORTNAME,	&m_csvMap.m_nColArtistShortName));
	m_listSpinAssoc.push_back(SSpinAssoc(&m_ctrlCheckArtistSortAsName,	&m_ctrlEditArtistSortAsName,	&m_ctrlSpinArtistSortAsName,	SN_REG_VALUE_CSV_ARTISTSORTASNAME,	&m_csvMap.m_nColArtistSortAsName));
	m_listSpinAssoc.push_back(SSpinAssoc(&m_ctrlCheckDiscNumber,		&m_ctrlEditDiscNumber,			&m_ctrlSpinDiscNumber,			SN_REG_VALUE_CSV_DISCNUMBER,		&m_csvMap.m_nColDiscNumber));
	m_listSpinAssoc.push_back(SSpinAssoc(&m_ctrlCheckDiscName,			&m_ctrlEditDiscName,			&m_ctrlSpinDiscName,			SN_REG_VALUE_CSV_DISCNAME,			&m_csvMap.m_nColDiscName));
	m_listSpinAssoc.push_back(SSpinAssoc(&m_ctrlCheckDiscShortName,		&m_ctrlEditDiscShortName,		&m_ctrlSpinDiscShortName,		SN_REG_VALUE_CSV_DISCSHORTNAME,		&m_csvMap.m_nColDiscShortName));
	m_listSpinAssoc.push_back(SSpinAssoc(&m_ctrlCheckDiscSortAsName,	&m_ctrlEditDiscSortAsName,		&m_ctrlSpinDiscSortAsName,		SN_REG_VALUE_CSV_DISCSORTASNAME,	&m_csvMap.m_nColDiscSortAsName));
	m_listSpinAssoc.push_back(SSpinAssoc(&m_ctrlCheckTrackNumber,		&m_ctrlEditTrackNumber,			&m_ctrlSpinTrackNumber,			SN_REG_VALUE_CSV_TRACKNUMBER,		&m_csvMap.m_nColTrackNumber));
	m_listSpinAssoc.push_back(SSpinAssoc(&m_ctrlCheckTrackName,			&m_ctrlEditTrackName,			&m_ctrlSpinTrackName,			SN_REG_VALUE_CSV_TRACKNAME,			&m_csvMap.m_nColTrackName));

	ZeroMemory(&m_csvMapForDataPreview, sizeof(m_csvMapForDataPreview));
	m_csvMapForDataPreview.m_nColListName			= 1;	m_listDataPreviewColumnTitles.push_back("List");
	m_csvMapForDataPreview.m_nColSNDevName			= 2;	m_listDataPreviewColumnTitles.push_back("Player");
	m_csvMapForDataPreview.m_nColArtistName			= 3;	m_listDataPreviewColumnTitles.push_back("Artist");
	m_csvMapForDataPreview.m_nColArtistShortName	= 4;	m_listDataPreviewColumnTitles.push_back("Artist (Short)");
	m_csvMapForDataPreview.m_nColArtistSortAsName	= 5;	m_listDataPreviewColumnTitles.push_back("Artist (Sort As)");
	m_csvMapForDataPreview.m_nColDiscNumber			= 6;	m_listDataPreviewColumnTitles.push_back("Disc #");
	m_csvMapForDataPreview.m_nColDiscName			= 7;	m_listDataPreviewColumnTitles.push_back("Disc");
	m_csvMapForDataPreview.m_nColDiscShortName		= 8;	m_listDataPreviewColumnTitles.push_back("Disc (Short)");
	m_csvMapForDataPreview.m_nColDiscSortAsName		= 9;	m_listDataPreviewColumnTitles.push_back("Disc (Sort As)");
	m_csvMapForDataPreview.m_nColTrackNumber		= 10;	m_listDataPreviewColumnTitles.push_back("Track #");
	m_csvMapForDataPreview.m_nColTrackName			= 11;	m_listDataPreviewColumnTitles.push_back("Track");
}

CCSVDlg::~CCSVDlg()
{
	delete m_pCSVPreviewFile;
	m_pCSVPreviewFile = NULL;

	delete m_pCSVPreviewData;
	m_pCSVPreviewData = NULL;
}

void CCSVDlg::DoDataExchange(CDataExchange* pDX)
{
	CSuckLessDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCSVDlg)
	DDX_Control(pDX, IDC_STATIC_PREVIEWTOP, m_ctrlStaticPreviewTop);
	DDX_Control(pDX, IDC_STATIC_PREVIEWBOTTOM, m_ctrlStaticPreviewBottom);
	DDX_Control(pDX, IDC_LIST_BOTTOM, m_ctrlListBottom);
	DDX_Control(pDX, IDC_LIST_TOP, m_ctrlListTop);
	DDX_Control(pDX, IDC_CHECK_LISTNAME, m_ctrlCheckListName);
	DDX_Control(pDX, IDC_EDIT_LISTNAME, m_ctrlEditListName);
	DDX_Control(pDX, IDC_SPIN_LISTNAME, m_ctrlSpinListName);
	DDX_Control(pDX, IDC_CHECK_SNDEVNAME, m_ctrlCheckSNDevName);
	DDX_Control(pDX, IDC_EDIT_SNDEVNAME, m_ctrlEditSNDevName);
	DDX_Control(pDX, IDC_SPIN_SNDEVNAME, m_ctrlSpinSNDevName);
	DDX_Control(pDX, IDC_CHECK_ARTISTNAME, m_ctrlCheckArtistName);
	DDX_Control(pDX, IDC_EDIT_ARTISTNAME, m_ctrlEditArtistName);
	DDX_Control(pDX, IDC_SPIN_ARTISTNAME, m_ctrlSpinArtistName);
	DDX_Control(pDX, IDC_CHECK_ARTISTSHORTNAME, m_ctrlCheckArtistShortName);
	DDX_Control(pDX, IDC_EDIT_ARTISTSHORTNAME, m_ctrlEditArtistShortName);
	DDX_Control(pDX, IDC_SPIN_ARTISTSHORTNAME, m_ctrlSpinArtistShortName);
	DDX_Control(pDX, IDC_CHECK_ARTISTSORTASNAME, m_ctrlCheckArtistSortAsName);
	DDX_Control(pDX, IDC_EDIT_ARTISTSORTASNAME, m_ctrlEditArtistSortAsName);
	DDX_Control(pDX, IDC_SPIN_ARTISTSORTASNAME, m_ctrlSpinArtistSortAsName);
	DDX_Control(pDX, IDC_CHECK_DISCNUMBER, m_ctrlCheckDiscNumber);
	DDX_Control(pDX, IDC_EDIT_DISCNUMBER, m_ctrlEditDiscNumber);
	DDX_Control(pDX, IDC_SPIN_DISCNUMBER, m_ctrlSpinDiscNumber);
	DDX_Control(pDX, IDC_CHECK_DISCNAME, m_ctrlCheckDiscName);
	DDX_Control(pDX, IDC_EDIT_DISCNAME, m_ctrlEditDiscName);
	DDX_Control(pDX, IDC_SPIN_DISCNAME, m_ctrlSpinDiscName);
	DDX_Control(pDX, IDC_CHECK_DISCSHORTNAME, m_ctrlCheckDiscShortName);
	DDX_Control(pDX, IDC_EDIT_DISCSHORTNAME, m_ctrlEditDiscShortName);
	DDX_Control(pDX, IDC_SPIN_DISCSHORTNAME, m_ctrlSpinDiscShortName);
	DDX_Control(pDX, IDC_CHECK_DISCSORTASNAME, m_ctrlCheckDiscSortAsName);
	DDX_Control(pDX, IDC_EDIT_DISCSORTASNAME, m_ctrlEditDiscSortAsName);
	DDX_Control(pDX, IDC_SPIN_DISCSORTASNAME, m_ctrlSpinDiscSortAsName);
	DDX_Control(pDX, IDC_CHECK_TRACKNUMBER, m_ctrlCheckTrackNumber);
	DDX_Control(pDX, IDC_EDIT_TRACKNUMBER, m_ctrlEditTrackNumber);
	DDX_Control(pDX, IDC_SPIN_TRACKNUMBER, m_ctrlSpinTrackNumber);
	DDX_Control(pDX, IDC_CHECK_TRACKNAME, m_ctrlCheckTrackName);
	DDX_Control(pDX, IDC_EDIT_TRACKNAME, m_ctrlEditTrackName);
	DDX_Control(pDX, IDC_SPIN_TRACKNAME, m_ctrlSpinTrackName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCSVDlg, CSuckLessDialog)
	//{{AFX_MSG_MAP(CCSVDlg)
	ON_WM_VSCROLL()
	ON_BN_CLICKED(IDC_CHECK_ARTISTNAME, OnCheckArtistname)
	ON_BN_CLICKED(IDC_CHECK_ARTISTSHORTNAME, OnCheckArtistshortname)
	ON_BN_CLICKED(IDC_CHECK_ARTISTSORTASNAME, OnCheckArtistsortasname)
	ON_BN_CLICKED(IDC_CHECK_DISCNAME, OnCheckDiscname)
	ON_BN_CLICKED(IDC_CHECK_DISCNUMBER, OnCheckDiscnumber)
	ON_BN_CLICKED(IDC_CHECK_DISCSHORTNAME, OnCheckDiscshortname)
	ON_BN_CLICKED(IDC_CHECK_DISCSORTASNAME, OnCheckDiscsortasname)
	ON_BN_CLICKED(IDC_CHECK_LISTNAME, OnCheckListname)
	ON_BN_CLICKED(IDC_CHECK_SNDEVNAME, OnCheckSndevname)
	ON_BN_CLICKED(IDC_CHECK_TRACKNAME, OnCheckTrackname)
	ON_BN_CLICKED(IDC_CHECK_TRACKNUMBER, OnCheckTracknumber)
	ON_EN_CHANGE(IDC_EDIT_ARTISTNAME, OnChangeEditArtistname)
	ON_EN_CHANGE(IDC_EDIT_ARTISTSHORTNAME, OnChangeEditArtistshortname)
	ON_EN_CHANGE(IDC_EDIT_ARTISTSORTASNAME, OnChangeEditArtistsortasname)
	ON_EN_CHANGE(IDC_EDIT_DISCNAME, OnChangeEditDiscname)
	ON_EN_CHANGE(IDC_EDIT_DISCNUMBER, OnChangeEditDiscnumber)
	ON_EN_CHANGE(IDC_EDIT_DISCSHORTNAME, OnChangeEditDiscshortname)
	ON_EN_CHANGE(IDC_EDIT_DISCSORTASNAME, OnChangeEditDiscsortasname)
	ON_EN_CHANGE(IDC_EDIT_LISTNAME, OnChangeEditListname)
	ON_EN_CHANGE(IDC_EDIT_SNDEVNAME, OnChangeEditSndevname)
	ON_EN_CHANGE(IDC_EDIT_TRACKNAME, OnChangeEditTrackname)
	ON_EN_CHANGE(IDC_EDIT_TRACKNUMBER, OnChangeEditTracknumber)
	ON_BN_CLICKED(IDC_BUTTON_PREVIEW, OnButtonPreview)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCSVDlg message handlers

BOOL CCSVDlg::OnInitDialog() 
{
	CSuckLessDialog::OnInitDialog();
	
	this->setWindowIcon(IDR_MAINFRAME);

	this->SetWindowText(m_bImport ? "Import from CSV" : "Export to CSV");

	m_ctrlStaticPreviewTop.SetWindowText(m_bImport ? "CSV:" : "Data:");
	m_ctrlStaticPreviewBottom.SetWindowText(m_bImport ? "Data:" : "CSV:");

	m_ctrlListTop.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	m_ctrlListBottom.SetExtendedStyle(LVS_EX_FULLROWSELECT);

	if (NULL != g_pProntoFont)
	{
		m_ctrlListTop.SetFont(g_pProntoFont);
		m_ctrlListBottom.SetFont(g_pProntoFont);
	}

	//--

	int i = 1;

	for (list<SSpinAssoc>::const_iterator asiter = m_listSpinAssoc.begin(); asiter != m_listSpinAssoc.end(); asiter++)
	{
		DWORD dwValue = 0;

		LeetRegQueryDWORDValue(HKEY_CURRENT_USER, SN_REG_PATH_CSV, asiter->m_szRegValueName, &dwValue);

		asiter->m_pSpin->SetRange32(0, MAX_CSV_COLUMNS);

		updateCheckEditSpin(UCES_NONE, asiter->m_pCheck, asiter->m_pEdit, asiter->m_pSpin, dwValue);
	}

	// -- Control setup --

	addControlInfo(IDC_STATIC_SETTINGS);
	addControlInfo(IDC_CHECK_LISTNAME);
	addControlInfo(IDC_EDIT_LISTNAME);
	addControlInfo(IDC_SPIN_LISTNAME);
	addControlInfo(IDC_CHECK_SNDEVNAME);
	addControlInfo(IDC_EDIT_SNDEVNAME);
	addControlInfo(IDC_SPIN_SNDEVNAME);
	addControlInfo(IDC_CHECK_ARTISTNAME);
	addControlInfo(IDC_EDIT_ARTISTNAME);
	addControlInfo(IDC_SPIN_ARTISTNAME);
	addControlInfo(IDC_CHECK_ARTISTSHORTNAME);
	addControlInfo(IDC_EDIT_ARTISTSHORTNAME);
	addControlInfo(IDC_SPIN_ARTISTSHORTNAME);
	addControlInfo(IDC_CHECK_ARTISTSORTASNAME);
	addControlInfo(IDC_EDIT_ARTISTSORTASNAME);
	addControlInfo(IDC_SPIN_ARTISTSORTASNAME);
	addControlInfo(IDC_CHECK_DISCNUMBER);
	addControlInfo(IDC_EDIT_DISCNUMBER);
	addControlInfo(IDC_SPIN_DISCNUMBER);
	addControlInfo(IDC_CHECK_DISCNAME);
	addControlInfo(IDC_EDIT_DISCNAME);
	addControlInfo(IDC_SPIN_DISCNAME);
	addControlInfo(IDC_CHECK_DISCSHORTNAME);
	addControlInfo(IDC_EDIT_DISCSHORTNAME);
	addControlInfo(IDC_SPIN_DISCSHORTNAME);
	addControlInfo(IDC_CHECK_DISCSORTASNAME);
	addControlInfo(IDC_EDIT_DISCSORTASNAME);
	addControlInfo(IDC_SPIN_DISCSORTASNAME);
	addControlInfo(IDC_CHECK_TRACKNUMBER);
	addControlInfo(IDC_EDIT_TRACKNUMBER);
	addControlInfo(IDC_SPIN_TRACKNUMBER);
	addControlInfo(IDC_CHECK_TRACKNAME);
	addControlInfo(IDC_EDIT_TRACKNAME);
	addControlInfo(IDC_SPIN_TRACKNAME);
	addControlInfo(IDC_STATIC_PREVIEW);
	addControlInfo(IDC_STATIC_PREVIEWTOP);
	addControlInfo(IDC_LIST_TOP);
	addControlInfo(IDC_STATIC_PREVIEWBOTTOM);
	addControlInfo(IDC_LIST_BOTTOM);
	addControlInfo(IDC_BUTTON_PREVIEW);
	addControlInfo(IDOK);
	addControlInfo(IDCANCEL);


	setControlRelationship(IDC_STATIC_SETTINGS,			IDD,					CControlInfo::ATOP_TOP,
																				CControlInfo::ABOTTOM_TOP,
																				CControlInfo::ALEFTRIGHT_CENTER,
																				CControlInfo::ATAG_ENDLIST);

	setControlRelationship(IDC_CHECK_LISTNAME,			IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_LISTNAME,			IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_SPIN_LISTNAME,			IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_CHECK_SNDEVNAME,			IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_SNDEVNAME,			IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_SPIN_SNDEVNAME,			IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_CHECK_ARTISTNAME,		IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_ARTISTNAME,			IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_SPIN_ARTISTNAME,			IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_CHECK_ARTISTSHORTNAME,	IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_ARTISTSHORTNAME,	IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_SPIN_ARTISTSHORTNAME,	IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_CHECK_ARTISTSORTASNAME,	IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_ARTISTSORTASNAME,	IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_SPIN_ARTISTSORTASNAME,	IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_CHECK_DISCNUMBER,		IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_DISCNUMBER,			IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_SPIN_DISCNUMBER,			IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_CHECK_DISCNAME,			IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_DISCNAME,			IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_SPIN_DISCNAME,			IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_CHECK_DISCSHORTNAME,		IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_DISCSHORTNAME,		IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_SPIN_DISCSHORTNAME,		IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_CHECK_DISCSORTASNAME,	IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_DISCSORTASNAME,		IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_SPIN_DISCSORTASNAME,		IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_CHECK_TRACKNUMBER,		IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_TRACKNUMBER,		IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_SPIN_TRACKNUMBER,		IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_CHECK_TRACKNAME,			IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_TRACKNAME,			IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_SPIN_TRACKNAME,			IDC_STATIC_SETTINGS,	CControlInfo::ACOMMON_TOP_LEFT);

	setControlRelationship(IDC_STATIC_PREVIEW,			IDD,					CControlInfo::ACOMMON_RESIZEHEIGHT_RESIZEWIDTH);
	setControlRelationship(IDC_STATIC_PREVIEWTOP,		IDC_LIST_TOP,			CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_STATIC_PREVIEWBOTTOM,	IDC_LIST_BOTTOM,		CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_LIST_TOP,				IDC_STATIC_PREVIEW,		CControlInfo::ATOP_TOP,
																				CControlInfo::ABOTTOM_CENTER,
																				CControlInfo::ALEFT_LEFT,
																				CControlInfo::ARIGHT_RIGHT,
																				CControlInfo::ATAG_ENDLIST);
	setControlRelationship(IDC_LIST_BOTTOM,				IDC_STATIC_PREVIEW,		CControlInfo::ATOP_CENTER,
																				CControlInfo::ABOTTOM_BOTTOM,
																				CControlInfo::ALEFT_LEFT,
																				CControlInfo::ARIGHT_RIGHT,
																				CControlInfo::ATAG_ENDLIST);

	setControlRelationship(IDC_BUTTON_PREVIEW,	IDD,					CControlInfo::ACOMMON_BOTTOM_LEFT);

	setControlRelationship(IDOK,				IDD,					CControlInfo::ACOMMON_BOTTOM_RIGHT);
	setControlRelationship(IDCANCEL,			IDD,					CControlInfo::ACOMMON_BOTTOM_RIGHT);

	controlAndFrameInfoIsSetup();

	setMinXToCurrent();
	setMinYToCurrent();

	m_bInitDone = true;

	this->setRememberWindowPosition(SN_REG_PATH_WINDOWPOS, SN_REG_VALUE_WINDOWPOS_CSV);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

// nNewSpinPos ignored unless updated is UCES_SPIN or UCES_NONE
void CCSVDlg::updateCheckEditSpin(UCES_UPDATED updated, CButton *pCheck, CEdit *pEdit, CSpinButtonCtrl *pSpin, int nNewSpinPos)
{
	if (! m_bUpdatingCheckEditSpin )
	{
		// Stops recursive calls.
		m_bUpdatingCheckEditSpin = true;

		int nValue = 0;

		if (UCES_CHECK == updated)
		{
			nValue = (BST_CHECKED == pCheck->GetCheck() ? 1 : 0);
		}
		else
		{
			if (UCES_EDIT == updated)
			{
				CString csEditText;
				pEdit->GetWindowText(csEditText);
				nValue = atoi(csEditText);
			}
			else if ((UCES_SPIN == updated) || (UCES_NONE == updated))
			{
				nValue = nNewSpinPos; // Cannot use pSpin->GetPos as it reads from the edit control, even though SetPos doesn't write to it with our setup. FFS.
			}

			if (1 > nValue)
			{
				nValue = 0;
				updated = UCES_NONE;
			}
			else if (MAX_CSV_COLUMNS < nValue)
			{
				nValue = MAX_CSV_COLUMNS;
				updated = UCES_NONE;
			}
		}

		if (UCES_CHECK != updated)
		{
			pCheck->SetCheck(nValue == 0 ? BST_UNCHECKED : BST_CHECKED);
		}

		if (UCES_EDIT != updated)
		{
			CString csEditText;
			if (nValue != 0)
			{
				csEditText.Format("%d", nValue);
			}
			pEdit->SetWindowText(csEditText);
		}

		if (UCES_SPIN != updated)
		{
			pSpin->SetPos(nValue);
		}

		m_bUpdatingCheckEditSpin = false;
	}
}

void CCSVDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	for (list<SSpinAssoc>::const_iterator asiter = m_listSpinAssoc.begin(); asiter != m_listSpinAssoc.end(); asiter++)
	{
		if (asiter->m_pSpin->GetDlgCtrlID() == pScrollBar->GetDlgCtrlID())
		{
			updateCheckEditSpin(UCES_SPIN, asiter->m_pCheck, asiter->m_pEdit, asiter->m_pSpin, nPos);
		}
	}

	CSuckLessDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CCSVDlg::OnCheckArtistname() 
{
	updateCheckEditSpin(UCES_CHECK, &m_ctrlCheckArtistName, &m_ctrlEditArtistName, &m_ctrlSpinArtistName, 0);
}

void CCSVDlg::OnCheckArtistshortname() 
{
	updateCheckEditSpin(UCES_CHECK, &m_ctrlCheckArtistShortName, &m_ctrlEditArtistShortName, &m_ctrlSpinArtistShortName, 0);
}

void CCSVDlg::OnCheckArtistsortasname() 
{
	updateCheckEditSpin(UCES_CHECK, &m_ctrlCheckArtistSortAsName, &m_ctrlEditArtistSortAsName, &m_ctrlSpinArtistSortAsName, 0);
}

void CCSVDlg::OnCheckDiscname() 
{
	updateCheckEditSpin(UCES_CHECK, &m_ctrlCheckDiscName, &m_ctrlEditDiscName, &m_ctrlSpinDiscName, 0);
}

void CCSVDlg::OnCheckDiscnumber() 
{
	updateCheckEditSpin(UCES_CHECK, &m_ctrlCheckDiscNumber, &m_ctrlEditDiscNumber, &m_ctrlSpinDiscNumber, 0);
}

void CCSVDlg::OnCheckDiscshortname() 
{
	updateCheckEditSpin(UCES_CHECK, &m_ctrlCheckDiscShortName, &m_ctrlEditDiscShortName, &m_ctrlSpinDiscShortName, 0);
}

void CCSVDlg::OnCheckDiscsortasname() 
{
	updateCheckEditSpin(UCES_CHECK, &m_ctrlCheckDiscSortAsName, &m_ctrlEditDiscSortAsName, &m_ctrlSpinDiscSortAsName, 0);
}

void CCSVDlg::OnCheckListname() 
{
	updateCheckEditSpin(UCES_CHECK, &m_ctrlCheckListName, &m_ctrlEditListName, &m_ctrlSpinListName, 0);
}

void CCSVDlg::OnCheckSndevname() 
{
	updateCheckEditSpin(UCES_CHECK, &m_ctrlCheckSNDevName, &m_ctrlEditSNDevName, &m_ctrlSpinSNDevName, 0);
}

void CCSVDlg::OnCheckTrackname() 
{
	updateCheckEditSpin(UCES_CHECK, &m_ctrlCheckTrackName, &m_ctrlEditTrackName, &m_ctrlSpinTrackName, 0);
}

void CCSVDlg::OnCheckTracknumber() 
{
	updateCheckEditSpin(UCES_CHECK, &m_ctrlCheckTrackNumber, &m_ctrlEditTrackNumber, &m_ctrlSpinTrackNumber, 0);
}

void CCSVDlg::OnChangeEditArtistname() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CSuckLessDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	updateCheckEditSpin(UCES_EDIT, &m_ctrlCheckArtistName, &m_ctrlEditArtistName, &m_ctrlSpinArtistName, 0);
}

void CCSVDlg::OnChangeEditArtistshortname() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CSuckLessDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	updateCheckEditSpin(UCES_EDIT, &m_ctrlCheckArtistShortName, &m_ctrlEditArtistShortName, &m_ctrlSpinArtistShortName, 0);
}

void CCSVDlg::OnChangeEditArtistsortasname() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CSuckLessDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	updateCheckEditSpin(UCES_EDIT, &m_ctrlCheckArtistSortAsName, &m_ctrlEditArtistSortAsName, &m_ctrlSpinArtistSortAsName, 0);
}

void CCSVDlg::OnChangeEditDiscname() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CSuckLessDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	updateCheckEditSpin(UCES_EDIT, &m_ctrlCheckDiscName, &m_ctrlEditDiscName, &m_ctrlSpinDiscName, 0);
}

void CCSVDlg::OnChangeEditDiscnumber() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CSuckLessDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	updateCheckEditSpin(UCES_EDIT, &m_ctrlCheckDiscNumber, &m_ctrlEditDiscNumber, &m_ctrlSpinDiscNumber, 0);
}

void CCSVDlg::OnChangeEditDiscshortname() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CSuckLessDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	updateCheckEditSpin(UCES_EDIT, &m_ctrlCheckDiscShortName, &m_ctrlEditDiscShortName, &m_ctrlSpinDiscShortName, 0);
}

void CCSVDlg::OnChangeEditDiscsortasname() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CSuckLessDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	updateCheckEditSpin(UCES_EDIT, &m_ctrlCheckDiscSortAsName, &m_ctrlEditDiscSortAsName, &m_ctrlSpinDiscSortAsName, 0);
}

void CCSVDlg::OnChangeEditListname() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CSuckLessDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	updateCheckEditSpin(UCES_EDIT, &m_ctrlCheckListName, &m_ctrlEditListName, &m_ctrlSpinListName, 0);
}

void CCSVDlg::OnChangeEditSndevname() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CSuckLessDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	updateCheckEditSpin(UCES_EDIT, &m_ctrlCheckSNDevName, &m_ctrlEditSNDevName, &m_ctrlSpinSNDevName, 0);
}

void CCSVDlg::OnChangeEditTrackname() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CSuckLessDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	updateCheckEditSpin(UCES_EDIT, &m_ctrlCheckTrackName, &m_ctrlEditTrackName, &m_ctrlSpinTrackName, 0);
}

void CCSVDlg::OnChangeEditTracknumber() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CSuckLessDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	updateCheckEditSpin(UCES_EDIT, &m_ctrlCheckTrackNumber, &m_ctrlEditTrackNumber, &m_ctrlSpinTrackNumber, 0);
}

void CCSVDlg::saveCSVSettings(bool bCSVMap, bool bRegistry)
{
	if (bCSVMap)
	{
		ZeroMemory(&m_csvMap, sizeof(m_csvMap));
	}

	for (list<SSpinAssoc>::const_iterator asiter = m_listSpinAssoc.begin(); asiter != m_listSpinAssoc.end(); asiter++)
	{
		int nValue = 0;

		if (BST_CHECKED == asiter->m_pCheck->GetCheck())
		{
			CString csEditText;
			asiter->m_pEdit->GetWindowText(csEditText);
			nValue = atoi(csEditText);
		}

		if (bCSVMap)
		{
			(*(asiter->m_pIntCSVMap)) = nValue;
		}

		if (bRegistry)
		{
			if (0 == nValue)
			{
				LeetRegDeleteValue(HKEY_CURRENT_USER, SN_REG_PATH_CSV, asiter->m_szRegValueName);
			}
			else
			{
				DWORD dwValue = nValue;

				LeetRegSetValue(HKEY_CURRENT_USER, SN_REG_PATH_CSV, asiter->m_szRegValueName, REG_DWORD, &dwValue, sizeof(DWORD));
			}
		}
	}
}

bool CCSVDlg::validateCSVMap(void)
{
	bool bResult = false;

	if (0 == m_csvMap.GetMaxCol())
	{
		MessageBox("No columns defined.", "Try again", MB_OK | MB_ICONEXCLAMATION);
	}
	else if (0 != m_csvMap.GetFirstColWithDuplicates())
	{
		CString csMsg;
		csMsg.Format("Column %d defined for multiple fields.", m_csvMap.GetFirstColWithDuplicates());
		MessageBox(csMsg, "Try again", MB_OK | MB_ICONEXCLAMATION);
	}
	else
	{
		bResult = true;
	}

	return(bResult);
}

void CCSVDlg::OnOK() 
{
	saveCSVSettings(true, false); // Save CSV settings to CSV map.

	if (validateCSVMap())
	{
		saveCSVSettings(false, true); // Save CSV settings to registry.

		// Do import / export on a separate thread.
		CPDTCSVDlgGeneric *pThread = new CPDTCSVDlgGeneric(&m_bThreadResult,
														   &m_threadErrorList,
														   &m_threadTError,
														    m_pConfig,
															m_bImport ? CPDTCSVDlgGeneric::IMPORT_CSV : CPDTCSVDlgGeneric::EXPORT_CSV,
															m_strFilename.c_str(),
														   &m_csvMap);

		CProgressDlg *pProgDlg = new CProgressDlg(PROGD_FRAME_NOPROG, false, pThread, this);
		this->openPseudoModalChild(pProgDlg, CProgressDlg::IDD, false, true);
	}
}

void CCSVDlg::OnPseudoModalChildClose(int sldIDD, LPARAM lparam)
{
	if ((CProgressDlg::IDD == sldIDD)			\
	&&	((SLDTHREADID_CSVDLGGENERIC == lparam)
	||	 (SLDTHREADID_CSVDLGPREVIEW == lparam))	)
	{
		if (!m_bThreadResult)
		{
			if (m_threadErrorList.IsEmpty())
			{
				MessageBox(CTypedError::SafeGetFullErrorTextTempBuffer(&m_threadTError), SUPERNUDELIST_ERROR_TITLE, MB_ICONEXCLAMATION);
			}
			else
			{
				CListingDlg *pSLDlg = new CListingDlg(SUPERNUDELIST_ERROR_TITLE,
														CTypedError::SafeGetFullErrorTextTempBuffer(&m_threadTError),
														&m_threadErrorList, false, this);
				this->openPseudoModalChild(pSLDlg, CListingDlg::IDD, false, true);
			}
		}
		else if (SLDTHREADID_CSVDLGGENERIC == lparam)
		{
			CSuckLessDialog::OnOK();
		}
		else if (SLDTHREADID_CSVDLGPREVIEW == lparam)
		{
			updatePreview();
		}
	}
	else if (CListingDlg::IDD == sldIDD)
	{
		m_threadErrorList.RemoveAll();
	}
}

void CCSVDlg::updatePreview(void)
{
	if (NULL != m_pCSVPreviewFile)
	{
		CListCtrl *pListCtrl = m_bImport ? &m_ctrlListTop : &m_ctrlListBottom;

		// Clear it out...

		pListCtrl->DeleteAllItems();
		int nColumnCount = pListCtrl->GetHeaderCtrl()->GetItemCount();
		for (int i = 0; i < nColumnCount; i++)
		{
		   pListCtrl->DeleteColumn(0);
		}

		// Setup the new columns

		nColumnCount = m_pCSVPreviewFile->GetNumColumns();

		CString csTitle;

		for (/*int*/ i = 0; i < nColumnCount; i++)
		{
			csTitle.Format("#%d", (i+1));

			pListCtrl->InsertColumn(i, csTitle);
		}


		// Add each line to the list control...

		int idx = 0;

		if (0 < nColumnCount)
		{
			string strLabel;

			for (CCSVFile::const_lineIter liter = m_pCSVPreviewFile->Begin(); liter != m_pCSVPreviewFile->End(); liter++)
			{
				strLabel = m_pCSVPreviewFile->GetLineColumn(liter, 0);

				int insIdx = pListCtrl->InsertItem(idx++, strLabel.c_str());

				if ((-1) != insIdx)
				{
					for (int i = 1; i < nColumnCount; i++)
					{
						strLabel = m_pCSVPreviewFile->GetLineColumn(liter, i);

						if (!pListCtrl->SetItemText(insIdx, i, strLabel.c_str()))
						{
							break;
						}
					}
				}
			}
		}

		// Resize the columns.

		for (/*int*/ i = 0; i < nColumnCount; i++)
		{
			pListCtrl->SetColumnWidth(i,	LVSCW_AUTOSIZE_USEHEADER);
		}

		// Delete the CCSVFile since we don't need it anymore.
		delete m_pCSVPreviewFile;
		m_pCSVPreviewFile = NULL;

		// Don't waste time re-making previews of the input.
		if (m_bImport)
		{
			m_bInputPreviewDone = true;
		}
	}

	if (NULL != m_pCSVPreviewData)
	{
		CListCtrl *pListCtrl = m_bImport ? &m_ctrlListBottom : &m_ctrlListTop;

		// Clear it out...

		pListCtrl->DeleteAllItems();
		int nColumnCount = pListCtrl->GetHeaderCtrl()->GetItemCount();
		for (int i = 0; i < nColumnCount; i++)
		{
		   pListCtrl->DeleteColumn(0);
		}

		// Setup the new columns

		nColumnCount = m_pCSVPreviewData->GetNumColumns();

		/*int*/ i = 0;
		for (list<string>::const_iterator titleLiter = m_listDataPreviewColumnTitles.begin(); titleLiter != m_listDataPreviewColumnTitles.end(); titleLiter++)
		{
			pListCtrl->InsertColumn(i++, titleLiter->c_str());
		}

		// Add each line to the list control...

		int idx = 0;

		if (0 < nColumnCount)
		{
			string strLabel;

			for (CCSVFile::const_lineIter liter = m_pCSVPreviewData->Begin(); liter != m_pCSVPreviewData->End(); liter++)
			{
				strLabel = m_pCSVPreviewData->GetLineColumn(liter, 0);

				int insIdx = pListCtrl->InsertItem(idx++, strLabel.c_str());

				if ((-1) != insIdx)
				{
					for (int i = 1; i < nColumnCount; i++)
					{
						strLabel = m_pCSVPreviewData->GetLineColumn(liter, i);

						if (!pListCtrl->SetItemText(insIdx, i, strLabel.c_str()))
						{
							break;
						}
					}
				}
			}
		}

		// Resize the columns.

		for (/*int*/ i = 0; i < nColumnCount; i++)
		{
			pListCtrl->SetColumnWidth(i,	LVSCW_AUTOSIZE_USEHEADER);
		}

		// Delete the CCSVFile since we don't need it anymore.
		delete m_pCSVPreviewData;
		m_pCSVPreviewData = NULL;

		// Don't waste time re-making previews of the input.
		if (!m_bImport)
		{
			m_bInputPreviewDone = true;
		}
	}
}

void CCSVDlg::OnSizeHookEnd(void)
{
	if (m_bInitDone)
	{
		CHeaderCtrl *pHeaderCtrl;

		if (NULL != (pHeaderCtrl = m_ctrlListTop.GetHeaderCtrl()))
		{
			int headItems = pHeaderCtrl->GetItemCount();

			if (0 != headItems)
			{
				m_ctrlListTop.SetColumnWidth(headItems - 1, LVSCW_AUTOSIZE_USEHEADER);
			}
		}

		if (NULL != (pHeaderCtrl = m_ctrlListBottom.GetHeaderCtrl()))
		{
			int headItems = pHeaderCtrl->GetItemCount();

			if (0 != headItems)
			{
				m_ctrlListBottom.SetColumnWidth(headItems - 1, LVSCW_AUTOSIZE_USEHEADER);
			}
		}
	}
}

void CCSVDlg::OnButtonPreview() 
{
	saveCSVSettings(true, false); // Save CSV settings to CSV map.

	if (validateCSVMap())
	{
		// Generate preview on a separate thread.
		CPDTCSVDlgPreview *pThread = new CPDTCSVDlgPreview(&m_bThreadResult,
														   &m_threadErrorList,
														   &m_threadTError,
															m_pConfig,
															m_bImport ? CPDTCSVDlgPreview::IMPORT_CSV : CPDTCSVDlgPreview::EXPORT_CSV,
															m_strFilename.c_str(),
														   &m_csvMap,
														   &m_csvMapForDataPreview,
															(  m_bImport  && m_bInputPreviewDone) ? NULL : &m_pCSVPreviewFile,
															((!m_bImport) && m_bInputPreviewDone) ? NULL : &m_pCSVPreviewData);

		CProgressDlg *pProgDlg = new CProgressDlg(PROGD_FRAME_NOPROG, false, pThread, this);
		this->openPseudoModalChild(pProgDlg, CProgressDlg::IDD, false, true);
	}
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

CPDTCSVDlgGeneric::CPDTCSVDlgGeneric(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
											CSNConfig *pConfig, OP_TYPE opType, const char *szFilename,
											const SSNCSVMap *pCSVMap)
: CProgressDlgThread()
{
	m_pbThreadResult = pbThreadResult;
	m_pStrLstLog = pStrLstLog;
	m_pThreadTError = pThreadTError;

	m_pConfig = pConfig;

	m_opType = opType;

	m_strFilename = szFilename;

	m_pCSVMap = pCSVMap;
}

CPDTCSVDlgGeneric::~CPDTCSVDlgGeneric(void)
{
}

// Overriden to provide functionality.
void CPDTCSVDlgGeneric::mainThreadSubClass(void)
{
	(*m_pbThreadResult) = false;
	CTypedError::SafeReset(m_pThreadTError);
	m_pStrLstLog->RemoveAll();

	if (IMPORT_CSV == m_opType)
	{
		SetProgressTitle("Importing from CSV...");

		SetProgressHeading("Reading CSV file");
		SetProgressMessage("");

		CCSVFile *pCSVFile = new CCSVFile(m_strFilename.c_str());

		if (pCSVFile->LoadFromFile(m_pThreadTError, m_strFilename.c_str()))
		{
			SetProgressHeading("Adding data from CSV file");

			CSNCSVLine csvLine(m_pCSVMap);

			if (m_pConfig->GetLibrary()->BuildFromCSVFile(m_pThreadTError, &csvLine, pCSVFile))
			{
				SetProgressHeading("Resolving players");

				set<CSNDisc *> *pSetDiscsWithUnresolvedDevices = m_pConfig->ResolveDevices();

				delete pSetDiscsWithUnresolvedDevices;
				pSetDiscsWithUnresolvedDevices = NULL;

				(*m_pbThreadResult) = true;
			}
		}

		delete pCSVFile;
		pCSVFile = NULL;
	}
	else if (EXPORT_CSV == m_opType)
	{
		SetProgressTitle("Exporting to CSV...");

		SetProgressHeading("Generating CSV file");
		SetProgressMessage("");

		CCSVFile *pCSVFile = new CCSVFile(m_pCSVMap->GetMaxCol());
		CSNCSVLine csvLine(m_pCSVMap);

		m_pConfig->GetLibrary()->AddToCSVFile(&csvLine, pCSVFile);

		SetProgressHeading("Saving CSV file");

		if (pCSVFile->SaveToFile(m_pThreadTError, m_strFilename.c_str()))
		{
			(*m_pbThreadResult) = true;
		}

		delete pCSVFile;
		pCSVFile = NULL;
	}
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

CPDTCSVDlgPreview::CPDTCSVDlgPreview(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
									 const CSNConfig *pConfig, OP_TYPE opType, const char *szFilename,
									 const SSNCSVMap *pCSVMapFile, const SSNCSVMap *pCSVMapData,
									 CCSVFile **ppCSVFile, CCSVFile **ppCSVData)
: CProgressDlgThread()
{
	m_pbThreadResult = pbThreadResult;
	m_pStrLstLog = pStrLstLog;
	m_pThreadTError = pThreadTError;

	m_pConfig = pConfig;

	m_opType = opType;

	m_strFilename = szFilename;

	m_pCSVMapFile = pCSVMapFile;
	m_pCSVMapData = pCSVMapData;

	m_ppCSVFile = ppCSVFile;
	m_ppCSVData = ppCSVData;
}

CPDTCSVDlgPreview::~CPDTCSVDlgPreview(void)
{
}

// Overriden to provide functionality.
void CPDTCSVDlgPreview::mainThreadSubClass(void)
{
	(*m_pbThreadResult) = false;
	CTypedError::SafeReset(m_pThreadTError);
	m_pStrLstLog->RemoveAll();

	SetProgressTitle("Generting preview...");

	(*m_pbThreadResult) = true;

	if (NULL != m_ppCSVFile)
	{
		delete (*m_ppCSVFile);
		(*m_ppCSVFile) = NULL;
	}

	if (NULL != m_ppCSVData)
	{
		delete (*m_ppCSVData);
		(*m_ppCSVData) = NULL;
	}

	if (IMPORT_CSV == m_opType)
	{
		CCSVFile *pCSFFileLocalOnly = NULL;
		CCSVFile **ppCSVFile = ((NULL != m_ppCSVFile) || (NULL == m_ppCSVData)) ? m_ppCSVFile : &pCSFFileLocalOnly;

		if (NULL != ppCSVFile)
		{
			SetProgressHeading("Reading CSV file");
			SetProgressMessage("");

			(*ppCSVFile) = new CCSVFile(m_strFilename.c_str());

			if (!(*ppCSVFile)->LoadFromFile(m_pThreadTError, m_strFilename.c_str()))
			{
				(*m_pbThreadResult) = false;

				delete (*ppCSVFile);
				(*ppCSVFile) = NULL;
			}
			else if (NULL != m_ppCSVData)
			{
				SetProgressHeading("Generating data");
				SetProgressMessage("");

				CSNCSVLine csvLine(m_pCSVMapFile);

				CSNLibrary library;

				if (!library.BuildFromCSVFile(m_pThreadTError, &csvLine, *ppCSVFile))
				{
					(*m_pbThreadResult) = false;
				}
				else
				{
					(*m_ppCSVData) = new CCSVFile(m_pCSVMapData->GetMaxCol());
					CSNCSVLine csvLine(m_pCSVMapData);
					
					library.AddToCSVFile(&csvLine, *m_ppCSVData);
				}
			}
		}

		delete pCSFFileLocalOnly;
		pCSFFileLocalOnly = NULL;
	}
	else if (EXPORT_CSV == m_opType)
	{
		if (NULL != m_ppCSVData)
		{
			SetProgressHeading("Generating data");
			SetProgressMessage("");

			(*m_ppCSVData) = new CCSVFile(m_pCSVMapData->GetMaxCol());
			CSNCSVLine csvLine(m_pCSVMapData);

			m_pConfig->GetLibrary()->AddToCSVFile(&csvLine, *m_ppCSVData);
		}

		if (NULL != m_ppCSVFile)
		{
			SetProgressHeading("Generating CSV");
			SetProgressMessage("");

			(*m_ppCSVFile) = new CCSVFile(m_pCSVMapFile->GetMaxCol());
			CSNCSVLine csvLine(m_pCSVMapFile);

			m_pConfig->GetLibrary()->AddToCSVFile(&csvLine, *m_ppCSVFile);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

