#if !defined(AFX_CSVDLG_H__6180FBA7_A2A9_4DB2_AB92_D1D79BB35530__INCLUDED_)
#define AFX_CSVDLG_H__6180FBA7_A2A9_4DB2_AB92_D1D79BB35530__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CSVDlg.h : header file
//

#include "SuckLessDialog.h"
#include "ProgressDlg.h"
#include "SNCSVLine.h"

class CSNConfig;

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

class CCSVDlg : public CSuckLessDialog
{
// Construction
public:
	CCSVDlg(bool bImport, CSNConfig *pConfig, const char *szFilename, CWnd* pParent);

	~CCSVDlg();

	enum
	{
		MAX_CSV_COLUMNS = 99 // Completely arbitrary.
	};

	enum UCES_UPDATED
	{
		UCES_NONE,
		UCES_CHECK,
		UCES_EDIT,
		UCES_SPIN
	};

// Dialog Data
	//{{AFX_DATA(CCSVDlg)
	enum { IDD = IDD_CSV_DIALOG };
	CStatic	m_ctrlStaticPreviewTop;
	CStatic	m_ctrlStaticPreviewBottom;
	CListCtrl	m_ctrlListBottom;
	CListCtrl	m_ctrlListTop;
	CButton	m_ctrlCheckListName;
	CEdit	m_ctrlEditListName;
	CSpinButtonCtrl m_ctrlSpinListName;
	CButton	m_ctrlCheckSNDevName;
	CEdit	m_ctrlEditSNDevName;
	CSpinButtonCtrl m_ctrlSpinSNDevName;
	CButton	m_ctrlCheckArtistName;
	CEdit	m_ctrlEditArtistName;
	CSpinButtonCtrl m_ctrlSpinArtistName;
	CButton	m_ctrlCheckArtistShortName;
	CEdit	m_ctrlEditArtistShortName;
	CSpinButtonCtrl m_ctrlSpinArtistShortName;
	CButton	m_ctrlCheckArtistSortAsName;
	CEdit	m_ctrlEditArtistSortAsName;
	CSpinButtonCtrl m_ctrlSpinArtistSortAsName;
	CButton	m_ctrlCheckDiscNumber;
	CEdit	m_ctrlEditDiscNumber;
	CSpinButtonCtrl m_ctrlSpinDiscNumber;
	CButton	m_ctrlCheckDiscName;
	CEdit	m_ctrlEditDiscName;
	CSpinButtonCtrl m_ctrlSpinDiscName;
	CButton	m_ctrlCheckDiscShortName;
	CEdit	m_ctrlEditDiscShortName;
	CSpinButtonCtrl m_ctrlSpinDiscShortName;
	CButton	m_ctrlCheckDiscSortAsName;
	CEdit	m_ctrlEditDiscSortAsName;
	CSpinButtonCtrl m_ctrlSpinDiscSortAsName;
	CButton	m_ctrlCheckTrackNumber;
	CEdit	m_ctrlEditTrackNumber;
	CSpinButtonCtrl m_ctrlSpinTrackNumber;
	CButton	m_ctrlCheckTrackName;
	CEdit	m_ctrlEditTrackName;
	CSpinButtonCtrl m_ctrlSpinTrackName;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCSVDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	struct SSpinAssoc
	{
		CButton			*m_pCheck;
		CEdit			*m_pEdit;
		CSpinButtonCtrl	*m_pSpin;
		const char		*m_szRegValueName;
		int				*m_pIntCSVMap;

		SSpinAssoc(CButton *pCheck, CEdit *pEdit, CSpinButtonCtrl *pSpin, const char *szRegValueName, int *pIntCSVMap)
			: m_pCheck(pCheck), m_pEdit(pEdit), m_pSpin(pSpin), m_szRegValueName(szRegValueName), m_pIntCSVMap(pIntCSVMap)
		{
		}
	};

	list<SSpinAssoc> m_listSpinAssoc;

	bool m_bThreadResult;
	CTypedError m_threadTError;
	CStringList m_threadErrorList;

	bool m_bImport; // Import or Export?
	CSNConfig *m_pConfig;
	string m_strFilename;

	// nNewSpinPos ignored unless updated is UCES_SPIN or UCES_NONE
	bool m_bUpdatingCheckEditSpin;

	bool m_bInputPreviewDone;
	CCSVFile *m_pCSVPreviewFile;
	CCSVFile *m_pCSVPreviewData;

	bool m_bInitDone;

	SSNCSVMap m_csvMap;
	SSNCSVMap m_csvMapForDataPreview;
	list<string> m_listDataPreviewColumnTitles;

protected:

	// nNewSpinPos ignored unless updated==UCES_SPIN
	void updateCheckEditSpin(UCES_UPDATED updated, CButton *pCheck, CEdit *pEdit, CSpinButtonCtrl *pSpin, int nNewSpinPos);

	void saveCSVSettings(bool bCSVMap, bool bRegistry);

	bool validateCSVMap(void);

	void updatePreview(void);

	// SuckLessDialog:
	void virtual OnPseudoModalChildClose(int sldIDD, LPARAM lparam);
	void OnSizeHookEnd(void);

protected:

	// Generated message map functions
	//{{AFX_MSG(CCSVDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnCheckArtistname();
	afx_msg void OnCheckArtistshortname();
	afx_msg void OnCheckArtistsortasname();
	afx_msg void OnCheckDiscname();
	afx_msg void OnCheckDiscnumber();
	afx_msg void OnCheckDiscshortname();
	afx_msg void OnCheckDiscsortasname();
	afx_msg void OnCheckListname();
	afx_msg void OnCheckSndevname();
	afx_msg void OnCheckTrackname();
	afx_msg void OnCheckTracknumber();
	afx_msg void OnChangeEditArtistname();
	afx_msg void OnChangeEditArtistshortname();
	afx_msg void OnChangeEditArtistsortasname();
	afx_msg void OnChangeEditDiscname();
	afx_msg void OnChangeEditDiscnumber();
	afx_msg void OnChangeEditDiscshortname();
	afx_msg void OnChangeEditDiscsortasname();
	afx_msg void OnChangeEditListname();
	afx_msg void OnChangeEditSndevname();
	afx_msg void OnChangeEditTrackname();
	afx_msg void OnChangeEditTracknumber();
	virtual void OnOK();
	afx_msg void OnButtonPreview();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

class CPDTCSVDlgGeneric : public CProgressDlgThread
{
public:
	enum OP_TYPE
	{
		NO_OP,
		IMPORT_CSV,
		EXPORT_CSV
	};

public:
	CPDTCSVDlgGeneric(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
						 CSNConfig *pConfig, OP_TYPE opType, const char *szFilename,
						 const SSNCSVMap *pCSVMap);
	virtual ~CPDTCSVDlgGeneric(void);

	int GetIdent(void)
	{
		return(SLDTHREADID_CSVDLGGENERIC);
	}

protected:
	bool *m_pbThreadResult;
	CStringList *m_pStrLstLog;
	CTypedError *m_pThreadTError;

	CSNConfig *m_pConfig;

	OP_TYPE m_opType;
	string m_strFilename;

	const SSNCSVMap *m_pCSVMap;

	void mainThreadSubClass(void);
};

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

class CPDTCSVDlgPreview : public CProgressDlgThread
{
public:
	enum OP_TYPE
	{
		NO_OP,
		IMPORT_CSV,
		EXPORT_CSV
	};

public:
	CPDTCSVDlgPreview(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
						 const CSNConfig *pConfig, OP_TYPE opType, const char *szFilename,
						 const SSNCSVMap *pCSVMapFile, const SSNCSVMap *pCSVMapData,
						 CCSVFile **ppCSVFile, CCSVFile **ppCSVData);
	virtual ~CPDTCSVDlgPreview(void);

	int GetIdent(void)
	{
		return(SLDTHREADID_CSVDLGPREVIEW);
	}

protected:
	bool *m_pbThreadResult;
	CStringList *m_pStrLstLog;
	CTypedError *m_pThreadTError;

	const CSNConfig *m_pConfig;

	OP_TYPE m_opType;
	string m_strFilename;

	const SSNCSVMap *m_pCSVMapFile;
	const SSNCSVMap *m_pCSVMapData;

	CCSVFile **m_ppCSVFile;
	CCSVFile **m_ppCSVData;

	void mainThreadSubClass(void);
};

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CSVDLG_H__6180FBA7_A2A9_4DB2_AB92_D1D79BB35530__INCLUDED_)
