// CSVFile.h: interface for the CCSVFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CSVFILE_H__79A0C45E_939F_4B79_B576_0505E54C8DE5__INCLUDED_)
#define AFX_CSVFILE_H__79A0C45E_939F_4B79_B576_0505E54C8DE5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CCSVFile
{
public:

	typedef list< vector<string> >::iterator lineIter;
	typedef list< vector<string> >::const_iterator const_lineIter;

public:
	CCSVFile(int numColumns);
	CCSVFile(const char *szFilename); // Reads first non-empty line to get numColumns
	virtual ~CCSVFile();

	int GetNumColumns(void) const;

	const_lineIter Begin(void) const;
	const_lineIter End(void) const;
	string GetLineColumn(const_lineIter line, int column) const;

	lineIter Begin(void);
	lineIter End(void);
	lineIter NewLine(void);
	void SetLineColumn(lineIter line, int column, const char *value);

	bool LoadFromFile(CTypedError *pTError, const char *filename);
	bool SaveToFile(CTypedError *pTError, const char *filename);

protected:
	int m_numColumns;
	list< vector<string> > m_lines;

protected:
	bool lineToFile(CTypedError *pTError, FILE *pFile, vector<string>&line);
	static string escapeColStr(const string colStr);
};

#endif // !defined(AFX_CSVFILE_H__79A0C45E_939F_4B79_B576_0505E54C8DE5__INCLUDED_)
