// DevResDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DevResDlg.h"
#include "SNVolume.h"
#include "SNDevice.h"
#include "SNConfig.h"
#include "DeviceAddDlg.h"
#include "CCFWrapper.h"
#include "ListingDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDevResDlg dialog


CDevResDlg::CDevResDlg(CSNConfig *pConfig, CCCFWrapper *pCCFWrapper, set<CSNDisc *> *pDiscSet, bool *pbDevResSuccess, CWnd* pParent)
	: CSuckLessDialog(CDevResDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDevResDlg)
	m_staticIntro = _T("");
	m_staticRemaining = _T("");
	//}}AFX_DATA_INIT

	m_pConfig = pConfig;
	m_pCCFWrapper = pCCFWrapper;
	m_pDiscSet = pDiscSet;

	m_pNewestDevice = NULL;
	m_bInitDone = false;

	m_pbDevResSuccess = pbDevResSuccess;
}

void CDevResDlg::DoDataExchange(CDataExchange* pDX)
{
	CSuckLessDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDevResDlg)
	DDX_Control(pDX, IDOK, m_buttonOK);
	DDX_Control(pDX, IDC_RADIO_DEVICE, m_ctrlRadioDevice);
	DDX_Control(pDX, IDC_RADIO_DELETE, m_ctrlRadioDelete);
	DDX_Control(pDX, IDCANCEL, m_ctrlCancel);
	DDX_Control(pDX, IDC_COMBO_DEVICE, m_ctrlComboBoxDevices);
	DDX_Control(pDX, IDC_LIST, m_ctrlListCtrl);
	DDX_Text(pDX, IDC_STATIC_INTRO, m_staticIntro);
	DDX_Text(pDX, IDC_STATIC_REMAINING, m_staticRemaining);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDevResDlg, CSuckLessDialog)
	//{{AFX_MSG_MAP(CDevResDlg)
	ON_BN_CLICKED(IDC_BUTTON_ALL, OnButtonAll)
	ON_BN_CLICKED(IDC_BUTTON_NONE, OnButtonNone)
	ON_BN_CLICKED(IDC_BUTTON_NEWDEVICE, OnButtonNewdevice)
	ON_BN_CLICKED(IDC_RADIO_DELETE, OnRadioDelete)
	ON_BN_CLICKED(IDC_RADIO_DEVICE, OnRadioDevice)
	ON_CBN_SELCHANGE(IDC_COMBO_DEVICE, OnSelchangeComboDevice)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDevResDlg message handlers

BOOL CDevResDlg::OnInitDialog() 
{
	CSuckLessDialog::OnInitDialog();
	
	UpdateData(TRUE);

	this->setWindowIcon(IDR_MAINFRAME);

	// -- Initial contents --

	if (NULL != g_pProntoFont)
	{
		m_ctrlListCtrl.SetFont(g_pProntoFont);
		m_ctrlComboBoxDevices.SetFont(g_pProntoFont);
	}

	m_ctrlListCtrl.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_SUBITEMIMAGES);
	m_ctrlListCtrl.InsertColumn(LIST_COL_LIST,		"List");
	m_ctrlListCtrl.InsertColumn(LIST_COL_ARTIST,	"Artist");
	m_ctrlListCtrl.InsertColumn(LIST_COL_DISC,		"Disc");
	m_ctrlListCtrl.InsertColumn(LIST_COL_DEVICE,	"Player");
	m_ctrlListCtrl.InsertColumn(LIST_COL_NUMBER,	"Number", LVCFMT_RIGHT);
	m_ctrlListCtrl.InsertColumn(LIST_COL_DUMMY,		"");

	m_ctrlListCtrl.NudelSortSetCallbackColumn(LIST_COL_ARTIST, nudelSLSortCallbackArtistColumn, NULL);
	m_ctrlListCtrl.NudelSortSetCallbackColumn(LIST_COL_DISC, nudelSLSortCallbackDiscColumn, NULL);
	m_ctrlListCtrl.NudelSortSetNumberColumn(LIST_COL_NUMBER);

	m_ctrlListImageList.Create(16, 16, ILC_MASK, 0, 3);
	m_ctrlListImageList.Add(AfxGetApp()->LoadIcon(IDI_ICON_LIST));
	m_ctrlListImageList.Add(AfxGetApp()->LoadIcon(IDI_ICON_FACE));
	m_ctrlListImageList.Add(AfxGetApp()->LoadIcon(IDI_ICON_CD));
	m_ctrlListCtrl.SetImageList(&m_ctrlListImageList, LVSIL_SMALL);

	populateList();
	populateDeviceCombo();

	// -- Control setup --

	addControlInfo(IDC_STATIC_INTRO);

	addControlInfo(IDC_STATIC_DISCS);
	addControlInfo(IDC_LIST);
	addControlInfo(IDC_BUTTON_ALL);
	addControlInfo(IDC_BUTTON_NONE);

	addControlInfo(IDC_STATIC_ACTION);
	addControlInfo(IDC_RADIO_DEVICE);
	addControlInfo(IDC_RADIO_DELETE);
	addControlInfo(IDC_COMBO_DEVICE);
	addControlInfo(IDC_BUTTON_NEWDEVICE);

	addControlInfo(IDC_STATIC_REMAINING);

	addControlInfo(IDC_BUTTON_HELP);

	addControlInfo(IDOK);
	addControlInfo(IDCANCEL);

	setControlRelationship(IDC_STATIC_INTRO,			IDD, CControlInfo::ACOMMON_TOP_RESIZEWIDTH);

	setControlRelationship(IDC_STATIC_DISCS,			IDD, CControlInfo::ACOMMON_RESIZEHEIGHT_RESIZEWIDTH);
	setControlRelationship(IDC_LIST,					IDD, CControlInfo::ACOMMON_RESIZEHEIGHT_RESIZEWIDTH);
	setControlRelationship(IDC_BUTTON_ALL,				IDD, CControlInfo::ACOMMON_TOP_RIGHT);
	setControlRelationship(IDC_BUTTON_NONE,				IDD, CControlInfo::ACOMMON_TOP_RIGHT);

	setControlRelationship(IDC_STATIC_ACTION,			IDD, CControlInfo::ACOMMON_BOTTOM_RESIZEWIDTH);
	setControlRelationship(IDC_RADIO_DEVICE,			IDD, CControlInfo::ACOMMON_BOTTOM_LEFT);
	setControlRelationship(IDC_RADIO_DELETE,			IDD, CControlInfo::ACOMMON_BOTTOM_LEFT);
	setControlRelationship(IDC_COMBO_DEVICE,			IDD, CControlInfo::ACOMMON_BOTTOM_RESIZEWIDTH);
	setControlRelationship(IDC_BUTTON_NEWDEVICE,		IDD, CControlInfo::ACOMMON_BOTTOM_RIGHT);

	setControlRelationship(IDC_STATIC_REMAINING,		IDD, CControlInfo::ACOMMON_BOTTOM_RESIZEWIDTH);

	setControlRelationship(IDC_BUTTON_HELP,				IDD, CControlInfo::ACOMMON_BOTTOM_LEFT);

	setControlRelationship(IDOK,						IDD, CControlInfo::ACOMMON_BOTTOM_RIGHT);
	setControlRelationship(IDCANCEL,					IDD, CControlInfo::ACOMMON_BOTTOM_RIGHT);

	controlAndFrameInfoIsSetup();

	setMinXToCurrent();
	setMinYToCurrent();

	m_bInitDone = true;

	UpdateData(FALSE);

	this->setRememberWindowPosition(SN_REG_PATH_WINDOWPOS, SN_REG_VALUE_WINDOWPOS_DEVRES);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDevResDlg::populateList(void)
{
	if (1 == m_pDiscSet->size())
	{
		m_staticIntro = "The disc listed below is not associated "
						"with a player. It must be "
						"associated with a player or deleted.";
	}
	else
	{
		m_staticIntro = "The discs listed below are not associated "
						"with players. They must be "
						"associated with players or deleted.";
	}

	m_staticRemaining.Format("%d unresolved remaining.", (int)(m_pDiscSet->size()));

	UpdateData(FALSE);

	m_ctrlListCtrl.DeleteAllItems();

	int idx = 0;

	for (set<CSNDisc *>::iterator setIter = m_pDiscSet->begin();
		 setIter != m_pDiscSet->end();
		 setIter++)
	{
		int insIdx = m_ctrlListCtrl.InsertItem(idx++, (*setIter)->GetParent()->GetParent()->GetName()->GetPronto(true));

		CString numStr;
		numStr.Format("%d", (*setIter)->GetDiscNumber());

		CString deviceName;

		if (NULL != (*setIter)->GetDevice())
		{
			deviceName = (*setIter)->GetDevice()->GetName()->GetPronto(true);
		}
		else
		{
			deviceName = (*setIter)->GetUnresolvedDeviceName()->GetPronto(true);

			if (!deviceName.IsEmpty())
			{
				deviceName += " (Non-existent)";
			}
		}

		if (((-1) == insIdx) \
		||	(!m_ctrlListCtrl.SetItemText(insIdx, LIST_COL_ARTIST,	(*setIter)->GetParent()->GetName()->GetPronto(true))) \
		||	(!m_ctrlListCtrl.SetItemText(insIdx, LIST_COL_DISC, (*setIter)->GetName()->GetPronto(true))) \
		||	(!m_ctrlListCtrl.SetItemText(insIdx, LIST_COL_DEVICE, deviceName)) \
		||	(!m_ctrlListCtrl.SetItemText(insIdx, LIST_COL_NUMBER, numStr)) )
		{
			MessageBox("Error populating list", SUPERNUDELIST_ERROR_TITLE, MB_ICONSTOP|MB_OK);
			break;
		}
		else
		{
			m_ctrlListCtrl.SetItemData(insIdx, (DWORD)(*setIter));

			m_ctrlListCtrl.SetItem(insIdx, LIST_COL_LIST,	LVIF_IMAGE, NULL, ILIDX_LIST,	0, 0, 0);
			m_ctrlListCtrl.SetItem(insIdx, LIST_COL_ARTIST,	LVIF_IMAGE, NULL, ILIDX_ARTIST,	0, 0, 0);
			m_ctrlListCtrl.SetItem(insIdx, LIST_COL_DISC,	LVIF_IMAGE, NULL, ILIDX_DISC,	0, 0, 0);

		}
	}

	m_ctrlListCtrl.SetColumnWidth(LIST_COL_LIST,	LVSCW_AUTOSIZE_USEHEADER);
	m_ctrlListCtrl.SetColumnWidth(LIST_COL_ARTIST,	LVSCW_AUTOSIZE_USEHEADER);
	m_ctrlListCtrl.SetColumnWidth(LIST_COL_DISC,	LVSCW_AUTOSIZE_USEHEADER);
	m_ctrlListCtrl.SetColumnWidth(LIST_COL_DEVICE,	LVSCW_AUTOSIZE_USEHEADER);
	m_ctrlListCtrl.SetColumnWidth(LIST_COL_NUMBER,	LVSCW_AUTOSIZE_USEHEADER);
	m_ctrlListCtrl.SetColumnWidth(LIST_COL_DUMMY,	LVSCW_AUTOSIZE_USEHEADER);

	m_ctrlListCtrl.SortItemsNudel(LIST_COL_LIST, false);
}

void CDevResDlg::populateDeviceCombo(void)
{
	m_ctrlComboBoxDevices.ResetContent();

	for (const CSNDevice *pDevice = m_pConfig->GetDevices()->GetFirst();
		 NULL != pDevice;
		 pDevice = m_pConfig->GetDevices()->GetNext(pDevice))
	{
		int insIdx = m_ctrlComboBoxDevices.InsertString(-1, pDevice->GetName()->GetPronto(true));

		if ((0 > insIdx) \
		||	(CB_ERR == m_ctrlComboBoxDevices.SetItemDataPtr(insIdx, (void *)pDevice)))
		{
			MessageBox("Population of GUI failed (player list)",
					   SUPERNUDELIST_ERROR_TITLE,
					   MB_OK | MB_ICONSTOP);
			break;
		}
		else if (pDevice == m_pNewestDevice)
		{
			m_ctrlComboBoxDevices.SetCurSel(insIdx);
		}
	}

	if ((NULL == m_pNewestDevice) \
	&&	(1 <= m_ctrlComboBoxDevices.GetCount()))
	{
		m_ctrlComboBoxDevices.SetCurSel(0);
	}
}

int CALLBACK CDevResDlg::nudelSLSortCallbackArtistColumn(CSortableListCtrl *pList,
															LPARAM lParam1, LPARAM lParam2,
															int idx1, int idx2, void *pVoid)
{
	const CSNDisc *disc1 = (const CSNDisc *)lParam1;
	const CSNDisc *disc2 = (const CSNDisc *)lParam2;

	return(disc1->GetParent()->CompareForSort(disc2->GetParent()));
}

int CALLBACK CDevResDlg::nudelSLSortCallbackDiscColumn(CSortableListCtrl *pList,
															LPARAM lParam1, LPARAM lParam2,
															int idx1, int idx2, void *pVoid)
{
	const CSNDisc *disc1 = (const CSNDisc *)lParam1;
	const CSNDisc *disc2 = (const CSNDisc *)lParam2;

	return(disc1->CompareForSort(disc2));
}

void CDevResDlg::OnSizeHookEnd(void)
{
	if (m_bInitDone)
	{
		CHeaderCtrl *pHeaderCtrl;

		if (NULL != (pHeaderCtrl = m_ctrlListCtrl.GetHeaderCtrl()))
		{
			int headItems = pHeaderCtrl->GetItemCount();

			if (0 != headItems)
			{
				m_ctrlListCtrl.SetColumnWidth(headItems - 1, LVSCW_AUTOSIZE_USEHEADER);
			}
		}
	}
}

void CDevResDlg::OnButtonAll()
{
	for (int i = 0; i < m_ctrlListCtrl.GetItemCount(); i++)
	{
		m_ctrlListCtrl.SetItemState(i, LVIS_SELECTED, LVIS_SELECTED);
	}
}

void CDevResDlg::OnButtonNone()
{
	for (int i = 0; i < m_ctrlListCtrl.GetItemCount(); i++)
	{
		m_ctrlListCtrl.SetItemState(i, 0, LVIS_SELECTED);
	}
}

void CDevResDlg::OnButtonNewdevice()
{
	m_pNewestDevice = NULL;

	CDeviceAddDlg *pSLDlg = new CDeviceAddDlg(m_pConfig->GetDevices(),
								m_pCCFWrapper->GetCSFAbstractTree(), &m_pNewestDevice, this);
	this->openPseudoModalChild(pSLDlg, CDeviceAddDlg::IDD, false, true);
}


void CDevResDlg::OnRadioDelete() 
{
	validateContents(NULL);
}

void CDevResDlg::OnRadioDevice() 
{
	validateContents(NULL);
}

void CDevResDlg::OnSelchangeComboDevice() 
{
	m_ctrlRadioDevice.SetCheck(1);
	m_ctrlRadioDelete.SetCheck(0);

	validateContents(NULL);
}

void CDevResDlg::OnPseudoModalChildClose(int sldIDD, LPARAM lparam)
{
	if (CDeviceAddDlg::IDD == sldIDD)
	{
		populateDeviceCombo();

		if (NULL != m_pNewestDevice)
		{
			m_ctrlRadioDevice.SetCheck(1);
			m_ctrlRadioDelete.SetCheck(0);
		}

		validateContents(NULL);
	}
	if ((CProgressDlg::IDD == sldIDD) && (SLDTHREADID_DEVRESDLGSAVE == lparam))
	{
		if (!m_bThreadResult)
		{
			if (m_threadErrorList.IsEmpty())
			{
				MessageBox(CTypedError::SafeGetFullErrorTextTempBuffer(&m_threadTError), SUPERNUDELIST_ERROR_TITLE, MB_ICONEXCLAMATION);
				this->closeWindow();
			}
			else
			{
				CListingDlg *pSLDlg = new CListingDlg(SUPERNUDELIST_ERROR_TITLE,
														CTypedError::SafeGetFullErrorTextTempBuffer(&m_threadTError),
														&m_threadErrorList, false, this);
				this->openPseudoModalChild(pSLDlg, CListingDlg::IDD, false, true);
			}
		}
		else
		{
			this->closeWindow();
		}
	}
	else if (CListingDlg::IDD == sldIDD)
	{
		m_threadErrorList.RemoveAll();

		this->closeWindow();
	}
}

bool CDevResDlg::validateContents(CTypedError *pTError)
{
	bool bResult = true;

	if ((!m_ctrlRadioDevice.GetCheck()) && (!m_ctrlRadioDelete.GetCheck()))
	{
		CTypedError::SafeSetMsgError(pTError, "No action selected.");
		bResult = false;
	}
	else if (m_ctrlRadioDevice.GetCheck())
	{
		int selIdx = m_ctrlComboBoxDevices.GetCurSel();

		if (0 > selIdx)
		{
			CTypedError::SafeSetMsgError(pTError, "No player selected.");
			bResult = false;
		}
		else
		{
			void *pDeviceVoid = m_ctrlComboBoxDevices.GetItemDataPtr(selIdx);

			// Since when was -1 guaranteed not to be a valid pointer? But that's
			// GetItemDataPtr's way of returning errors...
			if ((NULL == pDeviceVoid) || ((-1) == (int)pDeviceVoid))
			{
				CTypedError::SafeSetMsgError(pTError, "No player selected.");
				bResult = false;
			}
		}
	}

	m_buttonOK.EnableWindow(bResult ? TRUE : FALSE);

	return(bResult);
}

void CDevResDlg::OnOK() 
{
	CTypedError tError;

	if (!validateContents(&tError))
	{
		MessageBox(CTypedError::SafeGetFullErrorTextTempBuffer(&tError), SUPERNUDELIST_ERROR_TITLE, MB_ICONEXCLAMATION);
	}
	else if (0 == m_ctrlListCtrl.GetSelectedCount())
	{
		MessageBox("No discs selected.", SUPERNUDELIST_ERROR_TITLE, MB_ICONEXCLAMATION);
	}
	else
	{
		if (m_ctrlRadioDevice.GetCheck())
		{
			actionSetDevice();
		}
		else if (m_ctrlRadioDelete.GetCheck())
		{
			CString csDelMsg;
			csDelMsg.Format("Delete %u disc%s?",
							m_ctrlListCtrl.GetSelectedCount(),
							1 == m_ctrlListCtrl.GetSelectedCount() ? "" : "s");

			if (IDYES == MessageBox(csDelMsg, "Are you sure?", MB_YESNO | MB_ICONQUESTION))
			{
				actionDelete();
			}
		}
	}

	if (m_pDiscSet->empty())
	{
		(*m_pbDevResSuccess) = true;

		m_bThreadResult = true;
		CTypedError::SafeReset(&m_threadTError);
		m_threadErrorList.RemoveAll();

		CPDTDevResDlgSave *pThread = new CPDTDevResDlgSave(&m_bThreadResult, &m_threadErrorList,
															&m_threadTError, m_pConfig);

		CProgressDlg *pProgDlg = new CProgressDlg(PROGD_FRAME_NOPROG, false, pThread, this);
		this->openPseudoModalChild(pProgDlg, CProgressDlg::IDD, false, true);
	}
}

void CDevResDlg::OnCancel() 
{
	(*m_pbDevResSuccess) = false;

	m_bThreadResult = true;
	CTypedError::SafeReset(&m_threadTError);
	m_threadErrorList.RemoveAll();

	CPDTDevResDlgSave *pThread = new CPDTDevResDlgSave(&m_bThreadResult, &m_threadErrorList,
														&m_threadTError, m_pConfig);

	CProgressDlg *pProgDlg = new CProgressDlg(PROGD_FRAME_NOPROG, false, pThread, this);
	this->openPseudoModalChild(pProgDlg, CProgressDlg::IDD, false, true);
}

void CDevResDlg::actionSetDevice(void)
{
	int selIdx = m_ctrlComboBoxDevices.GetCurSel();

	if (0 <= selIdx)
	{
		void *pDeviceVoid = m_ctrlComboBoxDevices.GetItemDataPtr(selIdx);

		// Since when was -1 guaranteed not to be a valid pointer? But that's
		// GetItemDataPtr's way of returning errors...
		if ((NULL != pDeviceVoid) && ((-1) != (int)pDeviceVoid))
		{
			const CSNDevice *pDev = (const CSNDevice *)pDeviceVoid;

			POSITION pos = m_ctrlListCtrl.GetFirstSelectedItemPosition();

			while (NULL != pos)
			{
				int idx = m_ctrlListCtrl.GetNextSelectedItem(pos);

				CSNDisc *pDisc = (CSNDisc *)m_ctrlListCtrl.GetItemData(idx);

				set<CSNDisc *>::iterator setIter = m_pDiscSet->find(pDisc);

				if (setIter != m_pDiscSet->end())
				{
					(*setIter)->SetDevice(pDev);

					m_pDiscSet->erase(setIter);
				}
			}
		}
	}

	if (!m_pDiscSet->empty())
	{
		populateList();
	}
}

void CDevResDlg::actionDelete(void)
{
	POSITION pos = m_ctrlListCtrl.GetFirstSelectedItemPosition();

	while (NULL != pos)
	{
		int idx = m_ctrlListCtrl.GetNextSelectedItem(pos);

		CSNDisc *pDisc = (CSNDisc *)m_ctrlListCtrl.GetItemData(idx);

		set<CSNDisc *>::iterator setIter = m_pDiscSet->find(pDisc);

		if (setIter != m_pDiscSet->end())
		{
			(*setIter)->SNUIT_PressedDeleteButton(NULL);

			m_pDiscSet->erase(setIter);
		}
	}

	if (!m_pDiscSet->empty())
	{
		populateList();
	}
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

CPDTDevResDlgSave::CPDTDevResDlgSave(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
										CSNConfig *pConfig) : CProgressDlgThread()
{
	m_pbThreadResult = pbThreadResult;
	m_pStrLstLog = pStrLstLog;
	m_pThreadTError = pThreadTError;

	m_pConfig = pConfig;
}

CPDTDevResDlgSave::~CPDTDevResDlgSave(void)
{
}

// Returns an ident for the thread.
// Typically, each implementation of this class within a project will use a unique
// ident. (-1) should not be used, but any other number is fine.
// See CSuckLessDialog::OnThreadTermination().
int CPDTDevResDlgSave::GetIdent(void)
{
	return(SLDTHREADID_DEVRESDLGSAVE);
}

// Overriden to provide functionality.
void CPDTDevResDlgSave::mainThreadSubClass(void)
{
	(*m_pbThreadResult) = false;

	SetProgressTitle("Saving changes...");

	SetProgressHeading("Saving Library");
	SetProgressMessage("");

	if (m_pConfig->SaveLibrary(m_pThreadTError, NULL))
	{
		(*m_pbThreadResult) = true;

		if (m_pConfig->GetDevices()->IsDirty())
		{
			SetProgressHeading("Saving Players");
			SetProgressMessage("");

			if (!m_pConfig->SaveDevices(m_pThreadTError))
			{
				(*m_pbThreadResult) = false;
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

