#if !defined(AFX_DEVRESDLG_H__528FF7FB_ED14_4777_B88C_5757BD1B2497__INCLUDED_)
#define AFX_DEVRESDLG_H__528FF7FB_ED14_4777_B88C_5757BD1B2497__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DevResDlg.h : header file
//
#include "SuckLessDialog.h"
#include "ProgressDlg.h"
#include "SortableListCtrl.h"

class CCCFWrapper;
class CSNDevice;
class CSNDisc;
class CSNConfig;


/////////////////////////////////////////////////////////////////////////////
// CDevResDlg dialog

class CDevResDlg : public CSuckLessDialog
{
// Construction
public:
	CDevResDlg(CSNConfig *pConfig, CCCFWrapper *pCCFWrapper, set<CSNDisc *> *pDiscSet, bool *pbDevResSuccess, CWnd* pParent);

// Dialog Data
	//{{AFX_DATA(CDevResDlg)
	enum { IDD = IDD_DEVRES_DIALOG };
	CButton	m_buttonOK;
	CButton	m_ctrlRadioDevice;
	CButton	m_ctrlRadioDelete;
	CButton	m_ctrlCancel;
	CComboBox	m_ctrlComboBoxDevices;
	CSortableListCtrl	m_ctrlListCtrl;
	CString	m_staticIntro;
	CString	m_staticRemaining;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDevResDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:

	enum
	{
		LIST_COL_LIST = 0,
		LIST_COL_ARTIST,
		LIST_COL_DISC,
		LIST_COL_DEVICE,
		LIST_COL_NUMBER,
		LIST_COL_DUMMY
	};

	enum
	{
		ILIDX_LIST		= 0,
		ILIDX_ARTIST	= 1,
		ILIDX_DISC		= 2
	};

	CSNConfig *m_pConfig;
	CCCFWrapper *m_pCCFWrapper;
	set<CSNDisc *> *m_pDiscSet;

	CImageList m_ctrlListImageList;

	const CSNDevice *m_pNewestDevice;

	bool *m_pbDevResSuccess;

	bool m_bThreadResult;
	CTypedError m_threadTError;
	CStringList m_threadErrorList;

	bool m_bInitDone;

protected:
	void populateList(void);
	void populateDeviceCombo(void);
	bool validateContents(CTypedError *pTError);
	void actionSetDevice(void);
	void actionDelete(void);

	static int CALLBACK nudelSLSortCallbackArtistColumn(CSortableListCtrl *pList,
														LPARAM lParam1, LPARAM lParam2,
														int idx1, int idx2, void *pVoid);

	static int CALLBACK nudelSLSortCallbackDiscColumn(CSortableListCtrl *pList,
														LPARAM lParam1, LPARAM lParam2,
														int idx1, int idx2, void *pVoid);

	// SuckLessDialog
	void OnPseudoModalChildClose(int sldIDD, LPARAM lparam);
	void OnSizeHookEnd(void);

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDevResDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnButtonAll();
	afx_msg void OnButtonNone();
	afx_msg void OnButtonNewdevice();
	afx_msg void OnRadioDelete();
	afx_msg void OnRadioDevice();
	afx_msg void OnSelchangeComboDevice();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

class CPDTDevResDlgSave : public CProgressDlgThread
{
public:

	CPDTDevResDlgSave(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
						 CSNConfig *pConfig);
	virtual ~CPDTDevResDlgSave(void);

	// Returns an ident for the thread.
	// Typically, each implementation of this class within a project will use a unique
	// ident. (-1) should not be used, but any other number is fine.
	// See CSuckLessDialog::OnThreadTermination().
	int GetIdent(void);

protected:
	bool *m_pbThreadResult;
	CStringList *m_pStrLstLog;
	CTypedError *m_pThreadTError;

	CSNConfig *m_pConfig;

	// Overriden to provide functionality.
	void mainThreadSubClass(void);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DEVRESDLG_H__528FF7FB_ED14_4777_B88C_5757BD1B2497__INCLUDED_)
