#if !defined(AFX_DEVICESDLG_H__6E91B520_8367_11D4_BF8F_0020AF872188__INCLUDED_)
#define AFX_DEVICESDLG_H__6E91B520_8367_11D4_BF8F_0020AF872188__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DevicesDlg.h : header file
//
#include "SuckLessDialog.h"
#include "SNDevice.h"
#include "ProgressDlg.h"


/////////////////////////////////////////////////////////////////////////////
// CDevicesDlg dialog

class CSNConfig;
class CCCFWrapper;

class CDevicesDlg : public CSuckLessDialog
{
// Construction
public:
	CDevicesDlg(CSNConfig *pConfig, CCCFWrapper *pCCFWrapper, CWnd* pParent);

// Dialog Data
	//{{AFX_DATA(CDevicesDlg)
	enum { IDD = IDD_DEVICES_DIALOG };
	CListBox	m_ctrlListDevices;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDevicesDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void populateCtrlListDevices(void);

	CSNConfig *m_pConfig;
	CCCFWrapper *m_pCCFWrapper;

	bool m_bCancelAfterListing;

	bool m_bThreadResult;
	CTypedError m_threadTError;
	CStringList m_threadErrorList;

	// SuckLessDialog:
	void virtual OnPseudoModalChildClose(int sldIDD, LPARAM lparam);

	// Generated message map functions
	//{{AFX_MSG(CDevicesDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnButtonAdd();
	afx_msg void OnButtonEdit();
	afx_msg void OnButtonDelete();
	afx_msg void OnDblclkListDevices();
	virtual void OnOK();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

class CPDTDevDlgSave : public CProgressDlgThread
{
public:

	CPDTDevDlgSave(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
					 CSNConfig *pConfig);
	virtual ~CPDTDevDlgSave(void);

	// Returns an ident for the thread.
	// Typically, each implementation of this class within a project will use a unique
	// ident. (-1) should not be used, but any other number is fine.
	// See CSuckLessDialog::OnThreadTermination().
	int GetIdent(void);

protected:
	bool *m_pbThreadResult;
	CStringList *m_pStrLstLog;
	CTypedError *m_pThreadTError;

	CSNConfig *m_pConfig;

	// Overriden to provide functionality.
	void mainThreadSubClass(void);
};

/////////////////////////////////////////////////////////////////////////////

class CPDTDevDlgReLoad : public CProgressDlgThread
{
public:

	CPDTDevDlgReLoad(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
					 CSNConfig *pConfig);
	virtual ~CPDTDevDlgReLoad(void);

	// Returns an ident for the thread.
	// Typically, each implementation of this class within a project will use a unique
	// ident. (-1) should not be used, but any other number is fine.
	// See CSuckLessDialog::OnThreadTermination().
	int GetIdent(void);

protected:
	bool *m_pbThreadResult;
	CStringList *m_pStrLstLog;
	CTypedError *m_pThreadTError;

	CSNConfig *m_pConfig;

	// Overriden to provide functionality.
	void mainThreadSubClass(void);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DEVICESDLG_H__6E91B520_8367_11D4_BF8F_0020AF872188__INCLUDED_)
