#if !defined(AFX_DISCDLG_H__45B5E1DC_11C7_47A9_80A0_A16874EB5A01__INCLUDED_)
#define AFX_DISCDLG_H__45B5E1DC_11C7_47A9_80A0_A16874EB5A01__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DiscDlg.h : header file
//
#include "SuckLessDialog.h"
#include "SortableListCtrl.h"
#include "SNTrack.h"

/////////////////////////////////////////////////////////////////////////////
// CDiscDlg dialog

class CSNDisc;
class CSNArtist;
class CSNVolume;
class CSNLibrary;
class CSNDevice;
class ISNUITreeVolume;
class ISNUITreeArtist;
class ISNUITreeDlg;
class CSNDeviceList;

class CDiscDlg : public CSuckLessDialog
{
	friend class CTrackDlg; // Calls resetAndPopulateTrackList

// Construction
public:
	// pParentArtist can be NULL if pUpdateDisc is NULL.

	CDiscDlg(ISNUITreeDlg *pTreeDlg,
				const CSNDisc *pTemplateDisc, const CSNDisc *pUpdateDisc, const CSNDisc *pToAddBelow,
				ISNUITreeVolume *pParentVolume,
				ISNUITreeArtist *pParentArtist,
				CSNDeviceList *pDevices,
				const CSNDevice *pDevice,
				const CSNLibrary *pLibrary,
				CWnd* pParent);

	~CDiscDlg();

// Dialog Data
	//{{AFX_DATA(CDiscDlg)
	enum { IDD = IDD_DISC_DIALOG };
	CEdit	m_ctrlEditShort;
	CButton	m_ctrlCheckIgnoreTracks;
	CSortableListCtrl	m_ctrlListTracks;
	CButton	m_buttonCancel;
	CButton	m_buttonOK;
	CSpinButtonCtrl	m_ctrlSpinNumber;
	CComboBox	m_ctrlComboBoxDevice;
	CComboBox	m_ctrlComboBoxArtist;
	CEdit	m_ctrlEditSortAs;
	CEdit	m_ctrlEditName;
	CString	m_editName;
	CString	m_editSortAs;
	CString	m_editShort;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDiscDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:

	enum
	{
		LIST_COL_NUMBER = 0,
		LIST_COL_NAME
	};

	bool m_bInitDone;

	const CSNDisc *m_pUpdateDisc;
	const CSNDisc *m_pToAddBelow;
	ISNUITreeArtist *m_pParentArtist;
	ISNUITreeVolume *m_pParentVolume;
	ISNUITreeDlg *m_pTreeDlg;

	CSNDisc *m_pNewDisc;

	CSNDeviceList *m_pDevices;
	const CSNLibrary *m_pLibrary;

	const CSNArtist *m_pArtistToSelect;

	bool m_bUpdatingDiscNumber;

	CSNTrack m_templateTrack;

protected:
	void resetAndPopulateArtists(void);
	void resetAndPopulateTrackList(void);
	void updateDiscNumber(int discNumber, bool bUpdateEdit, bool bUpdateSpin);

	// SuckLessDialog:
	void OnPseudoModalChildClose(int sldIDD, LPARAM lparam);
	void OnSizeHookEnd(void);

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDiscDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnButtonName();
	afx_msg void OnButtonSortas();
	afx_msg void OnButtonArtistnew();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	virtual void OnOK();
	afx_msg void OnChangeEditNumber();
	afx_msg void OnButtonAddtrack();
	afx_msg void OnButtonDeletetrack();
	afx_msg void OnButtonEdittrack();
	afx_msg void OnDblclkListTracks(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnButtonShort();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DISCDLG_H__45B5E1DC_11C7_47A9_80A0_A16874EB5A01__INCLUDED_)
