// ImportDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SNConfig.h"
#include "ImportDlg.h"
#include "ListingDlg.h"
#include "LegacyNudelistFileFormat.h"
#include "CSVDlg.h"
#include "SNConfig.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CImportDlg dialog


CImportDlg::CImportDlg(bool bImport, CSNConfig *pConfig, CWnd* pParent)
	: CSuckLessDialog(CImportDlg::IDD, pParent),
	  m_bImport(bImport),
	  m_pConfig(pConfig)
{
	//{{AFX_DATA_INIT(CImportDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_listEE.push_back(pair<UINT, const char *>( 9000, "" ));
	m_listEE.push_back(pair<UINT, const char *>( 50, "Try to save myself by myself keeps slipping away..." ));
	m_listEE.push_back(pair<UINT, const char *>( 18000, "" ));
	m_listEE.push_back(pair<UINT, const char *>( 50, "Try to save myself by myself keeps slipping away..." ));
	m_listEE.push_back(pair<UINT, const char *>( 18000, "" ));
	m_listEE.push_back(pair<UINT, const char *>( 50, "Try" ));
	m_listEE.push_back(pair<UINT, const char *>( 50, "   to" ));
	m_listEE.push_back(pair<UINT, const char *>( 50, "     save" ));
	m_listEE.push_back(pair<UINT, const char *>( 75, "         myself" ));
	m_listEE.push_back(pair<UINT, const char *>( 50, "               but" ));
	m_listEE.push_back(pair<UINT, const char *>( 75, "                  myself" ));
	m_listEE.push_back(pair<UINT, const char *>( 75, "                        keeps" ));
	m_listEE.push_back(pair<UINT, const char *>( 80, "                             slipping" ));
	m_listEE.push_back(pair<UINT, const char *>( 80, "                                     away..." ));
	m_listEE.push_back(pair<UINT, const char *>( 18000, "" ));
	m_listEE.push_back(pair<UINT, const char *>( 50, "Try to save myself by myself keeps slipping..." ));
	m_listEE.push_back(pair<UINT, const char *>( 9000, "" ));
	m_listEE.push_back(pair<UINT, const char *>( 9000, "" ));
	m_listEEIter = m_listEE.begin();
}

void CImportDlg::OnTimer(UINT nIDEvent) 
{
	if (1 == nIDEvent)
	{
		UINT uiNextDelay = m_listEEIter->first;
		const char *szMessage = m_listEEIter->second;

		this->setStatusBarText(szMessage);

		// Next...

		m_listEEIter++;

		if (m_listEEIter == m_listEE.end())
		{
			KillTimer(1);
			this->setStatusBarText("Pick a file already! I'm getting bored here. :-)");
		}
		else
		{
			SetTimer(1, uiNextDelay, NULL); // Unless killed, timer will refire anyway.
		}
	}
	
	CSuckLessDialog::OnTimer(nIDEvent);
}

void CImportDlg::DoDataExchange(CDataExchange* pDX)
{
	CSuckLessDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CImportDlg)
	DDX_Control(pDX, IDC_EDIT_FILENAME, m_ctrlEditFilename);
	DDX_Control(pDX, IDC_BUTTON_FILENAME, m_ctrlButtonFilename);
	DDX_Control(pDX, IDC_STATIC_INFOTEXT, m_ctrlStaticInfoText);
	DDX_Control(pDX, IDOK, m_ctrlButtonOK);
	DDX_Control(pDX, IDC_RADIO_CSV, m_ctrlRadioCSV);
	DDX_Control(pDX, IDC_RADIO_SNXML, m_ctrlRadioSNXML);
	DDX_Control(pDX, IDC_RADIO_LEGACY, m_ctrlRadioLegacy);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CImportDlg, CSuckLessDialog)
	//{{AFX_MSG_MAP(CImportDlg)
	ON_BN_CLICKED(IDC_BUTTON_FILENAME, OnButtonFilename)
	ON_BN_CLICKED(IDC_RADIO_CSV, OnRadioCsv)
	ON_BN_CLICKED(IDC_RADIO_LEGACY, OnRadioLegacy)
	ON_BN_CLICKED(IDC_RADIO_SNXML, OnRadioSnxml)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImportDlg message handlers

BOOL CImportDlg::OnInitDialog() 
{
	CSuckLessDialog::OnInitDialog();
	
	this->setWindowIcon(IDR_MAINFRAME);

	this->SetWindowText(m_bImport ? "Import" : "Export");

	m_ctrlRadioLegacy.EnableWindow(m_bImport ? TRUE : FALSE);

	// -- Settings from registry

	string strFileName;
	string strFileType;

	if (LeetRegQueryStringValue(HKEY_CURRENT_USER, SN_REG_PATH_ROOT, m_bImport ? SN_REG_VALUE_IMPORTFILENAME : SN_REG_VALUE_EXPORTFILENAME, &strFileName)
	&&	LeetRegQueryStringValue(HKEY_CURRENT_USER, SN_REG_PATH_ROOT, m_bImport ? SN_REG_VALUE_IMPORTFILETYPE : SN_REG_VALUE_EXPORTFILETYPE, &strFileType))
	{
		if (0 == stricmp(strFileType.c_str(), SN_REG_CONTENT_CSV))
		{
			m_ctrlRadioCSV.SetCheck(1);
		}
		else if (0 == stricmp(strFileType.c_str(), SN_REG_CONTENT_SNXML))
		{
			m_ctrlRadioSNXML.SetCheck(1);
		}
		else if (0 == stricmp(strFileType.c_str(), SN_REG_CONTENT_LEGACY))
		{
			m_ctrlRadioLegacy.SetCheck(1);
		}

		m_ctrlEditFilename.SetWindowText(strFileName.c_str());

		updateControls();
	}

	// -- Control setup --

	addControlInfo(IDC_STATIC_FORMATS);
	addControlInfo(IDC_RADIO_CSV);
	addControlInfo(IDC_RADIO_SNXML);
	addControlInfo(IDC_RADIO_LEGACY);

	addControlInfo(IDC_STATIC_INFOFRAME);
	addControlInfo(IDC_STATIC_INFOTEXT);

	addControlInfo(IDC_STATIC_FILENAME);
	addControlInfo(IDC_EDIT_FILENAME);
	addControlInfo(IDC_BUTTON_FILENAME);

	addControlInfo(IDOK);
	addControlInfo(IDCANCEL);

	setControlRelationship(IDC_STATIC_FORMATS,	IDD,					CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_STATIC_INFOFRAME,IDD,					CControlInfo::ACOMMON_TOP_RESIZEWIDTH);
	setControlRelationship(IDC_STATIC_FILENAME,	IDD,					CControlInfo::ACOMMON_BOTTOM_RESIZEWIDTH);

	setControlRelationship(IDC_RADIO_CSV,		IDC_STATIC_FORMATS,		CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_RADIO_SNXML,		IDC_STATIC_FORMATS,		CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_RADIO_LEGACY,	IDC_STATIC_FORMATS,		CControlInfo::ACOMMON_TOP_LEFT);

	setControlRelationship(IDC_STATIC_INFOTEXT,	IDC_STATIC_INFOFRAME,	CControlInfo::ACOMMON_RESIZEHEIGHT_RESIZEWIDTH);

	setControlRelationship(IDC_EDIT_FILENAME,	IDC_STATIC_FILENAME,	CControlInfo::ACOMMON_TOP_RESIZEWIDTH);
	setControlRelationship(IDC_BUTTON_FILENAME,	IDC_STATIC_FILENAME,	CControlInfo::ACOMMON_TOP_RIGHT);

	setControlRelationship(IDOK,				IDD,					CControlInfo::ACOMMON_BOTTOM_RIGHT);
	setControlRelationship(IDCANCEL,			IDD,					CControlInfo::ACOMMON_BOTTOM_RIGHT);

	controlAndFrameInfoIsSetup();

	setMinXToCurrent();
	setMinYToCurrent();
	setMaxYToCurrent();

	SetTimer(1, 0, NULL);

	this->setRememberWindowPosition(SN_REG_PATH_WINDOWPOS, SN_REG_VALUE_WINDOWPOS_IMPORT);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CImportDlg::OnRadioCsv() 
{
	m_ctrlEditFilename.SetWindowText("");
	updateControls();
}

void CImportDlg::OnRadioLegacy() 
{
	m_ctrlEditFilename.SetWindowText("");
	updateControls();
}

void CImportDlg::OnRadioSnxml() 
{
	m_ctrlEditFilename.SetWindowText("");
	updateControls();
}

void CImportDlg::updateControls(void)
{
	const char *szInfoMsg;
	bool bGotFormat = true;

	if (1 == m_ctrlRadioCSV.GetCheck())
	{
		m_ctrlButtonOK.SetWindowText("Next >");
		szInfoMsg = "You can specify the columns on the next page.";
	}
	else if (1 == m_ctrlRadioSNXML.GetCheck())
	{
		m_ctrlButtonOK.SetWindowText("OK");

		if (m_bImport)
		{
			szInfoMsg = "The file containing your discs is typically named \"SN_Library.xml\".";
		}
		else
		{
			szInfoMsg = "For backups, copy the two XML files in the SN_Config directory.";
		}
	}
	else if (m_bImport && (1 == m_ctrlRadioLegacy.GetCheck()))
	{
		m_ctrlButtonOK.SetWindowText("OK");
		szInfoMsg = "You can assign your discs to players en masse at execution time.";
	}
	else
	{
		bGotFormat = false;
		szInfoMsg = "Select a file format.";
	}

	m_ctrlStaticInfoText.SetWindowText(szInfoMsg);

	m_ctrlButtonFilename.EnableWindow(bGotFormat ? TRUE : FALSE);

	CString csFilename;
	m_ctrlEditFilename.GetWindowText(csFilename);
	bool bGotFilename = (! csFilename.IsEmpty() );

	m_ctrlButtonOK.EnableWindow( (bGotFormat && bGotFilename) ? TRUE : FALSE );
}

void CImportDlg::OnButtonFilename() 
{
	const char *szImportExt;
	const char *szImportDesc;

	bool bGotFormat = true;

	KillTimer(1);
	this->setStatusBarText("");

	if (1 == m_ctrlRadioCSV.GetCheck())
	{
		szImportExt = ".csv";
		szImportDesc = "Comma-Separated Values (*.csv;*.txt)|*.csv;*.txt|All Files (*.*)|*.*||";
	}
	else if (1 == m_ctrlRadioSNXML.GetCheck())
	{
		szImportExt = ".xml";
		szImportDesc = "Super-Nudelist XML (*.xml)|*.xml|All Files (*.*)|*.*||";
	}
	else if (1 == m_ctrlRadioLegacy.GetCheck())
	{
		szImportExt = ".txt";
		szImportDesc = "Nudelist Legacy Format (*.txt)|*.txt|All Files (*.*)|*.*||";
	}
	else
	{
		bGotFormat = false;
	}

	if (bGotFormat)
	{
		DWORD dwFlags = OFN_HIDEREADONLY|OFN_NOCHANGEDIR|OFN_PATHMUSTEXIST;

		if (m_bImport)
		{
			dwFlags |= OFN_FILEMUSTEXIST;
		}
		else
		{
			dwFlags |= OFN_OVERWRITEPROMPT;
		}

		CFileDialog cfd(m_bImport ? TRUE : FALSE, szImportExt, NULL, dwFlags, szImportDesc, this);

		if (m_bImport)
		{
			cfd.m_ofn.lpstrTitle = "Select file to import from";
		}
		else
		{
			cfd.m_ofn.lpstrTitle = "Select file to export to";
		}

		if (IDOK == cfd.DoModal())
		{
			m_ctrlEditFilename.SetWindowText(cfd.GetPathName());
		}

		updateControls();
	}
}

void CImportDlg::OnOK() 
{
	bool bGeneric = false;
	CPDTImportDlgGeneric::OP_TYPE genericOpType = CPDTImportDlgGeneric::NO_OP;

	CString csFiletype;

	if (1 == m_ctrlRadioCSV.GetCheck())
	{
		bGeneric = false;
		csFiletype = SN_REG_CONTENT_CSV;
	}
	else if (1 == m_ctrlRadioSNXML.GetCheck())
	{
		bGeneric = true;
		csFiletype = SN_REG_CONTENT_SNXML;

		if (m_bImport)
		{
			genericOpType = CPDTImportDlgGeneric::IMPORT_XML;
		}
		else
		{
			genericOpType = CPDTImportDlgGeneric::EXPORT_XML;
		}
	}
	else if (1 == m_ctrlRadioLegacy.GetCheck())
	{
		bGeneric = true;
		csFiletype = SN_REG_CONTENT_LEGACY;

		if (m_bImport)
		{
			genericOpType = CPDTImportDlgGeneric::IMPORT_LEGACY;
		}
	}

	CString csFilename;
	m_ctrlEditFilename.GetWindowText(csFilename);

	if ( (!csFiletype.IsEmpty()) && (!csFilename.IsEmpty()) )
	{
		LeetRegSetValue(HKEY_CURRENT_USER, SN_REG_PATH_ROOT, m_bImport ? SN_REG_VALUE_IMPORTFILENAME : SN_REG_VALUE_EXPORTFILENAME, REG_SZ, LPCTSTR(csFilename), csFilename.GetLength() + 1);
		LeetRegSetValue(HKEY_CURRENT_USER, SN_REG_PATH_ROOT, m_bImport ? SN_REG_VALUE_IMPORTFILETYPE : SN_REG_VALUE_EXPORTFILETYPE, REG_SZ, LPCTSTR(csFiletype), csFiletype.GetLength() + 1);

		if (bGeneric)
		{
			CPDTImportDlgGeneric *pThread = new CPDTImportDlgGeneric(&m_bThreadResult,
																	 &m_threadErrorList,
																	 &m_threadTError,
																	 m_pConfig,
																	 genericOpType,
																	 csFilename);

			CProgressDlg *pProgDlg = new CProgressDlg(PROGD_FRAME_NOPROG, false, pThread, this);
			this->openPseudoModalChild(pProgDlg, CProgressDlg::IDD, false, true);
		}
		else
		{
			CCSVDlg *pCSVDlg = new CCSVDlg(m_bImport, m_pConfig, csFilename, this);
			this->openPseudoModalChild(pCSVDlg, CCSVDlg::IDD, true, true);
		}
	}
}

void CImportDlg::OnPseudoModalChildClose(int sldIDD, LPARAM lparam)
{
	if ((CProgressDlg::IDD == sldIDD)				\
	&&	(SLDTHREADID_IMPORTDLGGENERIC == lparam)	)
	{
		if (!m_bThreadResult)
		{
			if (m_threadErrorList.IsEmpty())
			{
				MessageBox(CTypedError::SafeGetFullErrorTextTempBuffer(&m_threadTError), SUPERNUDELIST_ERROR_TITLE, MB_ICONEXCLAMATION);
			}
			else
			{
				CListingDlg *pSLDlg = new CListingDlg(SUPERNUDELIST_ERROR_TITLE,
														CTypedError::SafeGetFullErrorTextTempBuffer(&m_threadTError),
														&m_threadErrorList, false, this);
				this->openPseudoModalChild(pSLDlg, CListingDlg::IDD, false, true);
			}
		}
		else
		{
			CSuckLessDialog::OnOK();
		}
	}
	else if (CListingDlg::IDD == sldIDD)
	{
		m_threadErrorList.RemoveAll();
	}
	else if (CCSVDlg::IDD == sldIDD)
	{
		CSuckLessDialog::OnOK();
	}
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

CPDTImportDlgGeneric::CPDTImportDlgGeneric(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
											CSNConfig *pConfig, OP_TYPE opType, const char *szFilename)
: CProgressDlgThread()
{
	m_pbThreadResult = pbThreadResult;
	m_pStrLstLog = pStrLstLog;
	m_pThreadTError = pThreadTError;

	m_pConfig = pConfig;

	m_opType = opType;

	m_strFilename = szFilename;
}

CPDTImportDlgGeneric::~CPDTImportDlgGeneric(void)
{
}

// Overriden to provide functionality.
void CPDTImportDlgGeneric::mainThreadSubClass(void)
{
	(*m_pbThreadResult) = false;
	CTypedError::SafeReset(m_pThreadTError);
	m_pStrLstLog->RemoveAll();

	if (IMPORT_XML == m_opType)
	{
		SetProgressTitle("Importing from XML...");

		SetProgressHeading("Loading Library");
		SetProgressMessage("");

		if (m_pConfig->LoadLibrary(m_pThreadTError, m_pStrLstLog, m_strFilename.c_str()))
		{
			(*m_pbThreadResult) = true;
		}
	}
	else if (EXPORT_XML == m_opType)
	{
		SetProgressTitle("Exporting to XML...");

		SetProgressHeading("Saving Library");
		SetProgressMessage("");

		if (m_pConfig->SaveLibrary(m_pThreadTError, m_strFilename.c_str()))
		{
			(*m_pbThreadResult) = true;
		}
	}
	else if (IMPORT_LEGACY == m_opType)
	{
		SetProgressTitle("Importing legacy configuration...");

		SetProgressHeading("Loading");
		SetProgressMessage("");

		CLegacyNudelistFileFormat leggy;

		FILE *pFile = fopen(m_strFilename.c_str(), "r");

		if (NULL == pFile)
		{
			CTypedError::SafeSetMsgError(m_pThreadTError, "Cannot open %s", m_strFilename.c_str());
		}
		else
		{
			if (leggy.Read(m_pThreadTError, pFile))
			{
				SetProgressHeading("Parsing");
				SetProgressMessage("");

				if (leggy.Parse(m_pThreadTError))
				{
					SetProgressHeading("Building");
					SetProgressMessage("");

					if (leggy.MakeVolume(m_pThreadTError, m_pConfig->GetLibrary(), NULL))
					{
						(*m_pbThreadResult) = true;
					}
				}
			}

			fclose(pFile);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
