#if !defined(AFX_IMPORTDLG_H__B924BF66_1CCC_4EF1_8628_AEFCB21B0185__INCLUDED_)
#define AFX_IMPORTDLG_H__B924BF66_1CCC_4EF1_8628_AEFCB21B0185__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ImportDlg.h : header file
//

#include "SuckLessDialog.h"
#include "ProgressDlg.h"

class CSNConfig;

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// CImportDlg dialog
/////////////////////////////////////////////////////////////////////////////

class CImportDlg : public CSuckLessDialog
{
// Construction
public:
	CImportDlg(bool bImport, CSNConfig *pConfig, CWnd* pParent);

	list< pair<UINT, const char *> > m_listEE;
	list< pair<UINT, const char *> >::const_iterator m_listEEIter;

// Dialog Data
	//{{AFX_DATA(CImportDlg)
	enum { IDD = IDD_IMPORT_DIALOG };
	CEdit	m_ctrlEditFilename;
	CButton	m_ctrlButtonFilename;
	CStatic	m_ctrlStaticInfoText;
	CButton	m_ctrlButtonOK;
	CButton	m_ctrlRadioCSV;
	CButton	m_ctrlRadioSNXML;
	CButton	m_ctrlRadioLegacy;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CImportDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	bool m_bThreadResult;
	CTypedError m_threadTError;
	CStringList m_threadErrorList;

	bool m_bImport; // Import or Export?
	CSNConfig *m_pConfig;

protected:
	void updateControls(void);

	// SuckLessDialog:
	void virtual OnPseudoModalChildClose(int sldIDD, LPARAM lparam);

	// Generated message map functions
	//{{AFX_MSG(CImportDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnButtonFilename();
	afx_msg void OnRadioCsv();
	afx_msg void OnRadioLegacy();
	afx_msg void OnRadioSnxml();
	virtual void OnOK();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

class CPDTImportDlgGeneric : public CProgressDlgThread
{
public:
	enum OP_TYPE
	{
		NO_OP,
		IMPORT_XML,
		EXPORT_XML,
		IMPORT_LEGACY
	};

public:
	CPDTImportDlgGeneric(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
						 CSNConfig *pConfig, OP_TYPE opType, const char *szFilename);
	virtual ~CPDTImportDlgGeneric(void);

	int GetIdent(void)
	{
		return(SLDTHREADID_IMPORTDLGGENERIC);
	}

protected:
	bool *m_pbThreadResult;
	CStringList *m_pStrLstLog;
	CTypedError *m_pThreadTError;

	CSNConfig *m_pConfig;

	OP_TYPE m_opType;
	string m_strFilename;

	void mainThreadSubClass(void);
};

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_IMPORTDLG_H__B924BF66_1CCC_4EF1_8628_AEFCB21B0185__INCLUDED_)
