// LayoutNudelistLine.cpp: implementation of the CLayoutNudelistLine class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "LayoutNudelistLines.h"
#include "LayoutNudelist.h"
#include "SNArtist.h"
#include "CSFSection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////

CLNLBlank::CLNLBlank(void)
{
}

CLNLBlank::~CLNLBlank(void)
{
}

void CLNLBlank::AddToPanelCSFSection(CCSFSection *pPanelCSFSection, unsigned int ypos, CCSFSection::FontType fontTypeDefault, bool bTruncate) const
{
}

/////////////////////////////////////////////////////////////////////////

CLNLTwoItems::CLNLTwoItems(const char *szNameEscapedOne, const char *szButtonLabelEscapedOne, const CActionSectionAdder *pActionAdderOne,
						   const char *szNameEscapedTwo, const char *szButtonLabelEscapedTwo, const CActionSectionAdder *pActionAdderTwo)
{
	if ((NULL != szNameEscapedOne) && (NULL != pActionAdderOne))
	{
		m_bOne = true;

		m_strNameEscapedOne = szNameEscapedOne;
		m_pActionAdderOne = pActionAdderOne;

		if (NULL != szButtonLabelEscapedOne)
		{
			m_strButtonLabelEscapedOne = szButtonLabelEscapedOne;
		}
	}
	else
	{
		m_bOne = false;
		m_pActionAdderOne = NULL;
	}

	if ((NULL != szNameEscapedTwo) && (NULL != pActionAdderTwo))
	{
		m_bTwo = true;

		m_strNameEscapedTwo = szNameEscapedTwo;
		m_pActionAdderTwo = pActionAdderTwo;

		if (NULL != szButtonLabelEscapedTwo)
		{
			m_strButtonLabelEscapedTwo = szButtonLabelEscapedTwo;
		}
	}
	else
	{
		m_bTwo = false;
		m_pActionAdderTwo = NULL;
	}

}

CLNLTwoItems::~CLNLTwoItems(void)
{
}

void CLNLTwoItems::AddToPanelCSFSection(CCSFSection *pPanelCSFSection, unsigned int ypos, CCSFSection::FontType fontTypeDefault, bool bTruncate) const
{
	CCSFSection *pAction;

	if (m_bOne)
	{
		pPanelCSFSection->AddEscapedButtonSubSection(m_strButtonLabelEscapedOne.c_str(),
														0, ypos, 36, 34,
														CCSFSection::FONT_8,
														CCSFSection::COLOUR_WHITE,
														"BMP\\TwoDiscLeftButton.bmp",
														&pAction);

		m_pActionAdderOne->AddToActionSection(pAction);

		CProntoString psLabel;
		psLabel.SetEscaped(m_strNameEscapedOne.c_str());

		if (bTruncate)
		{
			psLabel.TruncateToPixelWidth(CCSFSection::FONT_10 == fontTypeDefault, 164);
		}

		pPanelCSFSection->AddEscapedFrameSubSection(psLabel.GetEscaped(false),
														36, ypos, 168, 17,
														fontTypeDefault,
														CCSFSection::COLOUR_WHITE,
														"BMP\\TwoDiscLeftStrip.bmp");
	}

	if (m_bTwo)
	{
		pPanelCSFSection->AddEscapedButtonSubSection(m_strButtonLabelEscapedTwo.c_str(),
														204, ypos, 36, 34,
														CCSFSection::FONT_8,
														CCSFSection::COLOUR_BLACK,
														"BMP\\TwoDiscRightButton.bmp",
														&pAction);

		m_pActionAdderTwo->AddToActionSection(pAction);

		CProntoString psLabel;
		psLabel.SetEscaped(m_strNameEscapedTwo.c_str());

		if (bTruncate)
		{
			psLabel.TruncateToPixelWidth(CCSFSection::FONT_10 == fontTypeDefault, 164);
		}

		pPanelCSFSection->AddEscapedFrameSubSection(psLabel.GetEscaped(false),
														36, ypos + 17, 168, 17,
														fontTypeDefault,
														CCSFSection::COLOUR_BLACK,
														"BMP\\TwoDiscRightStrip.bmp");
	}
}

/////////////////////////////////////////////////////////////////////////

CLNLOneItemAndContinuation::CLNLOneItemAndContinuation(const char *szNameEscapedOne, const char *szButtonLabelEscapedOne, const CActionSectionAdder *pActionAdderOne,
													   const CActionSectionAdder *pActionAdderContinuation)
{
	if ((NULL != szNameEscapedOne) && (NULL != pActionAdderOne))
	{
		m_bOne = true;

		m_strNameEscapedOne = szNameEscapedOne;
		m_pActionAdderOne = pActionAdderOne;

		if (NULL != szButtonLabelEscapedOne)
		{
			m_strButtonLabelEscapedOne = szButtonLabelEscapedOne;
		}
	}
	else
	{
		m_bOne = false;
		m_pActionAdderOne = NULL;
	}

	m_pActionAdderContinuation = pActionAdderContinuation;
}

CLNLOneItemAndContinuation::~CLNLOneItemAndContinuation(void)
{
}

void CLNLOneItemAndContinuation::AddToPanelCSFSection(CCSFSection *pPanelCSFSection, unsigned int ypos, CCSFSection::FontType fontTypeDefault, bool bTruncate) const
{
	CCSFSection *pAction;

	if (m_bOne)
	{
		pPanelCSFSection->AddEscapedButtonSubSection(m_strButtonLabelEscapedOne.c_str(),
														0, ypos, 36, 34,
														CCSFSection::FONT_8,
														CCSFSection::COLOUR_WHITE,
														"BMP\\TwoDiscLeftButton.bmp",
														&pAction);

		m_pActionAdderOne->AddToActionSection(pAction);

		CProntoString psLabel;
		psLabel.SetEscaped(m_strNameEscapedOne.c_str());

		if (bTruncate)
		{
			psLabel.TruncateToPixelWidth(CCSFSection::FONT_10 == fontTypeDefault, 164);
		}

		pPanelCSFSection->AddEscapedFrameSubSection(psLabel.GetEscaped(false),
														36, ypos, 168, 17,
														fontTypeDefault,
														CCSFSection::COLOUR_WHITE,
														"BMP\\TwoDiscLeftStrip.bmp");
	}

	if (NULL != m_pActionAdderContinuation)
	{
		pPanelCSFSection->AddEscapedButtonSubSection(">>",
													204, ypos, 36, 34,
													fontTypeDefault,
													CCSFSection::COLOUR_BLACK,
													"BMP\\TwoDiscRightButton.bmp",
													&pAction);

		m_pActionAdderContinuation->AddToActionSection(pAction);

		pPanelCSFSection->AddEscapedFrameSubSection(NULL,
													67, ypos + 17, 137, 17,
													CCSFSection::FONT_0,
													CCSFSection::COLOUR_BLACK,
													"BMP\\ContinuationStrip.bmp");
	}

}

/////////////////////////////////////////////////////////////////////////

// pActionAdder may be NULL, in which case a frame is made rather than a button.
// (This is not the general case for other classes in this file.)
CLNLHeading::CLNLHeading(const char *szNameEscaped, const CActionSectionAdder *pActionAdder)
{
	m_szNameEscaped = szNameEscaped;
	m_pActionAdder = pActionAdder;
}

CLNLHeading::~CLNLHeading(void)
{
}

void CLNLHeading::AddToPanelCSFSection(CCSFSection *pPanelCSFSection, unsigned int ypos, CCSFSection::FontType fontTypeDefault, bool bTruncate) const
{
	CCSFSection *pAction;

	if (NULL != m_szNameEscaped)
	{
		if ((0 == stricmp("Nine Inch Nails", m_szNameEscaped))
		||	(0 == stricmp("NIN",			 m_szNameEscaped)))
		{
			if (NULL != m_pActionAdder)
			{
				pPanelCSFSection->AddEscapedButtonSubSection(NULL,
																0, ypos, 240, 34,
																CCSFSection::FONT_0,
																CCSFSection::COLOUR_BLACK,
																"BMP\\ArtistHeader.bmp",
																&pAction);
				m_pActionAdder->AddToActionSection(pAction);

				pPanelCSFSection->AddEscapedButtonSubSection(NULL,
																92, ypos + 5, 57, 24,
																CCSFSection::FONT_0,
																CCSFSection::COLOUR_BLACK,
																"BMP\\NINClassicPronto.bmp",
																&pAction);
				m_pActionAdder->AddToActionSection(pAction);
			}
			else
			{
				pPanelCSFSection->AddEscapedFrameSubSection(NULL,
																0, ypos, 240, 34,
																CCSFSection::FONT_0,
																CCSFSection::COLOUR_BLACK,
																"BMP\\ArtistHeader.bmp");

				pPanelCSFSection->AddEscapedFrameSubSection(NULL,
																92, ypos + 5, 57, 24,
																CCSFSection::FONT_0,
																CCSFSection::COLOUR_BLACK,
																"BMP\\NINClassicPronto.bmp");
			}
		}
		else
		{
			CProntoString psLabel;
			psLabel.SetEscaped(m_szNameEscaped);

			if (bTruncate)
			{
				psLabel.TruncateToPixelWidth(CCSFSection::FONT_10 == fontTypeDefault, 220);
			}

			if (NULL != m_pActionAdder)
			{
				pPanelCSFSection->AddEscapedButtonSubSection(psLabel.GetEscaped(false),
																0, ypos, 240, 34,
																CCSFSection::FONT_10,
																CCSFSection::COLOUR_BLACK,
																"BMP\\ArtistHeader.bmp",
																&pAction);

				m_pActionAdder->AddToActionSection(pAction);
			}
			else
			{
				pPanelCSFSection->AddEscapedFrameSubSection(psLabel.GetEscaped(false),
																0, ypos, 240, 34,
																CCSFSection::FONT_10,
																CCSFSection::COLOUR_BLACK,
																"BMP\\ArtistHeader.bmp");
			}
		}
	}
}


/////////////////////////////////////////////////////////////////////////

CLNLContinuedHeading::CLNLContinuedHeading(const char *szNameEscaped, const CActionSectionAdder *pActionAdder)
{
	m_szNameEscaped = szNameEscaped;
	m_pActionAdder = pActionAdder;
}

CLNLContinuedHeading::~CLNLContinuedHeading(void)
{
}

void CLNLContinuedHeading::AddToPanelCSFSection(CCSFSection *pPanelCSFSection, unsigned int ypos, CCSFSection::FontType fontTypeDefault, bool bTruncate) const
{
	CCSFSection *pAction;

	if (NULL != m_szNameEscaped)
	{
		if ((0 == stricmp("Nine Inch Nails", m_szNameEscaped))
		||	(0 == stricmp("NIN",			 m_szNameEscaped)))
		{
			pPanelCSFSection->AddEscapedButtonSubSection(NULL,
															0, ypos, 240, 34,
															CCSFSection::FONT_0,
															CCSFSection::COLOUR_BLACK,
															"BMP\\ArtistContinuedHeader.bmp",
															&pAction);

			if (NULL != m_pActionAdder)
			{
				m_pActionAdder->AddToActionSection(pAction);
			}

			pPanelCSFSection->AddEscapedButtonSubSection(NULL,
															92, ypos + 5, 57, 24,
															CCSFSection::FONT_0,
															CCSFSection::COLOUR_BLACK,
															"BMP\\NINClassicPronto.bmp",
															&pAction);

			if (NULL != m_pActionAdder)
			{
				m_pActionAdder->AddToActionSection(pAction);
			}
		}
		else
		{
			CProntoString psLabel;
			psLabel.SetEscaped(m_szNameEscaped);

			if (bTruncate)
			{
				psLabel.TruncateToPixelWidth(CCSFSection::FONT_10 == fontTypeDefault, 220);
			}

			pPanelCSFSection->AddEscapedButtonSubSection(psLabel.GetEscaped(false),
															0, ypos, 240, 34,
															CCSFSection::FONT_10,
															CCSFSection::COLOUR_BLACK,
															"BMP\\ArtistContinuedHeader.bmp",
															&pAction);

			if (NULL != m_pActionAdder)
			{
				m_pActionAdder->AddToActionSection(pAction);
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////////
