// LegacyNudelistFileFormat.h: interface for the CLegacyNudelistFileFormat class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LEGACYNUDELISTFILEFORMAT_H__B4377B5E_32AE_4E95_9965_B4AAAB3853DE__INCLUDED_)
#define AFX_LEGACYNUDELISTFILEFORMAT_H__B4377B5E_32AE_4E95_9965_B4AAAB3853DE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSNLibrary;
class ISNUITreeDlg;

/////////////////////////////////////////////////////////////////////////

class CLegacyNudelistLine
{
public:
	CLegacyNudelistLine(void);
	virtual ~CLegacyNudelistLine(void);

	void SetLineBuffer(const char *buffer);
	void setArtistBuffer(const char *buffer);
	void setArtistShortBuffer(const char *buffer);
	void setTitleBuffer(const char *buffer);

	bool ParseBuffer(CTypedError *pTError, unsigned int previousNumber, const char *previousArtist);

	int GetNumber(void);
	const char *GetArtist(void);
	const char *GetArtistShort(void);
	const char *GetTitle(void);

protected:
	char *m_lineBuffer;
	char *m_artistBuffer;
	char *m_artistShortBuffer;
	char *m_titleBuffer;

	int m_number;
	const char *m_artist;
	const char *m_title;
};

/////////////////////////////////////////////////////////////////////////

class CLegacyNudelistFileFormat
{
public:
	CLegacyNudelistFileFormat(void);
	virtual ~CLegacyNudelistFileFormat(void);

	bool Read(CTypedError *pTError, FILE *pfInputList);
	bool Parse(CTypedError *pTError);

	bool MakeVolume(CTypedError *pTError, CSNLibrary *pLibrary, ISNUITreeDlg *pTreeDlg);

protected:
	list<CLegacyNudelistLine *> m_lines;
};

/////////////////////////////////////////////////////////////////////////


#endif // !defined(AFX_LEGACYNUDELISTFILEFORMAT_H__B4377B5E_32AE_4E95_9965_B4AAAB3853DE__INCLUDED_)
