// ListDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ListDlg.h"
#include "SNLibrary.h"
#include "ATSelectDlg.h"
#include "ProntoStringDlg.h"
#include "SNConfig.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CListDlg dialog


CListDlg::CListDlg(ISNUITreeDlg *pTreeDlg,
					const CSNVolume *pTemplateVolume, const CSNVolume *pUpdateVolume, const CSNVolume *pToAddBelow,
					ISNUITreeLibrary *pParentLibrary, const CCSFAbstractTree *pAbstractTree,
					CWnd* pParent)
	: CSuckLessDialog(CListDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CListDlg)
	m_editName = _T("");
	m_bCheckJump = FALSE;
	m_bCheckShowButtons = FALSE;
	//}}AFX_DATA_INIT

	m_pNewVolume = new CSNVolume();

	m_pHBIToUpdate = NULL;

	if (NULL != pTemplateVolume)
	{
		m_pNewVolume->Set(pTemplateVolume);
	}

	m_pUpdateVolume = pUpdateVolume;
	m_pToAddBelow = pToAddBelow;
	m_pParentLibrary = pParentLibrary;
	m_pAbstractTree = pAbstractTree;
	m_pTreeDlg = pTreeDlg;
}

CListDlg::~CListDlg()
{
	delete m_pNewVolume;
}

void CListDlg::DoDataExchange(CDataExchange* pDX)
{
	CSuckLessDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CListDlg)
	DDX_Control(pDX, IDC_CHECK_LINKS, m_ctrlCheckLinks);
	DDX_Control(pDX, IDC_CHECK_TRUNCATE, m_ctrlCheckTruncate);
	DDX_Control(pDX, IDC_CHECK_JUMPAFTERTRACK, m_ctrlCheckJumpAfterTrack);
	DDX_Control(pDX, IDC_CHECK_DELAYDISCSUNTILTRACK, m_ctrlCheckDelayDiscsUntilTrack);
	DDX_Control(pDX, IDC_COMBO_BREAKS, m_ctrlComboBreaks);
	DDX_Control(pDX, IDC_COMBO_LEVELS, m_ctrlComboLevels);
	DDX_Control(pDX, IDC_CHECK_HIDE, m_ctrlCheckHide);
	DDX_Control(pDX, IDC_CHECK_10POINT, m_ctrlCheck10Point);
	DDX_Control(pDX, IDC_CHECK_HARDJUMP, m_ctrlCheckHardJump);
	DDX_Control(pDX, IDC_LIST_HARDACTION, m_ctrlListBoxHardAction);
	DDX_Control(pDX, IDC_EDIT_HARDJUMP, m_ctrlEditHardJump);
	DDX_Control(pDX, IDC_BUTTON_HARDLABEL, m_ctrlButtonHardLabel);
	DDX_Control(pDX, IDC_STATIC_HARDLABEL, m_ctrlStaticHardLabel);
	DDX_Control(pDX, IDC_EDIT_HARDLABEL, m_ctrlEditHardLabel);
	DDX_Control(pDX, IDC_TAB_HARD, m_ctrlTabHard);
	DDX_Control(pDX, IDC_LIST_LINKS, m_ctrlListBoxLinks);
	DDX_Control(pDX, IDC_EDIT_NAME, m_ctrlEditName);
	DDX_Text(pDX, IDC_EDIT_NAME, m_editName);
	DDX_Check(pDX, IDC_CHECK_JUMP, m_bCheckJump);
	DDX_Check(pDX, IDC_CHECK_SHOWBUTTONS, m_bCheckShowButtons);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CListDlg, CSuckLessDialog)
	//{{AFX_MSG_MAP(CListDlg)
	ON_BN_CLICKED(IDC_CHECK_JUMP, OnCheckJump)
	ON_BN_CLICKED(IDC_BUTTON_JUMP, OnButtonJump)
	ON_BN_CLICKED(IDC_BUTTON_NAME, OnButtonName)
	ON_BN_CLICKED(IDC_BUTTON_LINKADD, OnButtonLinkadd)
	ON_BN_CLICKED(IDC_BUTTON_LINKDELETE, OnButtonLinkdelete)
	ON_BN_CLICKED(IDC_BUTTON_LINKEDIT, OnButtonLinkedit)
	ON_LBN_DBLCLK(IDC_LIST_LINKS, OnDblclkListLinks)
	ON_BN_CLICKED(IDC_BUTTON_HARDJUMP, OnButtonHardjump)
	ON_BN_CLICKED(IDC_BUTTON_HARDLABEL, OnButtonHardlabel)
	ON_BN_CLICKED(IDC_CHECK_HARDJUMP, OnCheckHardjump)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB_HARD, OnSelchangeTabHard)
	ON_BN_CLICKED(IDC_BUTTON_HARDACTIONADD, OnButtonHardactionadd)
	ON_BN_CLICKED(IDC_BUTTON_HARDACTIONDELETE, OnButtonHardactiondelete)
	ON_BN_CLICKED(IDC_BUTTON_HARDACTIONDOWN, OnButtonHardactiondown)
	ON_BN_CLICKED(IDC_BUTTON_HARDACTIONEDIT, OnButtonHardactionedit)
	ON_BN_CLICKED(IDC_BUTTON_HARDACTIONUP, OnButtonHardactionup)
	ON_LBN_DBLCLK(IDC_LIST_HARDACTION, OnDblclkListHardaction)
	ON_CBN_SELCHANGE(IDC_COMBO_LEVELS, OnSelchangeComboLevels)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListDlg message handlers

BOOL CListDlg::OnInitDialog() 
{
	CSuckLessDialog::OnInitDialog();
	
	UpdateData(TRUE);

	this->setWindowIcon(IDR_MAINFRAME);

	CString winTitle;
	GetWindowText(winTitle);
	if (NULL != m_pUpdateVolume)
	{
		winTitle += " -- (";
		winTitle += m_pUpdateVolume->GetName()->GetPrintable(true);
		winTitle += ")";
	}
	else
	{
		winTitle += " -- <New>";
	}
	SetWindowText(winTitle);

	// -- Initial contents --

	if (NULL != g_pProntoFont)
	{
		m_ctrlEditHardLabel.SetFont(g_pProntoFont);
		m_ctrlEditHardJump.SetFont(g_pProntoFont);
		m_ctrlListBoxHardAction.SetFont(g_pProntoFont);
	
		CWnd *pCtrl;

		pCtrl = GetDlgItem(IDC_EDIT_NAME);
		if (NULL != pCtrl)
		{
			pCtrl->SetFont(g_pProntoFont);
		}

		pCtrl = GetDlgItem(IDC_EDIT_JUMP);
		if (NULL != pCtrl)
		{
			pCtrl->SetFont(g_pProntoFont);
		}

		pCtrl = GetDlgItem(IDC_LIST_LINKS);
		if (NULL != pCtrl)
		{
			pCtrl->SetFont(g_pProntoFont);
		}
	}

	// --

	int tabIdx = 0;
	const CSNHardButtonDefinitionList *pHardButtons = m_pNewVolume->GetHardButtons();

	for (const CSNHardButtonDefinition *pHBD = pHardButtons->GetFirst(); NULL != pHBD; pHBD = pHardButtons->GetNext(pHBD)) 
	{
		if (tabIdx != m_ctrlTabHard.InsertItem(tabIdx, pHBD->GetName()->GetPrintable(true)))
		{
			MessageBox("Error initialising tab control.", SUPERNUDELIST_ERROR_TITLE, MB_OK | MB_ICONEXCLAMATION);
			break;
		}

		m_tabHardMap.insert(pair<int, const CSNHardButtonDefinition *>(tabIdx, pHBD));

		tabIdx++;
	}

	m_ctrlTabHard.SetCurSel(0);
	saveAndPopulateHard(false, true);

	// --

	m_editName = m_pNewVolume->GetName()->GetPronto(true);

	// --

	const CCSFPanelPath *pPanel = m_pNewVolume->GetJumpPanel();
	csfPanelPathToStringGadget(IDC_EDIT_JUMP, pPanel);
	m_bCheckJump = (NULL != pPanel);

	// --

	m_bCheckShowButtons = m_pNewVolume->GetShowNumbers() ? TRUE : FALSE;

	m_ctrlCheck10Point.SetCheck(m_pNewVolume->GetLargerFont() ? 1 : 0);
	
	m_ctrlCheckHide.SetCheck(m_pNewVolume->GetHidePanels() ? 1 : 0);

	m_ctrlCheckDelayDiscsUntilTrack.SetCheck(m_pNewVolume->GetDelayDiscUntilTrack() ? 1 : 0);

	m_ctrlCheckJumpAfterTrack.SetCheck(m_pNewVolume->GetJumpAfterTrack() ? 1 : 0);

	m_ctrlCheckTruncate.SetCheck(m_pNewVolume->GetTruncate() ? 1 : 0);

	m_ctrlCheckLinks.SetCheck(m_pNewVolume->GetLinks() ? 1 : 0);

	// --
	{
		m_ctrlComboLevels.SetItemData(m_ctrlComboLevels.AddString("Letters -> Artists -> Discs -> Tracks"),	LEV_L|LEV_A|LEV_D|LEV_T);
		m_ctrlComboLevels.SetItemData(m_ctrlComboLevels.AddString("Letters -> Artists -> Discs"),			LEV_L|LEV_A|LEV_D      );
		m_ctrlComboLevels.SetItemData(m_ctrlComboLevels.AddString("Letters -> Artists -> Tracks"),			LEV_L|LEV_A|      LEV_T);
		m_ctrlComboLevels.SetItemData(m_ctrlComboLevels.AddString("Letters -> Discs -> Tracks"),			LEV_L|      LEV_D|LEV_T);
		m_ctrlComboLevels.SetItemData(m_ctrlComboLevels.AddString("Letters -> Discs"),						LEV_L|      LEV_D      );
		m_ctrlComboLevels.SetItemData(m_ctrlComboLevels.AddString("Letters -> Tracks"),						LEV_L|            LEV_T);
		m_ctrlComboLevels.SetItemData(m_ctrlComboLevels.AddString("Artists -> Discs -> Tracks"),			      LEV_A|LEV_D|LEV_T);
		m_ctrlComboLevels.SetItemData(m_ctrlComboLevels.AddString("Artists -> Discs"),						      LEV_A|LEV_D      );
		m_ctrlComboLevels.SetItemData(m_ctrlComboLevels.AddString("Artists -> Tracks"),						      LEV_A|      LEV_T);
		m_ctrlComboLevels.SetItemData(m_ctrlComboLevels.AddString("Discs -> Tracks"),						            LEV_D|LEV_T);
		m_ctrlComboLevels.SetItemData(m_ctrlComboLevels.AddString("Discs"),									            LEV_D      );
		m_ctrlComboLevels.SetItemData(m_ctrlComboLevels.AddString("Tracks"),								                  LEV_T);

		DWORD dwCCLSel = 0;

		if (m_pNewVolume->GetShowLetters()) dwCCLSel |= LEV_L;
		if (m_pNewVolume->GetShowArtists()) dwCCLSel |= LEV_A;
		if (m_pNewVolume->GetShowDiscs()  ) dwCCLSel |= LEV_D;
		if (m_pNewVolume->GetShowTracks() ) dwCCLSel |= LEV_T;

		m_ctrlComboLevels.SetCurSel(0);

		for (int i=0; i < m_ctrlComboLevels.GetCount(); i++)
		{
			if (dwCCLSel == m_ctrlComboLevels.GetItemData(i))
			{
				m_ctrlComboLevels.SetCurSel(i);
				break;
			}
		}

		OnSelchangeComboLevels();
	}
	// --
	{
		m_ctrlComboBreaks.SetItemData(m_ctrlComboBreaks.AddString("New page for every item"),				BRK_A);
		m_ctrlComboBreaks.SetItemData(m_ctrlComboBreaks.AddString("Space between items"),					BRK_S);
		m_ctrlComboBreaks.SetItemData(m_ctrlComboBreaks.AddString("Space; New page if doesn't fit"),		BRK_S | BRK_F);
		m_ctrlComboBreaks.SetItemData(m_ctrlComboBreaks.AddString("No space between items"),				0);
		m_ctrlComboBreaks.SetItemData(m_ctrlComboBreaks.AddString("No space; New page if doesn't fit"),	BRK_F);

		DWORD dwCCBSel = BRK_A;

		if (! m_pNewVolume->GetGapBreakAlways() )
		{
			dwCCBSel = 0;

			if (m_pNewVolume->GetGapSpace()) dwCCBSel |= BRK_S;
			if (m_pNewVolume->GetGapFit())   dwCCBSel |= BRK_F;
		}

		m_ctrlComboBreaks.SetCurSel(0);

		for (int i=0; i < m_ctrlComboBreaks.GetCount(); i++)
		{
			if (dwCCBSel == m_ctrlComboBreaks.GetItemData(i))
			{
				m_ctrlComboBreaks.SetCurSel(i);
				break;
			}
		}
	}
	// --

	int insIdx;

	for (const CCSFButtonPath *pButton = m_pNewVolume->GetLinkButtonPaths()->GetFirst();
		 NULL != pButton;
		 pButton = m_pNewVolume->GetLinkButtonPaths()->GetNext(pButton))
	{
		insIdx = m_ctrlListBoxLinks.InsertString(0, pButton->GetName()->GetPronto(true));

		if ((0 > insIdx) \
		||	(LB_ERR == m_ctrlListBoxLinks.SetItemDataPtr(insIdx, (void *)pButton)))
		{
			MessageBox("Population of GUI failed",
					   SUPERNUDELIST_ERROR_TITLE,
					   MB_OK | MB_ICONSTOP);
			break;
		}
	}

	// -- Control setup --

	addControlInfo(IDC_STATIC_FRAME_LEFT);
	addControlInfo(IDC_STATIC_FRAME_RIGHT);

	addControlInfo(IDC_STATIC_GENERAL);
	addControlInfo(IDC_STATIC_LINKS);

	addControlInfo(IDC_STATIC_NAME);
	addControlInfo(IDC_EDIT_NAME);
	addControlInfo(IDC_BUTTON_NAME);

	addControlInfo(IDC_CHECK_JUMP);
	addControlInfo(IDC_EDIT_JUMP);
	addControlInfo(IDC_BUTTON_JUMP);

	addControlInfo(IDC_STATIC_LEVELS);
	addControlInfo(IDC_COMBO_LEVELS);

	addControlInfo(IDC_STATIC_BREAKS);
	addControlInfo(IDC_COMBO_BREAKS);

	addControlInfo(IDC_CHECK_JUMPAFTERTRACK);
	addControlInfo(IDC_CHECK_DELAYDISCSUNTILTRACK);
	addControlInfo(IDC_CHECK_SHOWBUTTONS);
	addControlInfo(IDC_CHECK_HIDE);
	addControlInfo(IDC_CHECK_10POINT);
	addControlInfo(IDC_CHECK_TRUNCATE);

	addControlInfo(IDC_LIST_LINKS);
	addControlInfo(IDC_BUTTON_LINKADD);
	addControlInfo(IDC_BUTTON_LINKEDIT);
	addControlInfo(IDC_BUTTON_LINKDELETE);

	addControlInfo(IDC_TAB_HARD);

	addControlInfo(IDC_STATIC_HARDGENERAL);
	addControlInfo(IDC_STATIC_HARDACTION);

	addControlInfo(IDC_STATIC_HARDLABEL);
	addControlInfo(IDC_EDIT_HARDLABEL);
	addControlInfo(IDC_BUTTON_HARDLABEL);

	addControlInfo(IDC_CHECK_HARDJUMP);
	addControlInfo(IDC_EDIT_HARDJUMP);
	addControlInfo(IDC_BUTTON_HARDJUMP);

	addControlInfo(IDC_LIST_HARDACTION);
	addControlInfo(IDC_BUTTON_HARDACTIONADD);
	addControlInfo(IDC_BUTTON_HARDACTIONEDIT);
	addControlInfo(IDC_BUTTON_HARDACTIONDELETE);
	addControlInfo(IDC_BUTTON_HARDACTIONUP);
	addControlInfo(IDC_BUTTON_HARDACTIONDOWN);

	addControlInfo(IDC_BUTTON_HELP);

	addControlInfo(IDOK);
	addControlInfo(IDCANCEL);

	setControlRelationship(IDC_STATIC_FRAME_LEFT,	IDD,	CControlInfo::ATOP_TOP,
															CControlInfo::ABOTTOM_BOTTOM,
															CControlInfo::ALEFT_LEFT,
															CControlInfo::ARIGHT_PERCENTAGE,
															CControlInfo::ATAG_ENDLIST);

	setControlRelationship(IDC_STATIC_FRAME_RIGHT,	IDD,	CControlInfo::ATOP_TOP,
															CControlInfo::ABOTTOM_BOTTOM,
															CControlInfo::ALEFT_PERCENTAGE,
															CControlInfo::ARIGHT_RIGHT,
															CControlInfo::ATAG_ENDLIST);

	setControlRelationship(IDC_STATIC_GENERAL,		IDC_STATIC_FRAME_LEFT,	CControlInfo::ACOMMON_TOP_RESIZEWIDTH);

	setControlRelationship(IDC_STATIC_NAME,			IDC_STATIC_GENERAL,		CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_NAME,			IDC_STATIC_GENERAL,		CControlInfo::ACOMMON_TOP_RESIZEWIDTH);
	setControlRelationship(IDC_BUTTON_NAME,			IDC_STATIC_GENERAL,		CControlInfo::ACOMMON_TOP_RIGHT);

	setControlRelationship(IDC_CHECK_JUMP,			IDC_STATIC_GENERAL,		CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_JUMP,			IDC_STATIC_GENERAL,		CControlInfo::ACOMMON_TOP_RESIZEWIDTH);
	setControlRelationship(IDC_BUTTON_JUMP,			IDC_STATIC_GENERAL,		CControlInfo::ACOMMON_TOP_RIGHT);

	setControlRelationship(IDC_STATIC_LEVELS,		IDC_STATIC_GENERAL,		CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_COMBO_LEVELS,		IDC_STATIC_GENERAL,		CControlInfo::ACOMMON_TOP_RESIZEWIDTH);

	setControlRelationship(IDC_STATIC_BREAKS,		IDC_STATIC_GENERAL,		CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_COMBO_BREAKS,		IDC_STATIC_GENERAL,		CControlInfo::ACOMMON_TOP_RESIZEWIDTH);

	setControlRelationship(IDC_CHECK_JUMPAFTERTRACK,	IDC_STATIC_GENERAL,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_CHECK_DELAYDISCSUNTILTRACK,	IDC_STATIC_GENERAL,	CControlInfo::ACOMMON_TOP_LEFT);

	setControlRelationship(IDC_CHECK_SHOWBUTTONS,	IDC_STATIC_GENERAL,		CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_CHECK_HIDE,			IDC_STATIC_GENERAL,		CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_CHECK_10POINT,		IDC_STATIC_GENERAL,		CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_CHECK_TRUNCATE,		IDC_STATIC_GENERAL,		CControlInfo::ACOMMON_TOP_LEFT);

	setControlRelationship(IDC_STATIC_LINKS,		IDC_STATIC_FRAME_LEFT,	CControlInfo::ACOMMON_RESIZEHEIGHT_RESIZEWIDTH);

	setControlRelationship(IDC_LIST_LINKS,			IDC_STATIC_LINKS,		CControlInfo::ACOMMON_RESIZEHEIGHT_RESIZEWIDTH);
	setControlRelationship(IDC_BUTTON_LINKADD,		IDC_STATIC_LINKS,		CControlInfo::ACOMMON_TOP_RIGHT);
	setControlRelationship(IDC_BUTTON_LINKEDIT,		IDC_STATIC_LINKS,		CControlInfo::ACOMMON_TOP_RIGHT);
	setControlRelationship(IDC_BUTTON_LINKDELETE,	IDC_STATIC_LINKS,		CControlInfo::ACOMMON_TOP_RIGHT);

	setControlRelationship(IDC_TAB_HARD,			IDC_STATIC_FRAME_RIGHT,	CControlInfo::ACOMMON_RESIZEHEIGHT_RESIZEWIDTH);

	setControlRelationship(IDC_STATIC_HARDGENERAL,	IDC_TAB_HARD,			CControlInfo::ACOMMON_TOP_RESIZEWIDTH);
	setControlRelationship(IDC_STATIC_HARDACTION,	IDC_TAB_HARD,			CControlInfo::ACOMMON_RESIZEHEIGHT_RESIZEWIDTH);

	setControlRelationship(IDC_STATIC_HARDLABEL,	IDC_STATIC_HARDGENERAL,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_HARDLABEL,		IDC_STATIC_HARDGENERAL,	CControlInfo::ACOMMON_TOP_RESIZEWIDTH);
	setControlRelationship(IDC_BUTTON_HARDLABEL,	IDC_STATIC_HARDGENERAL,	CControlInfo::ACOMMON_TOP_RIGHT);

	setControlRelationship(IDC_CHECK_HARDJUMP,		IDC_STATIC_HARDGENERAL,	CControlInfo::ACOMMON_TOP_LEFT);
	setControlRelationship(IDC_EDIT_HARDJUMP,		IDC_STATIC_HARDGENERAL,	CControlInfo::ACOMMON_TOP_RESIZEWIDTH);
	setControlRelationship(IDC_BUTTON_HARDJUMP,		IDC_STATIC_HARDGENERAL,	CControlInfo::ACOMMON_TOP_RIGHT);

	setControlRelationship(IDC_LIST_HARDACTION,			IDC_STATIC_HARDACTION,	CControlInfo::ACOMMON_RESIZEHEIGHT_RESIZEWIDTH);
	setControlRelationship(IDC_BUTTON_HARDACTIONADD,	IDC_STATIC_HARDACTION,	CControlInfo::ACOMMON_TOP_RIGHT);
	setControlRelationship(IDC_BUTTON_HARDACTIONEDIT,	IDC_STATIC_HARDACTION,	CControlInfo::ACOMMON_TOP_RIGHT);
	setControlRelationship(IDC_BUTTON_HARDACTIONDELETE,	IDC_STATIC_HARDACTION,	CControlInfo::ACOMMON_TOP_RIGHT);
	setControlRelationship(IDC_BUTTON_HARDACTIONUP,		IDC_STATIC_HARDACTION,	CControlInfo::ACOMMON_TOP_RIGHT);
	setControlRelationship(IDC_BUTTON_HARDACTIONDOWN,	IDC_STATIC_HARDACTION,	CControlInfo::ACOMMON_TOP_RIGHT);

	setControlRelationship(IDC_BUTTON_HELP,			IDD,					CControlInfo::ACOMMON_BOTTOM_LEFT);

	setControlRelationship(IDOK,					IDD,					CControlInfo::ACOMMON_BOTTOM_RIGHT);
	setControlRelationship(IDCANCEL,				IDD,					CControlInfo::ACOMMON_BOTTOM_RIGHT);

	controlAndFrameInfoIsSetup();

	setMinXToCurrent();
	setMinYToCurrent();

	UpdateData(FALSE);

	m_ctrlEditName.SetFocus();

	this->setRememberWindowPosition(SN_REG_PATH_WINDOWPOS, SN_REG_VALUE_WINDOWPOS_LIST);

	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CListDlg::OnSelchangeTabHard(NMHDR* pNMHDR, LRESULT* pResult) 
{
	saveAndPopulateHard(true, true);
	
	*pResult = 0;
}

void CListDlg::saveAndPopulateHard(bool bSaveOld, bool bPopulateNew)
{
	if ((bSaveOld) && (NULL != m_pHBIToUpdate))
	{
		// Save the label, only if it has a label.
		// (Jump panel and action list are edited directly.)
		if (NULL != m_hbiEdited.GetLabel())
		{
			CString csLabel;
			m_ctrlEditHardLabel.GetWindowText(csLabel);
			m_hbiEdited.GetLabel()->SetPronto(csLabel);
		}

		// Remove jump if turned off.
		if (0 == m_ctrlCheckHardJump.GetCheck())
		{
			m_hbiEdited.SetJumpPanel(NULL);
		}

		// Update in our volume.
		m_pNewVolume->GetHardButtons()->Update(NULL, &m_hbiEdited, m_pHBIToUpdate);
	}

	if (bPopulateNew)
	{
		map<int, const CSNHardButtonDefinition *>::iterator thIter;
		thIter = m_tabHardMap.find(m_ctrlTabHard.GetCurSel());

		if (thIter != m_tabHardMap.end())
		{
			m_pHBIToUpdate = thIter->second;
			m_hbiEdited.Set(m_pHBIToUpdate);

			// --

			if (NULL != m_hbiEdited.GetLabel())
			{
				m_ctrlStaticHardLabel.EnableWindow(TRUE);
				m_ctrlEditHardLabel.EnableWindow(TRUE);
				m_ctrlButtonHardLabel.EnableWindow(TRUE);

				m_ctrlEditHardLabel.SetWindowText(m_hbiEdited.GetLabel()->GetPronto(true));
			}
			else
			{
				m_ctrlStaticHardLabel.EnableWindow(FALSE);
				m_ctrlEditHardLabel.EnableWindow(FALSE);
				m_ctrlButtonHardLabel.EnableWindow(FALSE);

				m_ctrlEditHardLabel.SetWindowText(m_hbiEdited.GetName()->GetPronto(true));
			}

			// --

			const CCSFPanelPath *pPanel = m_hbiEdited.GetJumpPanel();
			csfPanelPathToStringGadget(IDC_EDIT_HARDJUMP, pPanel);
			m_ctrlCheckHardJump.SetCheck(NULL != pPanel ? 1 : 0);

			// --

			m_ctrlListBoxHardAction.ResetContent();

			int insIdx = 0;

			for (const CCSFButtonPath *pButton = m_hbiEdited.GetActionButtonPaths()->GetFirst();
				 NULL != pButton;
				 pButton = m_hbiEdited.GetActionButtonPaths()->GetNext(pButton))
			{
				int atIdx = m_ctrlListBoxHardAction.InsertString(insIdx++, pButton->GetName()->GetPronto(true));

				if ((0 > atIdx) \
				||	(LB_ERR == m_ctrlListBoxHardAction.SetItemDataPtr(atIdx, (void *)pButton)))
				{
					MessageBox("Population of GUI failed",
							   SUPERNUDELIST_ERROR_TITLE,
							   MB_OK | MB_ICONSTOP);
					break;
				}
			}
		}
	}
}

void CListDlg::csfPanelPathToStringGadget(int editIdent, const CCSFPanelPath *pPath)
{
	CWnd *pCtrl = GetDlgItem(editIdent);

	if (NULL != pCtrl)
	{
		if (NULL == pPath) 
		{
			// Null CCSFPath passed in means clear the string.
			pCtrl->SetWindowText("");
		}
		else
		{
			pCtrl->SetWindowText(pPath->GetName()->GetPronto(true));
		}
	}
}

void CListDlg::OnCheckJump() 
{
	UpdateData(TRUE);
	
	csfPanelPathToStringGadget(IDC_EDIT_JUMP,
							m_bCheckJump ? m_pNewVolume->GetJumpPanel() : NULL);	
}

void CListDlg::OnCheckHardjump() 
{
	csfPanelPathToStringGadget(IDC_EDIT_HARDJUMP,
							m_ctrlCheckHardJump.GetCheck() ? m_hbiEdited.GetJumpPanel() : NULL);	
}

void CListDlg::OnButtonName() 
{
	CProntoStringDlg *pSLDlg = new CProntoStringDlg(&m_ctrlEditName, "List Name", this);
	this->openPseudoModalChild(pSLDlg, CProntoStringDlg::IDD, false, true);
}

void CListDlg::OnButtonHardlabel() 
{
	CString csTitle = m_hbiEdited.GetName()->GetPronto(true);
	csTitle += " Button Label";

	CProntoStringDlg *pSLDlg = new CProntoStringDlg(&m_ctrlEditHardLabel, csTitle, this);
	this->openPseudoModalChild(pSLDlg, CProntoStringDlg::IDD, false, true);
}

void CListDlg::OnButtonJump() 
{
	m_ATPathType = PATH_JUMP;
	m_pATSelButPathEditing = NULL;
	m_ATSelButPathEditingIdx = LB_ERR;

	const CCSFPanelPath *pPPath = m_pNewVolume->GetJumpPanel();

	if (NULL != pPPath)
	{
		m_ATSelDlgDev.SetPronto(pPPath->GetDeviceName()->GetPronto(false));
		m_ATSelDlgPan.SetPronto(pPPath->GetPanelName()->GetPronto(false));
	}

	m_ATSelDlgBut.Reset();

	CATSelectDlg *pSLDlg = new CATSelectDlg(CATSelectDlg::PT_PANEL, false, "Select Jump Panel", &m_ATSelDlgDev, &m_ATSelDlgPan, NULL, m_pAbstractTree, this);
	this->openPseudoModalChild(pSLDlg, CATSelectDlg::IDD, false, true);
}

void CListDlg::OnButtonHardjump() 
{
	m_ATPathType = PATH_JUMPHARD;
	m_pATSelButPathEditing = NULL;
	m_ATSelButPathEditingIdx = LB_ERR;

	const CCSFPanelPath *pPPath = m_hbiEdited.GetJumpPanel();

	if (NULL != pPPath)
	{
		m_ATSelDlgDev.SetPronto(pPPath->GetDeviceName()->GetPronto(false));
		m_ATSelDlgPan.SetPronto(pPPath->GetPanelName()->GetPronto(false));
	}

	m_ATSelDlgBut.Reset();

	CATSelectDlg *pSLDlg = new CATSelectDlg(CATSelectDlg::PT_PANEL, false, "Select Jump Panel", &m_ATSelDlgDev, &m_ATSelDlgPan, NULL, m_pAbstractTree, this);
	this->openPseudoModalChild(pSLDlg, CATSelectDlg::IDD, false, true);
}

void CListDlg::OnButtonLinkadd() 
{
	m_ATPathType = PATH_LINK;
	m_pATSelButPathEditing = NULL;
	m_ATSelButPathEditingIdx = LB_ERR;

	CATSelectDlg *pSLDlg = new CATSelectDlg(CATSelectDlg::PT_BUTTON, true, "Select Link Button", &m_ATSelDlgDev, &m_ATSelDlgPan, &m_ATSelDlgBut, m_pAbstractTree, this);
	this->openPseudoModalChild(pSLDlg, CATSelectDlg::IDD, false, true);
}

void CListDlg::OnButtonLinkdelete() 
{
	m_ATSelButPathEditingIdx = m_ctrlListBoxLinks.GetCurSel();

	if (0 <= m_ATSelButPathEditingIdx)
	{
		void *pATSelButPathEditingVoid = m_ctrlListBoxLinks.GetItemDataPtr(m_ATSelButPathEditingIdx);

		// Since when was -1 guaranteed not to be a valid pointer? But that's
		// GetItemDataPtr's way of returning errors...
		if ((NULL != pATSelButPathEditingVoid) && ((-1) != (int)pATSelButPathEditingVoid))
		{
			m_pATSelButPathEditing = (const CCSFButtonPath *)pATSelButPathEditingVoid;

			m_ctrlListBoxLinks.DeleteString(m_ATSelButPathEditingIdx);

			if (0 < m_ATSelButPathEditingIdx)
			{
				m_ATSelButPathEditingIdx--; // Select entry above.
			}
			else if (m_ctrlListBoxLinks.GetCount() == 0)
			{
				m_ATSelButPathEditingIdx = (-1); // Deselect.
			}
			// else select the same idx we just deleted (which must be index 0).

			m_ctrlListBoxLinks.SetCurSel(m_ATSelButPathEditingIdx);

			m_pNewVolume->GetLinkButtonPaths()->RemoveAndDelete(m_pATSelButPathEditing);
		}
	}
}

void CListDlg::OnButtonLinkedit() 
{
	m_ATPathType = PATH_LINK;

	m_ATSelButPathEditingIdx = m_ctrlListBoxLinks.GetCurSel();

	if (0 <= m_ATSelButPathEditingIdx)
	{
		void *pATSelButPathEditingVoid = m_ctrlListBoxLinks.GetItemDataPtr(m_ATSelButPathEditingIdx);

		// Since when was -1 guaranteed not to be a valid pointer? But that's
		// GetItemDataPtr's way of returning errors...
		if ((NULL != pATSelButPathEditingVoid) && ((-1) != (int)pATSelButPathEditingVoid))
		{
			m_pATSelButPathEditing = (const CCSFButtonPath *)pATSelButPathEditingVoid;

			m_ATSelDlgDev.SetPronto(m_pATSelButPathEditing->GetDeviceName()->GetPronto(false));
			m_ATSelDlgPan.SetPronto(m_pATSelButPathEditing->GetPanelName()->GetPronto(false));
			m_ATSelDlgBut.SetPronto(m_pATSelButPathEditing->GetButtonName()->GetPronto(false));

			CATSelectDlg *pSLDlg = new CATSelectDlg(CATSelectDlg::PT_BUTTON, true, "Select Link Button", &m_ATSelDlgDev, &m_ATSelDlgPan, &m_ATSelDlgBut, m_pAbstractTree, this);
			this->openPseudoModalChild(pSLDlg, CATSelectDlg::IDD, false, true);
		}
	}
}

void CListDlg::OnButtonHardactionadd() 
{
	m_ATPathType = PATH_LINKHARD;
	m_pATSelButPathEditing = NULL;
	m_ATSelButPathEditingIdx = LB_ERR;

	CATSelectDlg *pSLDlg = new CATSelectDlg(CATSelectDlg::PT_BUTTON, true, "Select Button", &m_ATSelDlgDev, &m_ATSelDlgPan, &m_ATSelDlgBut, m_pAbstractTree, this);
	this->openPseudoModalChild(pSLDlg, CATSelectDlg::IDD, false, true);
}

void CListDlg::OnButtonHardactiondelete() 
{
	m_ATSelButPathEditingIdx = m_ctrlListBoxHardAction.GetCurSel();

	if (0 <= m_ATSelButPathEditingIdx)
	{
		void *pATSelButPathEditingVoid = m_ctrlListBoxHardAction.GetItemDataPtr(m_ATSelButPathEditingIdx);

		// Since when was -1 guaranteed not to be a valid pointer? But that's
		// GetItemDataPtr's way of returning errors...
		if ((NULL != pATSelButPathEditingVoid) && ((-1) != (int)pATSelButPathEditingVoid))
		{
			m_pATSelButPathEditing = (const CCSFButtonPath *)pATSelButPathEditingVoid;

			m_ctrlListBoxHardAction.DeleteString(m_ATSelButPathEditingIdx);

			if (0 < m_ATSelButPathEditingIdx)
			{
				m_ATSelButPathEditingIdx--; // Select entry above.
			}
			else if (m_ctrlListBoxHardAction.GetCount() == 0)
			{
				m_ATSelButPathEditingIdx = (-1); // Deselect.
			}
			// else select the same idx we just deleted (which must be index 0).

			m_ctrlListBoxHardAction.SetCurSel(m_ATSelButPathEditingIdx);

			m_hbiEdited.GetActionButtonPaths()->RemoveAndDelete(m_pATSelButPathEditing);
		}
	}
}

void CListDlg::OnButtonHardactionedit() 
{
	m_ATPathType = PATH_LINKHARD;

	m_ATSelButPathEditingIdx = m_ctrlListBoxHardAction.GetCurSel();

	if (0 <= m_ATSelButPathEditingIdx)
	{
		void *pATSelButPathEditingVoid = m_ctrlListBoxHardAction.GetItemDataPtr(m_ATSelButPathEditingIdx);

		// Since when was -1 guaranteed not to be a valid pointer? But that's
		// GetItemDataPtr's way of returning errors...
		if ((NULL != pATSelButPathEditingVoid) && ((-1) != (int)pATSelButPathEditingVoid))
		{
			m_pATSelButPathEditing = (const CCSFButtonPath *)pATSelButPathEditingVoid;

			m_ATSelDlgDev.SetPronto(m_pATSelButPathEditing->GetDeviceName()->GetPronto(false));
			m_ATSelDlgPan.SetPronto(m_pATSelButPathEditing->GetPanelName()->GetPronto(false));
			m_ATSelDlgBut.SetPronto(m_pATSelButPathEditing->GetButtonName()->GetPronto(false));

			CATSelectDlg *pSLDlg = new CATSelectDlg(CATSelectDlg::PT_BUTTON, true, "Select Button", &m_ATSelDlgDev, &m_ATSelDlgPan, &m_ATSelDlgBut, m_pAbstractTree, this);
			this->openPseudoModalChild(pSLDlg, CATSelectDlg::IDD, false, true);
		}
	}
}

void CListDlg::OnButtonHardactionup() 
{
	m_ATSelButPathEditingIdx = m_ctrlListBoxHardAction.GetCurSel();

	if (0 <= m_ATSelButPathEditingIdx)
	{
		void *pATSelButPathEditingVoid = m_ctrlListBoxHardAction.GetItemDataPtr(m_ATSelButPathEditingIdx);

		// Since when was -1 guaranteed not to be a valid pointer? But that's
		// GetItemDataPtr's way of returning errors...
		if ((NULL != pATSelButPathEditingVoid) && ((-1) != (int)pATSelButPathEditingVoid))
		{
			m_pATSelButPathEditing = (const CCSFButtonPath *)pATSelButPathEditingVoid;

			if (0 < m_ATSelButPathEditingIdx)
			{
				m_ctrlListBoxHardAction.DeleteString(m_ATSelButPathEditingIdx);
				m_ATSelButPathEditingIdx--;
				m_ATSelButPathEditingIdx = m_ctrlListBoxHardAction.InsertString(m_ATSelButPathEditingIdx, m_pATSelButPathEditing->GetName()->GetPronto(true));

				if ((0 > m_ATSelButPathEditingIdx) \
				||	(LB_ERR == m_ctrlListBoxHardAction.SetItemDataPtr(m_ATSelButPathEditingIdx, (void *)m_pATSelButPathEditing)))
				{
					MessageBox("Update of GUI failed", "Error moving button", MB_OK | MB_ICONEXCLAMATION);
				}
				else
				{
					m_ctrlListBoxHardAction.SetCurSel(m_ATSelButPathEditingIdx);

					m_hbiEdited.GetActionButtonPaths()->MoveUp(m_pATSelButPathEditing);
				}
			}
		}
	}
}

void CListDlg::OnButtonHardactiondown() 
{
	m_ATSelButPathEditingIdx = m_ctrlListBoxHardAction.GetCurSel();

	if (0 <= m_ATSelButPathEditingIdx)
	{
		void *pATSelButPathEditingVoid = m_ctrlListBoxHardAction.GetItemDataPtr(m_ATSelButPathEditingIdx);

		// Since when was -1 guaranteed not to be a valid pointer? But that's
		// GetItemDataPtr's way of returning errors...
		if ((NULL != pATSelButPathEditingVoid) && ((-1) != (int)pATSelButPathEditingVoid))
		{
			m_pATSelButPathEditing = (const CCSFButtonPath *)pATSelButPathEditingVoid;

			if (m_ctrlListBoxHardAction.GetCount() > (m_ATSelButPathEditingIdx + 1))
			{
				m_ctrlListBoxHardAction.DeleteString(m_ATSelButPathEditingIdx);
				m_ATSelButPathEditingIdx++;
				m_ATSelButPathEditingIdx = m_ctrlListBoxHardAction.InsertString(m_ATSelButPathEditingIdx, m_pATSelButPathEditing->GetName()->GetPronto(true));

				if ((0 > m_ATSelButPathEditingIdx) \
				||	(LB_ERR == m_ctrlListBoxHardAction.SetItemDataPtr(m_ATSelButPathEditingIdx, (void *)m_pATSelButPathEditing)))
				{
					MessageBox("Update of GUI failed", "Error moving button", MB_OK | MB_ICONEXCLAMATION);
				}
				else
				{
					m_ctrlListBoxHardAction.SetCurSel(m_ATSelButPathEditingIdx);

					m_hbiEdited.GetActionButtonPaths()->MoveDown(m_pATSelButPathEditing);
				}
			}
		}
	}
}

void CListDlg::OnDblclkListLinks() 
{
	OnButtonLinkedit();
}

void CListDlg::OnDblclkListHardaction() 
{
	OnButtonHardactionedit();
}

// SuckLessDialog:
void CListDlg::OnPseudoModalChildClose(int sldIDD, LPARAM lparam)
{
	UpdateData(TRUE);

	if (CATSelectDlg::IDD == sldIDD)
	{
		if (lparam)
		{
			if ((PATH_JUMP == m_ATPathType) || (PATH_JUMPHARD == m_ATPathType))
			{
				CCSFPanelPath panel;
				panel.SetDeviceNamePronto(m_ATSelDlgDev.GetPronto(false));
				panel.SetPanelNamePronto(m_ATSelDlgPan.GetPronto(false));

				if (PATH_JUMP == m_ATPathType)
				{
					m_pNewVolume->SetJumpPanel(&panel);

					csfPanelPathToStringGadget(IDC_EDIT_JUMP, &panel);
					m_bCheckJump = TRUE;
				}
				else if (PATH_JUMPHARD == m_ATPathType)
				{
					m_hbiEdited.SetJumpPanel(&panel);

					csfPanelPathToStringGadget(IDC_EDIT_HARDJUMP, &panel);
					m_ctrlCheckHardJump.SetCheck(1);
				}
			}
			else if ((PATH_LINK == m_ATPathType) || (PATH_LINKHARD == m_ATPathType))
			{
				CCSFButtonPathList *pButtonList = NULL;
				CListBox *pCtrlListBox = NULL;

				if (PATH_LINK == m_ATPathType)
				{
					pButtonList = m_pNewVolume->GetLinkButtonPaths();
					pCtrlListBox = &m_ctrlListBoxLinks;
				}
				else if (PATH_LINKHARD == m_ATPathType)
				{
					pButtonList = m_hbiEdited.GetActionButtonPaths();
					pCtrlListBox = &m_ctrlListBoxHardAction;
				}

				CCSFButtonPath *pButton = new CCSFButtonPath();
				pButton->SetDeviceNamePronto(m_ATSelDlgDev.GetPronto(false));
				pButton->SetPanelNamePronto(m_ATSelDlgPan.GetPronto(false));
				pButton->SetButtonNamePronto(m_ATSelDlgBut.GetPronto(false));

				CTypedError tError;

				bool bUpdating = ((0 <= m_ATSelButPathEditingIdx) && (NULL != m_pATSelButPathEditing));

				if (bUpdating)
				{
					m_pATSelButPathEditing = pButtonList->Update(&tError, pButton, m_pATSelButPathEditing);
	
					if (NULL != m_pATSelButPathEditing)
					{
						pCtrlListBox->DeleteString(m_ATSelButPathEditingIdx);
					}
				}
				else
				{
					m_pATSelButPathEditing = pButtonList->AddBelowAndOwn(&tError, pButton, NULL);

					if (NULL != m_pATSelButPathEditing)
					{
						// Do not delete pButton, it is now owned by the list.
						// Note that the list does not take ownership in the case of updates.
						pButton = NULL;
					}

					m_ATSelButPathEditingIdx = pCtrlListBox->GetCount();
				}

				if (NULL != m_pATSelButPathEditing)
				{
					m_ATSelButPathEditingIdx = pCtrlListBox->InsertString(m_ATSelButPathEditingIdx, m_pATSelButPathEditing->GetName()->GetPronto(true));

					if ((0 > m_ATSelButPathEditingIdx) \
					||	(LB_ERR == pCtrlListBox->SetItemDataPtr(m_ATSelButPathEditingIdx, (void *)m_pATSelButPathEditing)))
					{
						CTypedError::SafeSetMsgError(&tError, "Update of GUI failed");
					}
				}

				if (CTypedError::SafeIsError(&tError))
				{
					MessageBox(CTypedError::SafeGetFullErrorTextTempBuffer(&tError),
							   bUpdating ? "Error updating button" : "Error adding button",
							   MB_OK | MB_ICONEXCLAMATION);
				}

				delete pButton;
				pButton = NULL;
			}
		}
	}

	UpdateData(FALSE);
}

void CListDlg::OnOK() 
{
	UpdateData(TRUE);

	// -- Put any unsaved values into the volume. --

	m_pNewVolume->GetName()->SetPronto(LPCTSTR(m_editName));

	if (! m_bCheckJump )
	{
		m_pNewVolume->SetJumpPanel(NULL);
	}

	m_pNewVolume->SetShowNumbers(m_bCheckShowButtons ? true : false);

	m_pNewVolume->SetHidePanels(0 != m_ctrlCheckHide.GetCheck());

	m_pNewVolume->SetLargerFont(0 != m_ctrlCheck10Point.GetCheck());

	m_pNewVolume->SetTruncate(0 != m_ctrlCheckTruncate.GetCheck());

	m_pNewVolume->SetLinks(0 != m_ctrlCheckLinks.GetCheck());

	m_pNewVolume->SetDelayDiscUntilTrack(0 != m_ctrlCheckDelayDiscsUntilTrack.GetCheck());

	m_pNewVolume->SetJumpAfterTrack(0 != m_ctrlCheckJumpAfterTrack.GetCheck());

	saveAndPopulateHard(true, false);

	//--

	int intCCLSel = m_ctrlComboLevels.GetCurSel();

	if (0 <= intCCLSel)
	{
		DWORD dwCCLSel = m_ctrlComboLevels.GetItemData(intCCLSel);

		m_pNewVolume->SetShowLetters(dwCCLSel & LEV_L ? true : false);
		m_pNewVolume->SetShowArtists(dwCCLSel & LEV_A ? true : false);
		m_pNewVolume->SetShowDiscs(  dwCCLSel & LEV_D ? true : false);
		m_pNewVolume->SetShowTracks( dwCCLSel & LEV_T ? true : false);
	}

	//--

	int intCCBSel = m_ctrlComboBreaks.GetCurSel();

	if (0 <= intCCBSel)
	{
		DWORD dwCCBSel = m_ctrlComboBreaks.GetItemData(intCCBSel);

		m_pNewVolume->SetGapBreakAlways(dwCCBSel & BRK_A ? true : false);
		m_pNewVolume->SetGapSpace(      dwCCBSel & BRK_S ? true : false);
		m_pNewVolume->SetGapFit(        dwCCBSel & BRK_F ? true : false);
	}

	// -- Try to add to/update the list. --

	CTypedError tError;

	const CSNVolume *pAddUpdateResult = NULL;

	if (NULL != m_pUpdateVolume)
	{
		pAddUpdateResult = m_pParentLibrary->SNUIT_UpdateVolume(m_pTreeDlg, &tError, m_pNewVolume, m_pUpdateVolume);
	}
	else
	{
		pAddUpdateResult = m_pParentLibrary->SNUIT_AddBelowAndOwnVolume(m_pTreeDlg, &tError, m_pNewVolume, m_pToAddBelow);
	}

	if (NULL == pAddUpdateResult)
	{
		MessageBox(CTypedError::SafeGetFullErrorTextTempBuffer(&tError),
				   NULL != m_pUpdateVolume ? "Cannot update list" : "Cannot add list",
				   MB_OK | MB_ICONEXCLAMATION);
	}
	else
	{
		if (NULL == m_pUpdateVolume)
		{
			// We no longer own the volume
			// and should not delete it on destruction.
			m_pNewVolume = NULL;
		}

		CSuckLessDialog::OnOK();
	}
}

void CListDlg::OnSelchangeComboLevels() 
{
	int intCCLSel = m_ctrlComboLevels.GetCurSel();

	if (0 <= intCCLSel)
	{
		DWORD dwCCLSel = m_ctrlComboLevels.GetItemData(intCCLSel);

		m_ctrlCheckDelayDiscsUntilTrack.EnableWindow((dwCCLSel & LEV_D) && (dwCCLSel & LEV_T));
		m_ctrlCheckJumpAfterTrack.EnableWindow(dwCCLSel & LEV_T);
	}
}
