#if !defined(AFX_LISTDLG_H__FFBCE8DF_1392_4C57_9636_3D4E3D4C3952__INCLUDED_)
#define AFX_LISTDLG_H__FFBCE8DF_1392_4C57_9636_3D4E3D4C3952__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ListDlg.h : header file
//

#include "SuckLessDialog.h"
#include "CSFPath.h"
#include "SNHardButtonDefinition.h"

class CSNVolume;
class ISNUITreeLibrary;
class CCSFAbstractTree;
class ISNUITreeDlg;

/////////////////////////////////////////////////////////////////////////////
// CListDlg dialog

class CListDlg : public CSuckLessDialog
{
// Construction
public:
	CListDlg(ISNUITreeDlg *pTreeDlg,
				const CSNVolume *pTemplateVolume, const CSNVolume *pUpdateVolume, const CSNVolume *pToAddBelow,
				ISNUITreeLibrary *pParentLibrary, const CCSFAbstractTree *pAbstractTree,
				CWnd* pParent);

	~CListDlg();


// Dialog Data
	//{{AFX_DATA(CListDlg)
	enum { IDD = IDD_LIST_DIALOG };
	CButton	m_ctrlCheckLinks;
	CButton	m_ctrlCheckTruncate;
	CButton	m_ctrlCheckJumpAfterTrack;
	CButton	m_ctrlCheckDelayDiscsUntilTrack;
	CComboBox	m_ctrlComboBreaks;
	CComboBox	m_ctrlComboLevels;
	CButton	m_ctrlCheckHide;
	CButton	m_ctrlCheck10Point;
	CButton	m_ctrlCheckHardJump;
	CListBox	m_ctrlListBoxHardAction;
	CEdit	m_ctrlEditHardJump;
	CButton	m_ctrlButtonHardLabel;
	CStatic	m_ctrlStaticHardLabel;
	CEdit	m_ctrlEditHardLabel;
	CTabCtrl	m_ctrlTabHard;
	CListBox	m_ctrlListBoxLinks;
	CEdit	m_ctrlEditName;
	CString	m_editName;
	BOOL	m_bCheckJump;
	BOOL	m_bCheckShowButtons;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CListDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	enum DATPathType
	{
		PATH_JUMP,
		PATH_JUMPHARD,
		PATH_LINK,
		PATH_LINKHARD
	};

	enum LEVEL_FLAGS
	{
		LEV_L = 1<<0,
		LEV_A = 1<<1,
		LEV_D = 1<<2,
		LEV_T = 1<<3
	};

	enum BREAK_FLAGS
	{
		BRK_A = 1<<0,
		BRK_S = 1<<1,
		BRK_F = 1<<2
	};

	const CSNVolume *m_pUpdateVolume;
	const CSNVolume *m_pToAddBelow;
	const CCSFAbstractTree *m_pAbstractTree;
	ISNUITreeLibrary *m_pParentLibrary;
	ISNUITreeDlg *m_pTreeDlg;

	CSNVolume *m_pNewVolume;

	CProntoString m_ATSelDlgDev;
	CProntoString m_ATSelDlgPan;
	CProntoString m_ATSelDlgBut;
	DATPathType m_ATPathType;
	const CCSFButtonPath *m_pATSelButPathEditing;
	int m_ATSelButPathEditingIdx;

	const CSNHardButtonDefinition *m_pHBIToUpdate;
	CSNHardButtonDefinition m_hbiEdited;
	map<int, const CSNHardButtonDefinition *> m_tabHardMap;

protected:
	void saveAndPopulateHard(bool bSaveOld, bool bPopulateNew);
	void csfPanelPathToStringGadget(int editIdent, const CCSFPanelPath *pPath);

	// SuckLessDialog:
	void virtual OnPseudoModalChildClose(int sldIDD, LPARAM lparam);

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CListDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnCheckJump();
	afx_msg void OnButtonJump();
	afx_msg void OnButtonName();
	virtual void OnOK();
	afx_msg void OnButtonLinkadd();
	afx_msg void OnButtonLinkdelete();
	afx_msg void OnButtonLinkedit();
	afx_msg void OnDblclkListLinks();
	afx_msg void OnButtonHardjump();
	afx_msg void OnButtonHardlabel();
	afx_msg void OnCheckHardjump();
	afx_msg void OnSelchangeTabHard(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnButtonHardactionadd();
	afx_msg void OnButtonHardactiondelete();
	afx_msg void OnButtonHardactiondown();
	afx_msg void OnButtonHardactionedit();
	afx_msg void OnButtonHardactionup();
	afx_msg void OnDblclkListHardaction();
	afx_msg void OnSelchangeComboLevels();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LISTDLG_H__FFBCE8DF_1392_4C57_9636_3D4E3D4C3952__INCLUDED_)
