// ListsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ListsDlg.h"
#include "ListDlg.h"
#include "ArtistDlg.h"
#include "DiscDlg.h"
#include "SNConfig.h"
#include "CCFWrapper.h"
#include "SNLibrary.h"
#include "ListingDlg.h"
#include "ReportDlg.h"
#include "ImportDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CListsDlg dialog


CListsDlg::CListsDlg(CSNConfig *pConfig, CCCFWrapper *pCCFWrapper, CWnd* pParent)
	: CSuckLessDialog(CListsDlg::IDD, pParent), m_slotReport(pConfig)
{
	//{{AFX_DATA_INIT(CListsDlg)
	//}}AFX_DATA_INIT

	m_pConfig = pConfig;
	m_pCCFWrapper = pCCFWrapper;

	m_bCancelAfterListing = false;
	m_bThreadResult = false;
}

void CListsDlg::DoDataExchange(CDataExchange* pDX)
{
	CSuckLessDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CListsDlg)
	DDX_Control(pDX, IDC_BUTTON_MOVEDOWN, m_ctrlButtonDown);
	DDX_Control(pDX, IDC_BUTTON_MOVEUP, m_ctrlButtonUp);
	DDX_Control(pDX, IDC_CHECK_KEEPSORTED, m_ctrlCheckKeepSorted);
	DDX_Control(pDX, IDC_BUTTON_SORT, m_ctrlButtonSort);
	DDX_Control(pDX, IDC_BUTTON_EDIT, m_ctrlButtonEdit);
	DDX_Control(pDX, IDC_BUTTON_DELETE, m_ctrlButtonDelete);
	DDX_Control(pDX, IDC_BUTTON_ADD, m_ctrlButtonAdd);
	DDX_Control(pDX, IDC_TREE_LISTS, m_ctrlTreeLists);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CListsDlg, CSuckLessDialog)
	//{{AFX_MSG_MAP(CListsDlg)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE_LISTS, OnSelchangedTreeLists)
	ON_BN_CLICKED(IDC_BUTTON_SORT, OnButtonSort)
	ON_BN_CLICKED(IDC_CHECK_KEEPSORTED, OnCheckKeepsorted)
	ON_BN_CLICKED(IDC_BUTTON_MOVEUP, OnButtonMoveup)
	ON_BN_CLICKED(IDC_BUTTON_MOVEDOWN, OnButtonMovedown)
	ON_BN_CLICKED(IDC_BUTTON_DELETE, OnButtonDelete)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_EDIT, OnButtonEdit)
	ON_NOTIFY(NM_DBLCLK, IDC_TREE_LISTS, OnDblclkTreeLists)
	ON_BN_CLICKED(IDC_BUTTON_IMPORT, OnButtonImport)
	ON_BN_CLICKED(IDC_BUTTON_REPORT, OnButtonReport)
	ON_BN_CLICKED(IDC_BUTTON_EXPORT, OnButtonExport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListsDlg message handlers

BOOL CListsDlg::OnInitDialog() 
{
	CSuckLessDialog::OnInitDialog();

	this->setWindowIcon(IDR_MAINFRAME);

	// -- Initial contents --

	m_treeImageList.Create(16, 16, ILC_MASK, 0, 4);
	m_treeImageList.Add(AfxGetApp()->LoadIcon(IDI_ICON_LIBRARY));
	m_treeImageList.Add(AfxGetApp()->LoadIcon(IDI_ICON_LIST));
	m_treeImageList.Add(AfxGetApp()->LoadIcon(IDI_ICON_FACE));
	m_treeImageList.Add(AfxGetApp()->LoadIcon(IDI_ICON_CD));
	m_ctrlTreeLists.SetImageList(&m_treeImageList, TVSIL_NORMAL);

	if (NULL != g_pProntoFont)
	{
		m_ctrlTreeLists.SetFont(g_pProntoFont);
	}

	populateTree();

	// -- Control setup --

	addControlInfo(IDC_STATIC_LISTS);
	addControlInfo(IDC_TREE_LISTS);
	addControlInfo(IDC_BUTTON_ADD);
	addControlInfo(IDC_BUTTON_EDIT);
	addControlInfo(IDC_BUTTON_DELETE);
	addControlInfo(IDC_BUTTON_SORT);
	addControlInfo(IDC_CHECK_KEEPSORTED);
	addControlInfo(IDC_BUTTON_MOVEUP);
	addControlInfo(IDC_BUTTON_MOVEDOWN);
	addControlInfo(IDC_BUTTON_HELP);
	addControlInfo(IDC_BUTTON_IMPORT);
	addControlInfo(IDC_BUTTON_EXPORT);
	addControlInfo(IDC_BUTTON_REPORT);
	addControlInfo(IDC_BUTTON_MANAGE);
	addControlInfo(IDOK);
	addControlInfo(IDCANCEL);
	
	setControlRelationship(IDC_STATIC_LISTS,		IDD,					CControlInfo::ACOMMON_RESIZEHEIGHT_RESIZEWIDTH);

	setControlRelationship(IDC_TREE_LISTS,			IDC_STATIC_LISTS,		CControlInfo::ACOMMON_RESIZEHEIGHT_RESIZEWIDTH);

	setControlRelationship(IDC_BUTTON_ADD,			IDC_STATIC_LISTS,		CControlInfo::ACOMMON_TOP_RIGHT);
	setControlRelationship(IDC_BUTTON_EDIT,			IDC_STATIC_LISTS,		CControlInfo::ACOMMON_TOP_RIGHT);
	setControlRelationship(IDC_BUTTON_DELETE,		IDC_STATIC_LISTS,		CControlInfo::ACOMMON_TOP_RIGHT);
	setControlRelationship(IDC_BUTTON_SORT,			IDC_STATIC_LISTS,		CControlInfo::ACOMMON_TOP_RIGHT);
	setControlRelationship(IDC_CHECK_KEEPSORTED,	IDC_STATIC_LISTS,		CControlInfo::ACOMMON_TOP_RIGHT);
	setControlRelationship(IDC_BUTTON_MOVEUP,		IDC_STATIC_LISTS,		CControlInfo::ACOMMON_TOP_RIGHT);
	setControlRelationship(IDC_BUTTON_MOVEDOWN,		IDC_STATIC_LISTS,		CControlInfo::ACOMMON_TOP_RIGHT);

	setControlRelationship(IDC_BUTTON_HELP,			IDD,					CControlInfo::ACOMMON_BOTTOM_LEFT);
	setControlRelationship(IDC_BUTTON_IMPORT,		IDD,					CControlInfo::ACOMMON_BOTTOM_LEFT);
	setControlRelationship(IDC_BUTTON_EXPORT,		IDD,					CControlInfo::ACOMMON_BOTTOM_LEFT);
	setControlRelationship(IDC_BUTTON_REPORT,		IDD,					CControlInfo::ACOMMON_BOTTOM_LEFT);
	setControlRelationship(IDC_BUTTON_MANAGE,		IDD,					CControlInfo::ACOMMON_BOTTOM_LEFT);

	setControlRelationship(IDOK,					IDD,					CControlInfo::ACOMMON_BOTTOM_RIGHT);
	setControlRelationship(IDCANCEL,				IDD,					CControlInfo::ACOMMON_BOTTOM_RIGHT);

	controlAndFrameInfoIsSetup();

	setMinXToCurrent();
	setMinYToCurrent();

	this->setRememberWindowPosition(SN_REG_PATH_WINDOWPOS, SN_REG_VALUE_WINDOWPOS_LISTS);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CListsDlg::populateTree(void)
{
	m_ctrlTreeLists.DeleteAllItems();
	m_itemTreeMap.clear();
	m_treeItemMap.clear();

	SNUIT_AddTreeItem(m_pConfig->GetLibrary(), NULL, NULL);
	m_pConfig->GetLibrary()->SNUIT_AddChildrenToTree(this);
	// Expand first two levels (everything except artists).
	expandTreeItemAndChildren(m_ctrlTreeLists.GetRootItem(), 2);
	// Ensure the root item is visible now.
	m_ctrlTreeLists.EnsureVisible(m_ctrlTreeLists.GetRootItem());
}

void CListsDlg::expandTreeItemAndChildren(HTREEITEM htiParent, unsigned int levels)
{
	if ((0 < levels) && (NULL != htiParent))
	{
		m_ctrlTreeLists.Expand(htiParent, TVE_EXPAND);

		if (m_ctrlTreeLists.ItemHasChildren(htiParent))
		{
			levels--;

			for (HTREEITEM htiChild = m_ctrlTreeLists.GetChildItem(htiParent);
				 NULL != htiChild;
				 htiChild = m_ctrlTreeLists.GetNextSiblingItem(htiChild))
			{
				expandTreeItemAndChildren(htiChild, levels);
			}
		}
	}
}

// NULL parent to insert at the root.
// NULL insertAfter to insert at the top.
bool CListsDlg::SNUIT_AddTreeItem(ISNUITreeItem *pTItem,
								  ISNUITreeItem *pTIParent, const ISNUITreeItem *pTIInsertAfter)
{
	bool bNoError = true;

	HTREEITEM htiParent = TVI_ROOT;
	HTREEITEM htiInsertAfter = TVI_FIRST;

	if ((bNoError) && (NULL != pTIParent))
	{
		const_itmIter iterParent = m_itemTreeMap.find(pTIParent);

		if (iterParent == m_itemTreeMap.end())
		{
			bNoError = false;
			MessageBox("Error adding item to tree, item not found in map", SUPERNUDELIST_ERROR_TITLE, MB_ICONSTOP|MB_OK);
		}
		else
		{
			htiParent = iterParent->second;
		}
	}

	if ((bNoError) && (NULL != pTIInsertAfter))
	{
		const_itmIter iterInsertAfter = m_itemTreeMap.find(pTIInsertAfter);

		if (iterInsertAfter == m_itemTreeMap.end())
		{
			bNoError = false;
			MessageBox("Error adding item to tree, item not found in map", SUPERNUDELIST_ERROR_TITLE, MB_ICONSTOP|MB_OK);
		}
		else
		{
			htiInsertAfter = iterInsertAfter->second;
		}
	}

	if (bNoError)
	{
		int imgIdx = pTItem->SNUIT_GetImageIdx(this);

		HTREEITEM htiAdded;

		htiAdded = m_ctrlTreeLists.InsertItem(TVIF_PARAM|TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE,
												pTItem->SNUIT_GetLabel(), imgIdx, imgIdx, 0, 0,
												(LPARAM)pTItem, htiParent, htiInsertAfter);

		if (NULL == htiAdded)
		{
			MessageBox("Error adding item to tree", SUPERNUDELIST_ERROR_TITLE, MB_ICONSTOP|MB_OK);
			bNoError = false;
		}
		else
		{
			m_treeItemMap.insert(timPair(htiAdded, pTItem));
			m_itemTreeMap.insert(itmPair(pTItem, htiAdded));
		}
	}

	return(bNoError);
}

bool CListsDlg::SNUIT_RemoveTreeItems(ISNUITreeItem *pTIParent, bool bKeepParent)
{
	bool bNoError = true;

	const_itmIter iterItem = m_itemTreeMap.find(pTIParent);

	if (iterItem == m_itemTreeMap.end())
	{
		MessageBox("Error removing item from tree, item not found in map", SUPERNUDELIST_ERROR_TITLE, MB_ICONSTOP|MB_OK);
		bNoError = false;
	}
	else
	{
		HTREEITEM htiParent = iterItem->second;

		while (m_ctrlTreeLists.ItemHasChildren(htiParent))
		{
			if (! removeTreeItemAndChildren(m_ctrlTreeLists.GetChildItem(htiParent)) )
			{
				bNoError = false;
				break;
			}
		}

		if (bNoError && (!bKeepParent))
		{
			if (! m_ctrlTreeLists.DeleteItem(htiParent) )
			{
				MessageBox("Error removing item from tree", SUPERNUDELIST_ERROR_TITLE, MB_ICONSTOP|MB_OK);
				bNoError = false;
			}
			else
			{
				m_itemTreeMap.erase(pTIParent);
				m_treeItemMap.erase(htiParent);
			}
		}
	}

	return(bNoError);
}

bool CListsDlg::removeTreeItemAndChildren(HTREEITEM htItem)
{
	bool bNoError = true;

	const_timIter iterItem = m_treeItemMap.find(htItem);

	if (iterItem == m_treeItemMap.end())
	{
		MessageBox("Error removing item from tree, item not found in map", SUPERNUDELIST_ERROR_TITLE, MB_ICONSTOP|MB_OK);
		bNoError = false;
	}
	else
	{
		ISNUITreeItem *pTItem = iterItem->second;

		while (m_ctrlTreeLists.ItemHasChildren(htItem))
		{
			if (! removeTreeItemAndChildren(m_ctrlTreeLists.GetChildItem(htItem)) )
			{
				bNoError = false;
				break;
			}
		}

		if (bNoError)
		{
			if (! m_ctrlTreeLists.DeleteItem(htItem) )
			{
				MessageBox("Error removing item from tree", SUPERNUDELIST_ERROR_TITLE, MB_ICONSTOP|MB_OK);
				bNoError = false;
			}
			else
			{
				m_itemTreeMap.erase(pTItem);
				m_treeItemMap.erase(htItem);
			}
		}
	}

	return(bNoError);
}

bool CListsDlg::SNUIT_SelectAndMakeVisibleTreeItem(const ISNUITreeItem *pTItem)
{
	bool bNoError = true;

	const_itmIter iterItem = m_itemTreeMap.find(pTItem);

	if (iterItem == m_itemTreeMap.end())
	{
		MessageBox("Error selecting item in tree, item not found in map", SUPERNUDELIST_ERROR_TITLE, MB_ICONSTOP|MB_OK);
		bNoError = false;
	}
	else
	{
		HTREEITEM htItem = iterItem->second;
		HTREEITEM htPrevSel = m_ctrlTreeLists.GetSelectedItem();

		m_ctrlTreeLists.EnsureVisible(htItem);

		if (! m_ctrlTreeLists.SelectItem(htItem) )
		{
			MessageBox("Error selecting item in tree", SUPERNUDELIST_ERROR_TITLE, MB_ICONSTOP|MB_OK);
			bNoError = false;
		}
		else if (htItem == htPrevSel)
		{
			// Called automatically if hItem != htPrevSel
			updateItemSpecificControls(pTItem);
		}
	}

	return(bNoError);
}

set<ISNUITreeItem *> *CListsDlg::SNUIT_GetExpandedItems(const ISNUITreeItem *pTIParent)
{
	set<ISNUITreeItem *> *pSetResult = new set<ISNUITreeItem *>;

	const_itmIter iterItem = m_itemTreeMap.find(pTIParent);

	if (iterItem != m_itemTreeMap.end())
	{
		getExpandedItems(pSetResult, iterItem->second);
	}

	return(pSetResult);
}

void CListsDlg::getExpandedItems(set<ISNUITreeItem *> *pSetResult, HTREEITEM htiParent)
{
	if (NULL != htiParent)
	{
		if (TVIS_EXPANDED & m_ctrlTreeLists.GetItemState(htiParent, TVIS_EXPANDED))
		{
			const_timIter iterItem = m_treeItemMap.find(htiParent);

			if (iterItem != m_treeItemMap.end())
			{
				pSetResult->insert(iterItem->second);
			}
		}

		if (m_ctrlTreeLists.ItemHasChildren(htiParent))
		{
			for (HTREEITEM htiChild = m_ctrlTreeLists.GetChildItem(htiParent);
				 NULL != htiChild;
				 htiChild = m_ctrlTreeLists.GetNextSiblingItem(htiChild))
			{
				getExpandedItems(pSetResult, htiChild);
			}
		}
	}
}

void CListsDlg::SNUIT_ExpandedItems(set<ISNUITreeItem *> *pExpandSet)
{
	for (set<ISNUITreeItem *>::const_iterator setIter = pExpandSet->begin();
		 setIter != pExpandSet->end();
		 setIter++)
	{
		const_itmIter iterItem = m_itemTreeMap.find(*setIter);

		if (iterItem != m_itemTreeMap.end())
		{
			m_ctrlTreeLists.Expand(iterItem->second, TVE_EXPAND);
		}
	}
}

bool CListsDlg::SNUIT_UpdateLabel(ISNUITreeItem *pTItem)
{
	bool bNoError = true;

	const_itmIter iterItem = m_itemTreeMap.find(pTItem);

	if (iterItem == m_itemTreeMap.end())
	{
		MessageBox("Error updating item in tree, item not found in map", SUPERNUDELIST_ERROR_TITLE, MB_ICONSTOP|MB_OK);
		bNoError = false;
	}
	else
	{
		HTREEITEM htItem = iterItem->second;

		if (! m_ctrlTreeLists.SetItemText(htItem, pTItem->SNUIT_GetLabel()) )
		{
			MessageBox("Error updating item in tree", SUPERNUDELIST_ERROR_TITLE, MB_ICONSTOP|MB_OK);
			bNoError = false;
		}
	}

	return(bNoError);
}

int CListsDlg::SNUIT_GetImageIdxRoot(void) const
{
	return(ILIDX_ROOT);
}

int CListsDlg::SNUIT_GetImageIdxList(void) const
{
	return(ILIDX_LIST);
}

int CListsDlg::SNUIT_GetImageIdxArtist(void) const
{
	return(ILIDX_ARTIST);
}

int CListsDlg::SNUIT_GetImageIdxDisc(void) const
{
	return(ILIDX_DISC);
}

void CListsDlg::OnSelchangedTreeLists(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	
	ISNUITreeItem *pTItem = NULL;

	if (pNMTreeView->itemNew.mask & TVIF_HANDLE)
	{
		const_timIter iterItem = m_treeItemMap.find(pNMTreeView->itemNew.hItem);

		if (iterItem != m_treeItemMap.end())
		{
			pTItem = iterItem->second;
		}
	}

	updateItemSpecificControls(pTItem);

	*pResult = 0;

}

void CListsDlg::updateItemSpecificControls(const ISNUITreeItem *pTItem)
{
	bool bEnableEdit		= false;
	bool bEnableDelete		= false;
	bool bEnableUp			= false;
	bool bEnableDown		= false;
	bool bEnableSort		= false;
	bool bEnableKeepSorted	= false;

	bool bKeepSorted = false;

	const char *szLabelAdd		= "Add";
	const char *szLabelEdit		= "Edit";
	const char *szLabelDelete	= "Delete";
	const char *szLabelSort		= "Sort";

	if (NULL != pTItem)
	{
		bEnableEdit			= pTItem->SNUIT_GetEditButtonActivation();
		bEnableDelete		= pTItem->SNUIT_GetDeleteButtonActivation();
		bEnableUp			= pTItem->SNUIT_GetUpButtonActivation();
		bEnableDown			= pTItem->SNUIT_GetDownButtonActivation();
		bEnableSort			= pTItem->SNUIT_GetSortButtonActivation();
		bEnableKeepSorted	= pTItem->SNUIT_GetKeepSortedCheckActivation();

		bKeepSorted		= pTItem->SNUIT_GetKeepSorted();

		szLabelAdd		= pTItem->SNUIT_GetAddButtonName();
		szLabelEdit		= pTItem->SNUIT_GetEditButtonName();
		szLabelDelete	= pTItem->SNUIT_GetDeleteButtonName();
		szLabelSort		= pTItem->SNUIT_GetSortButtonName();
	}

	m_ctrlButtonEdit		.EnableWindow(bEnableEdit		? TRUE : FALSE);
	m_ctrlButtonDelete		.EnableWindow(bEnableDelete		? TRUE : FALSE);
	m_ctrlButtonUp			.EnableWindow(bEnableUp			? TRUE : FALSE);
	m_ctrlButtonDown		.EnableWindow(bEnableDown		? TRUE : FALSE);
	m_ctrlButtonSort		.EnableWindow(bEnableSort		? TRUE : FALSE);
	m_ctrlCheckKeepSorted	.EnableWindow(bEnableKeepSorted	? TRUE : FALSE);

	m_ctrlCheckKeepSorted.SetCheck(bKeepSorted ? 1 : 0);

	m_ctrlButtonAdd.SetWindowText(szLabelAdd);
	m_ctrlButtonEdit.SetWindowText(szLabelEdit);
	m_ctrlButtonDelete.SetWindowText(szLabelDelete);
	m_ctrlButtonSort.SetWindowText(szLabelSort);
}

ISNUITreeItem *CListsDlg::getSelectedTreeItem(void)
{
	ISNUITreeItem *pTIResult = NULL;

	HTREEITEM htiSelected = m_ctrlTreeLists.GetSelectedItem();

	if (NULL != htiSelected)
	{
		const_timIter iterItem = m_treeItemMap.find(htiSelected);

		if (iterItem == m_treeItemMap.end())
		{
			MessageBox("Error finding selected tree item in map", SUPERNUDELIST_ERROR_TITLE, MB_ICONSTOP|MB_OK);
		}
		else
		{
			pTIResult = iterItem->second;
		}
	}

	return(pTIResult);
}

void CListsDlg::OnButtonSort() 
{
	ISNUITreeItem *pTISelected = getSelectedTreeItem();

	if (NULL != pTISelected)
	{
		pTISelected->SNUIT_PressedSortButton(this);
	}
}

void CListsDlg::OnCheckKeepsorted() 
{
	ISNUITreeItem *pTISelected = getSelectedTreeItem();

	if (NULL != pTISelected)
	{
		pTISelected->SNUIT_SetKeepSorted(this, m_ctrlCheckKeepSorted.GetCheck() ? true : false);

		updateItemSpecificControls(getSelectedTreeItem());
	}
}

void CListsDlg::OnButtonMoveup() 
{
	ISNUITreeItem *pTISelected = getSelectedTreeItem();
	
	if (NULL != pTISelected)
	{
		pTISelected->SNUIT_PressedUpButton(this);

		updateItemSpecificControls(getSelectedTreeItem());
	}
}

void CListsDlg::OnButtonMovedown() 
{
	ISNUITreeItem *pTISelected = getSelectedTreeItem();

	if (NULL != pTISelected)
	{
		pTISelected->SNUIT_PressedDownButton(this);

		updateItemSpecificControls(getSelectedTreeItem());
	}
}

void CListsDlg::OnButtonDelete() 
{
	ISNUITreeItem *pTISelected = getSelectedTreeItem();

	if (NULL != pTISelected)
	{
		CString csConfirmMsg = pTISelected->SNUIT_GetDeleteConfirmMessage();

		if (csConfirmMsg.IsEmpty()	\
		||	(IDYES == MessageBox(csConfirmMsg, "Are you sure?", MB_YESNO | MB_ICONQUESTION)))
		{
			pTISelected->SNUIT_PressedDeleteButton(this);

			updateItemSpecificControls(getSelectedTreeItem());
		}
	}	
}

void CListsDlg::OnButtonAdd() 
{
	ISNUITreeItem *pTISelected = getSelectedTreeItem();

	if (NULL != pTISelected)
	{
		pTISelected->SNUIT_PressedAddButton(this);
	}	
}

void CListsDlg::OnButtonEdit() 
{
	ISNUITreeItem *pTISelected = getSelectedTreeItem();

	if (NULL != pTISelected)
	{
		pTISelected->SNUIT_PressedEditButton(this);
	}	
}

void CListsDlg::SNUIT_AsyncAddList(ISNUITreeLibrary *pParent, const CSNVolume *pAddBelow)
{
	CListDlg *pSLDlg = new CListDlg(this, NULL, NULL, pAddBelow, pParent,
									m_pCCFWrapper->GetCSFAbstractTree(), this);
	this->openPseudoModalChild(pSLDlg, CListDlg::IDD, false, true);
}

void CListsDlg::SNUIT_AsyncEditList(ISNUITreeLibrary *pParent, const CSNVolume *pList)
{
	CListDlg *pSLDlg = new CListDlg(this, pList, pList, NULL, pParent,
									m_pCCFWrapper->GetCSFAbstractTree(), this);
	this->openPseudoModalChild(pSLDlg, CListDlg::IDD, false, true);
}

void CListsDlg::SNUIT_AsyncAddArtist(ISNUITreeVolume *pParent, const CSNArtist *pAddBelow)
{
	CArtistDlg *pSLDlg = new CArtistDlg(this, NULL, NULL, pAddBelow, NULL, pParent, this);
	this->openPseudoModalChild(pSLDlg, CArtistDlg::IDD, false, true);
}

void CListsDlg::SNUIT_AsyncEditArtist(ISNUITreeVolume *pParent, const CSNArtist *pArtist)
{
	CArtistDlg *pSLDlg = new CArtistDlg(this, pArtist, pArtist, NULL, NULL, pParent, this);
	this->openPseudoModalChild(pSLDlg, CArtistDlg::IDD, false, true);
}

void CListsDlg::SNUIT_AsyncAddDisc(const CSNLibrary *pLibrary, ISNUITreeVolume *pParentVolume, ISNUITreeArtist *pParentArtist, const CSNDisc *pAddBelow, const CSNDevice *pDevice)
{
	CDiscDlg *pSLDlg = new CDiscDlg(this, NULL, NULL, pAddBelow, pParentVolume, pParentArtist, m_pConfig->GetDevices(), pDevice, pLibrary, this);
	this->openPseudoModalChild(pSLDlg, CDiscDlg::IDD, false, true);
}

void CListsDlg::SNUIT_AsyncEditDisc(const CSNLibrary *pLibrary, ISNUITreeVolume *pParentVolume, ISNUITreeArtist *pParentArtist, const CSNDisc *pDisc)
{
	CDiscDlg *pSLDlg = new CDiscDlg(this, pDisc, pDisc, NULL, pParentVolume, pParentArtist, m_pConfig->GetDevices(), NULL, pLibrary, this);
	this->openPseudoModalChild(pSLDlg, CDiscDlg::IDD, false, true);
}

void CListsDlg::OnOK() 
{
	if (m_pConfig->GetLibrary()->IsDirty())
	{
		m_bThreadResult = true;
		CTypedError::SafeReset(&m_threadTError);
		m_threadErrorList.RemoveAll();

		CPDTListDlgSave *pThread = new CPDTListDlgSave(&m_bThreadResult, &m_threadErrorList,
														 &m_threadTError, m_pConfig);

		CProgressDlg *pProgDlg = new CProgressDlg(PROGD_FRAME_NOPROG, false, pThread, this);
		this->openPseudoModalChild(pProgDlg, CProgressDlg::IDD, false, true);
	}
	else
	{
		CSuckLessDialog::OnOK();
	}
}

void CListsDlg::OnCancel() 
{
	if (m_pConfig->GetLibrary()->IsDirty())
	{
		if (IDYES == MessageBox("Discard your changes?", "Are you sure?", MB_YESNO | MB_ICONQUESTION))
		{
			m_bThreadResult = true;
			CTypedError::SafeReset(&m_threadTError);
			m_threadErrorList.RemoveAll();

			CPDTListDlgReLoad *pThread = new CPDTListDlgReLoad(&m_bThreadResult, &m_threadErrorList,
																 &m_threadTError, m_pConfig);

			CProgressDlg *pProgDlg = new CProgressDlg(PROGD_FRAME_NOPROG, false, pThread, this);
			this->openPseudoModalChild(pProgDlg, CProgressDlg::IDD, false, true);
		}
	}
	else
	{
		CSuckLessDialog::OnCancel();
	}
}

void CListsDlg::OnPseudoModalChildClose(int sldIDD, LPARAM lparam)
{
	if ((CProgressDlg::IDD == sldIDD)			\
	&&	((SLDTHREADID_LISTDLGSAVE == lparam)	\
	||	 (SLDTHREADID_LISTDLGRELOAD == lparam))	)
	{
		if (!m_bThreadResult)
		{
			if (m_threadErrorList.IsEmpty())
			{
				MessageBox(CTypedError::SafeGetFullErrorTextTempBuffer(&m_threadTError), SUPERNUDELIST_ERROR_TITLE, MB_ICONEXCLAMATION);

				if (SLDTHREADID_LISTDLGRELOAD == lparam)
				{
					CSuckLessDialog::OnCancel();
				}
			}
			else
			{
				m_bCancelAfterListing = (SLDTHREADID_LISTDLGRELOAD == lparam);

				CListingDlg *pSLDlg = new CListingDlg(SUPERNUDELIST_ERROR_TITLE,
														CTypedError::SafeGetFullErrorTextTempBuffer(&m_threadTError),
														&m_threadErrorList, false, this);
				this->openPseudoModalChild(pSLDlg, CListingDlg::IDD, false, true);
			}
		}
		else
		{
			if (SLDTHREADID_LISTDLGSAVE == lparam)
			{
				CSuckLessDialog::OnOK();
			}
			else if (SLDTHREADID_LISTDLGRELOAD == lparam)
			{
				CSuckLessDialog::OnCancel();
			}
		}
	}
	else if (CListingDlg::IDD == sldIDD)
	{
		m_threadErrorList.RemoveAll();

		if (m_bCancelAfterListing)
		{
			CSuckLessDialog::OnCancel();
		}
	}
	else if ((CProgressDlg::IDD == sldIDD) && (SLDTHREADID_LISTDLGSLOTREPORT == lparam))
	{
		CReportDlg *pSLDlg = new CReportDlg(&m_slotReport, this);
		this->openPseudoModalChild(pSLDlg, CReportDlg::IDD, false, true);
	}
	else if (CReportDlg::IDD == sldIDD)
	{
		m_slotReport.Reset(); // Free memory.
	}
	else if (CImportDlg::IDD == sldIDD) // Imports and Exports, FWIW.
	{
		populateTree();
	}
}

void CListsDlg::OnDblclkTreeLists(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// Make sure they double-clicked on the selected item.
	// Without this the user can select an item and double-click
	// a +/- box to expand/collapse an item and we think they
	// double-clicked something they were nowhere near pointing at.

	DWORD mPos = ::GetMessagePos();
	POINTS points = MAKEPOINTS(mPos);

	TVHITTESTINFO hitTest;
	ZeroMemory(&hitTest, sizeof(hitTest));
	hitTest.pt.x = points.x;
	hitTest.pt.y = points.y;

	m_ctrlTreeLists.ScreenToClient(&hitTest.pt);
	
	HTREEITEM htiPoint = m_ctrlTreeLists.HitTest(&hitTest);
	HTREEITEM htiSelected = m_ctrlTreeLists.GetSelectedItem();

	if ((NULL != htiPoint) && (htiPoint == htiSelected) && (TVHT_ONITEM&(hitTest.flags)))
	{
		// Don't edit items with children; expand / collapse them (done by tree ctrl).
		if (! m_ctrlTreeLists.ItemHasChildren(htiSelected) )
		{
			ISNUITreeItem *pTItem = getSelectedTreeItem();

			if ((NULL != pTItem) && pTItem->SNUIT_GetEditButtonActivation())
			{
				pTItem->SNUIT_PressedEditButton(this);
			}
		}
	}

	*pResult = 0;
}

void CListsDlg::OnButtonImport() 
{
	CImportDlg *pImportDlg = new CImportDlg(true, m_pConfig, this);
	this->openPseudoModalChild(pImportDlg, CImportDlg::IDD, false, true);
}

void CListsDlg::OnButtonExport() 
{
	CImportDlg *pImportDlg = new CImportDlg(false, m_pConfig, this);
	this->openPseudoModalChild(pImportDlg, CImportDlg::IDD, false, true);
}

void CListsDlg::OnButtonReport() 
{
	CPDTListDlgSlotReport *pThread = new CPDTListDlgSlotReport(&m_slotReport);

	CProgressDlg *pProgDlg = new CProgressDlg(PROGD_FRAME_NOPROG, false, pThread, this);
	this->openPseudoModalChild(pProgDlg, CProgressDlg::IDD, false, true);
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

CPDTListDlgSave::CPDTListDlgSave(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
									CSNConfig *pConfig) : CProgressDlgThread()
{
	m_pbThreadResult = pbThreadResult;
	m_pStrLstLog = pStrLstLog;
	m_pThreadTError = pThreadTError;

	m_pConfig = pConfig;
}

CPDTListDlgSave::~CPDTListDlgSave(void)
{
}

// Returns an ident for the thread.
// Typically, each implementation of this class within a project will use a unique
// ident. (-1) should not be used, but any other number is fine.
// See CSuckLessDialog::OnThreadTermination().
int CPDTListDlgSave::GetIdent(void)
{
	return(SLDTHREADID_LISTDLGSAVE);
}

// Overriden to provide functionality.
void CPDTListDlgSave::mainThreadSubClass(void)
{
	(*m_pbThreadResult) = false;

	SetProgressTitle("Saving changes...");

	SetProgressHeading("Saving Library");
	SetProgressMessage("");

	if (m_pConfig->SaveLibrary(m_pThreadTError, NULL))
	{
		(*m_pbThreadResult) = true;
	}
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

CPDTListDlgReLoad::CPDTListDlgReLoad(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
									CSNConfig *pConfig) : CProgressDlgThread()
{
	m_pbThreadResult = pbThreadResult;
	m_pStrLstLog = pStrLstLog;
	m_pThreadTError = pThreadTError;

	m_pConfig = pConfig;
}

CPDTListDlgReLoad::~CPDTListDlgReLoad(void)
{
}

// Returns an ident for the thread.
// Typically, each implementation of this class within a project will use a unique
// ident. (-1) should not be used, but any other number is fine.
// See CSuckLessDialog::OnThreadTermination().
int CPDTListDlgReLoad::GetIdent(void)
{
	return(SLDTHREADID_LISTDLGRELOAD);
}

// Overriden to provide functionality.
void CPDTListDlgReLoad::mainThreadSubClass(void)
{
	(*m_pbThreadResult) = false;

	SetProgressTitle("Cancelling changes...");

	SetProgressHeading("Re-loading Library");
	SetProgressMessage("");

	if (m_pConfig->LoadLibrary(m_pThreadTError, m_pStrLstLog, NULL))
	{
		(*m_pbThreadResult) = true;
	}
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

CPDTListDlgSlotReport::CPDTListDlgSlotReport(CSlotReport *pSlotReport)
{
	m_pSlotReport = pSlotReport;
}

CPDTListDlgSlotReport::~CPDTListDlgSlotReport(void)
{
}

// Returns an ident for the thread.
// Typically, each implementation of this class within a project will use a unique
// ident. (-1) should not be used, but any other number is fine.
// See CSuckLessDialog::OnThreadTermination().
int CPDTListDlgSlotReport::GetIdent(void)
{
	return(SLDTHREADID_LISTDLGSLOTREPORT);
}

// Overriden to provide functionality.
void CPDTListDlgSlotReport::mainThreadSubClass(void)
{
	SetProgressTitle("Generating Slot Report...");

	SetProgressHeading("Please wait");
	SetProgressMessage("");

	m_pSlotReport->Generate();
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
