#if !defined(AFX_LISTSDLG_H__DA174216_C58F_45E0_A791_1ED414617763__INCLUDED_)
#define AFX_LISTSDLG_H__DA174216_C58F_45E0_A791_1ED414617763__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ListsDlg.h : header file
//
#include "SuckLessDialog.h"
#include "SNUITree.h"
#include "ProgressDlg.h"
#include "SlotReport.h"

/////////////////////////////////////////////////////////////////////////////
// CListsDlg dialog

class CSNConfig;
class CCCFWrapper;

class CListsDlg : public CSuckLessDialog, public ISNUITreeDlg
{
// Construction
public:
	CListsDlg(CSNConfig *pConfig, CCCFWrapper *pCCFWrapper, CWnd* pParent);

// Dialog Data
	//{{AFX_DATA(CListsDlg)
	enum { IDD = IDD_LISTS_DIALOG };
	CButton	m_ctrlButtonDown;
	CButton	m_ctrlButtonUp;
	CButton	m_ctrlCheckKeepSorted;
	CButton	m_ctrlButtonSort;
	CButton	m_ctrlButtonEdit;
	CButton	m_ctrlButtonDelete;
	CButton	m_ctrlButtonAdd;
	CTreeCtrl	m_ctrlTreeLists;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CListsDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CSNConfig *m_pConfig;
	CCCFWrapper *m_pCCFWrapper;

	bool m_bCancelAfterListing;

	bool m_bThreadResult;
	CTypedError m_threadTError;
	CStringList m_threadErrorList;

	CSlotReport m_slotReport;

	CImageList m_treeImageList;

	typedef map<const ISNUITreeItem *, HTREEITEM>::const_iterator const_itmIter;
	typedef pair<const ISNUITreeItem *, HTREEITEM> itmPair;
	map<const ISNUITreeItem *, HTREEITEM> m_itemTreeMap;

	typedef map<HTREEITEM, ISNUITreeItem *>::const_iterator const_timIter;
	typedef pair<HTREEITEM, ISNUITreeItem *> timPair;
	map<HTREEITEM, ISNUITreeItem *> m_treeItemMap;

	enum
	{
		ILIDX_ROOT		= 0,
		ILIDX_LIST		= 1,
		ILIDX_ARTIST	= 2,
		ILIDX_DISC		= 3
	};

protected:
	void populateTree(void);
	void expandTreeItemAndChildren(HTREEITEM htiParent, unsigned int levels);
	bool removeTreeItemAndChildren(HTREEITEM htItem);
	ISNUITreeItem *getSelectedTreeItem(void);
	void updateItemSpecificControls(const ISNUITreeItem *pTItem);
	void getExpandedItems(set<ISNUITreeItem *> *pSetResult, HTREEITEM htiParent);

	// SuckLessDialog:
	void virtual OnPseudoModalChildClose(int sldIDD, LPARAM lparam);

public:
	// ISNUITreeDlg functions

	// NULL parent to insert at the root.
	// NULL insertAfter to insert at the top.
	bool SNUIT_AddTreeItem(ISNUITreeItem *pTItem,
							ISNUITreeItem *pTIParent, const ISNUITreeItem *pTIInsertAfter);

	bool SNUIT_RemoveTreeItems(ISNUITreeItem *pTIParent, bool bKeepParent);

	bool SNUIT_SelectAndMakeVisibleTreeItem(const ISNUITreeItem *pTItem);

	set<ISNUITreeItem *> *SNUIT_GetExpandedItems(const ISNUITreeItem *pTIParent);
	void SNUIT_ExpandedItems(set<ISNUITreeItem *> *pExpandSet);

	bool SNUIT_UpdateLabel(ISNUITreeItem *pTItem);

	int SNUIT_GetImageIdxRoot(void) const;
	int SNUIT_GetImageIdxList(void) const;
	int SNUIT_GetImageIdxArtist(void) const;
	int SNUIT_GetImageIdxDisc(void) const;

	void SNUIT_AsyncAddList(ISNUITreeLibrary *pParent, const CSNVolume *pAddBelow);
	void SNUIT_AsyncAddArtist(ISNUITreeVolume *pParent, const CSNArtist *pAddBelow);
	void SNUIT_AsyncAddDisc(const CSNLibrary *pLibrary, ISNUITreeVolume *pParentVolume, ISNUITreeArtist *pParentArtist, const CSNDisc *pAddBelow,const CSNDevice *pDevice);

	void SNUIT_AsyncEditList(ISNUITreeLibrary *pParent, const CSNVolume *pList);
	void SNUIT_AsyncEditArtist(ISNUITreeVolume *pParent, const CSNArtist *pArtist);
	void SNUIT_AsyncEditDisc(const CSNLibrary *pLibrary, ISNUITreeVolume *pParentVolume, ISNUITreeArtist *pParentArtist, const CSNDisc *pDisc);


protected:
	// Generated message map functions
	//{{AFX_MSG(CListsDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnHelpAbout();
	afx_msg void OnSelchangedTreeLists(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnButtonSort();
	afx_msg void OnCheckKeepsorted();
	afx_msg void OnButtonMoveup();
	afx_msg void OnButtonMovedown();
	afx_msg void OnButtonDelete();
	afx_msg void OnButtonAdd();
	afx_msg void OnButtonEdit();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnDblclkTreeLists(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnButtonImport();
	afx_msg void OnButtonReport();
	afx_msg void OnButtonExport();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

class CPDTListDlgSave : public CProgressDlgThread
{
public:

	CPDTListDlgSave(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
					 CSNConfig *pConfig);
	virtual ~CPDTListDlgSave(void);

	// Returns an ident for the thread.
	// Typically, each implementation of this class within a project will use a unique
	// ident. (-1) should not be used, but any other number is fine.
	// See CSuckLessDialog::OnThreadTermination().
	int GetIdent(void);

protected:
	bool *m_pbThreadResult;
	CStringList *m_pStrLstLog;
	CTypedError *m_pThreadTError;

	CSNConfig *m_pConfig;

	// Overriden to provide functionality.
	void mainThreadSubClass(void);
};

/////////////////////////////////////////////////////////////////////////////

class CPDTListDlgReLoad : public CProgressDlgThread
{
public:

	CPDTListDlgReLoad(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
					 CSNConfig *pConfig);
	virtual ~CPDTListDlgReLoad(void);

	// Returns an ident for the thread.
	// Typically, each implementation of this class within a project will use a unique
	// ident. (-1) should not be used, but any other number is fine.
	// See CSuckLessDialog::OnThreadTermination().
	int GetIdent(void);

protected:
	bool *m_pbThreadResult;
	CStringList *m_pStrLstLog;
	CTypedError *m_pThreadTError;

	CSNConfig *m_pConfig;

	// Overriden to provide functionality.
	void mainThreadSubClass(void);
};

/////////////////////////////////////////////////////////////////////////////

class CPDTListDlgImport : public CProgressDlgThread
{
public:

	CPDTListDlgImport(bool *pbThreadResult, CTypedError *pThreadTError,
					 CSNConfig *pConfig, CString filename);
	virtual ~CPDTListDlgImport(void);

	// Returns an ident for the thread.
	// Typically, each implementation of this class within a project will use a unique
	// ident. (-1) should not be used, but any other number is fine.
	// See CSuckLessDialog::OnThreadTermination().
	int GetIdent(void);

protected:
	bool *m_pbThreadResult;
	CTypedError *m_pThreadTError;
	CSNConfig *m_pConfig;
	CString m_csFilename;

	// Overriden to provide functionality.
	void mainThreadSubClass(void);
};

/////////////////////////////////////////////////////////////////////////////

class CPDTListDlgSlotReport : public CProgressDlgThread
{
public:

	CPDTListDlgSlotReport(CSlotReport *pSlotReport);
	virtual ~CPDTListDlgSlotReport(void);

	// Returns an ident for the thread.
	// Typically, each implementation of this class within a project will use a unique
	// ident. (-1) should not be used, but any other number is fine.
	// See CSuckLessDialog::OnThreadTermination().
	int GetIdent(void);

protected:
	CSlotReport *m_pSlotReport;

	// Overriden to provide functionality.
	void mainThreadSubClass(void);
};

/////////////////////////////////////////////////////////////////////////////


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LISTSDLG_H__DA174216_C58F_45E0_A791_1ED414617763__INCLUDED_)
