#if !defined(AFX_REPORTDLG_H__96014204_B732_413B_875B_87117C32FFED__INCLUDED_)
#define AFX_REPORTDLG_H__96014204_B732_413B_875B_87117C32FFED__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ReportDlg.h : header file
//
#include "SuckLessDialog.h"
#include "SortableListCtrl.h"

class CSlotReport;

/////////////////////////////////////////////////////////////////////////////
// CReportDlg dialog

class CReportDlg : public CSuckLessDialog
{
// Construction
public:
	CReportDlg(CSlotReport *pSlotReport, CWnd* pParent);

// Dialog Data
	//{{AFX_DATA(CReportDlg)
	enum { IDD = IDD_REPORT_DIALOG };
	CTabCtrl	m_ctrlTabReports;
	CSortableListCtrl	m_ctrlListReport;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CReportDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	enum
	{
		LIST_COL_DEVICE = 0,
		LIST_COL_NUMBER,
		LIST_COL_DISC1,
		LIST_COL_DISC2
	};

	enum
	{
		TAB_LOWEST = 0,
		TAB_HIGHEST,
		TAB_GAPS,
		TAB_DUPLICATES,
		TAB_ALL
	};

	bool m_bInitDone;

	CSlotReport *m_pSlotReport;
	map< int, pair<const CSNDisc *, const CSNDisc *> > m_colDiscsMap;

protected:
	void populateListLowest(void);
	void populateListHighest(void);
	void populateListGaps(void);
	void populateListDuplicates(void);
	void populateListAll(void);

	void noteEmptyList(const char *msg);

	bool addDiscToList(int *pIdx, const char *device, const CSNDisc *pDisc1, const CSNDisc *pDisc2);

	static int CALLBACK nudelSLSortCallbackDisc1Column(CSortableListCtrl *pList,
														LPARAM lParam1, LPARAM lParam2,
														int idx1, int idx2, void *pVoid);

	static int CALLBACK nudelSLSortCallbackDisc2Column(CSortableListCtrl *pList,
														LPARAM lParam1, LPARAM lParam2,
														int idx1, int idx2, void *pVoid);

	// SuckLessDialog
	void OnSizeHookEnd(void);

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CReportDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeTabReports(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_REPORTDLG_H__96014204_B732_413B_875B_87117C32FFED__INCLUDED_)
