// CSVLine.cpp: implementation of the CSNCSVLine class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SNCSVLine.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


int SSNCSVMap::GetMaxCol(void) const
{
	int nMax = 0;

	if (nMax < m_nColListName)			nMax = m_nColListName;
	if (nMax < m_nColSNDevName)			nMax = m_nColSNDevName;
	if (nMax < m_nColArtistName)		nMax = m_nColArtistName;
	if (nMax < m_nColArtistShortName)	nMax = m_nColArtistShortName;
	if (nMax < m_nColArtistSortAsName)	nMax = m_nColArtistSortAsName;
	if (nMax < m_nColDiscNumber)		nMax = m_nColDiscNumber;
	if (nMax < m_nColDiscName)			nMax = m_nColDiscName;
	if (nMax < m_nColDiscShortName)		nMax = m_nColDiscShortName;
	if (nMax < m_nColDiscSortAsName)	nMax = m_nColDiscSortAsName;
	if (nMax < m_nColTrackNumber)		nMax = m_nColTrackNumber;
	if (nMax < m_nColTrackName)			nMax = m_nColTrackName;

	return(nMax);
}

// Returns zero if there are none.
int SSNCSVMap::GetFirstColWithDuplicates(void) const
{
	int nResult = 0;

	int nColumns = this->GetMaxCol();

	int *colCounts = new int[nColumns];

	for (int i = 0; i < nColumns; i++)
	{
		colCounts[i] = 0;
	}

	if (0 != m_nColListName)			colCounts[m_nColListName-1]++;
	if (0 != m_nColSNDevName)			colCounts[m_nColSNDevName-1]++;
	if (0 != m_nColArtistName)			colCounts[m_nColArtistName-1]++;
	if (0 != m_nColArtistShortName)		colCounts[m_nColArtistShortName-1]++;
	if (0 != m_nColArtistSortAsName)	colCounts[m_nColArtistSortAsName-1]++;
	if (0 != m_nColDiscNumber)			colCounts[m_nColDiscNumber-1]++;
	if (0 != m_nColDiscName)			colCounts[m_nColDiscName-1]++;
	if (0 != m_nColDiscShortName)		colCounts[m_nColDiscShortName-1]++;
	if (0 != m_nColDiscSortAsName)		colCounts[m_nColDiscSortAsName-1]++;
	if (0 != m_nColTrackNumber)			colCounts[m_nColTrackNumber-1]++;
	if (0 != m_nColTrackName)			colCounts[m_nColTrackName-1]++;

	for (/*int*/ i = 0; i < nColumns; i++)
	{
		if (1 < colCounts[i])
		{
			nResult = i + 1;
		}
	}

	delete [] colCounts;

	return(nResult);
}


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSNCSVLine::CSNCSVLine(const SSNCSVMap *pMap)
:	m_pMap(pMap),
	m_bColListName(false),
	m_bColSNDevName(false),
	m_bColArtistName(false),
	m_bColArtistShortName(false),
	m_bColArtistSortAsName(false),
	m_bColDiscNumber(false),
	m_bColDiscName(false),
	m_bColDiscShortName(false),
	m_bColDiscSortAsName(false),
	m_bColTrackNumber(false),
	m_bColTrackName(false)
{

}

CSNCSVLine::~CSNCSVLine()
{

}

void CSNCSVLine::Set(const CSNCSVLine *pToCopy)
{
	if (this != pToCopy)
	{
		*this = *pToCopy; // Default assignment operator.
	}
}

bool CSNCSVLine::IsReady(void) const
{
	if ((0 == m_pMap->m_nColListName			|| m_bColListName)
	&&	(0 == m_pMap->m_nColSNDevName			|| m_bColSNDevName)
	&&	(0 == m_pMap->m_nColArtistName			|| m_bColArtistName)
	&&	(0 == m_pMap->m_nColArtistShortName		|| m_bColArtistShortName)
	&&	(0 == m_pMap->m_nColArtistSortAsName	|| m_bColArtistSortAsName)
	&&	(0 == m_pMap->m_nColDiscNumber			|| m_bColDiscNumber)
	&&	(0 == m_pMap->m_nColDiscName			|| m_bColDiscName)
	&&	(0 == m_pMap->m_nColDiscShortName		|| m_bColDiscShortName)
	&&	(0 == m_pMap->m_nColDiscSortAsName		|| m_bColDiscSortAsName)
	&&	(0 == m_pMap->m_nColTrackNumber			|| m_bColTrackNumber)
	&&	(0 == m_pMap->m_nColTrackName			|| m_bColTrackName))
	{
		return(true);
	}
	else
	{
		return(false);
	}
}

void CSNCSVLine::AddToCSVFile(CCSVFile *pCSVFile) const
{
	CCSVFile::lineIter lIter = pCSVFile->NewLine();

	if (m_bColListName)			pCSVFile->SetLineColumn(lIter, m_pMap->m_nColListName - 1,			m_strColListName.c_str());
	if (m_bColSNDevName)		pCSVFile->SetLineColumn(lIter, m_pMap->m_nColSNDevName - 1,			m_strColSNDevName.c_str());
	if (m_bColArtistName)		pCSVFile->SetLineColumn(lIter, m_pMap->m_nColArtistName - 1,		m_strColArtistName.c_str());
	if (m_bColArtistShortName)	pCSVFile->SetLineColumn(lIter, m_pMap->m_nColArtistShortName - 1,	m_strColArtistShortName.c_str());
	if (m_bColArtistSortAsName)	pCSVFile->SetLineColumn(lIter, m_pMap->m_nColArtistSortAsName - 1,	m_strColArtistSortAsName.c_str());
	if (m_bColDiscNumber)		pCSVFile->SetLineColumn(lIter, m_pMap->m_nColDiscNumber - 1,		m_strColDiscNumber.c_str());
	if (m_bColDiscName)			pCSVFile->SetLineColumn(lIter, m_pMap->m_nColDiscName - 1,			m_strColDiscName.c_str());
	if (m_bColDiscShortName)	pCSVFile->SetLineColumn(lIter, m_pMap->m_nColDiscShortName - 1,		m_strColDiscShortName.c_str());
	if (m_bColDiscSortAsName)	pCSVFile->SetLineColumn(lIter, m_pMap->m_nColDiscSortAsName - 1,	m_strColDiscSortAsName.c_str());
	if (m_bColTrackNumber)		pCSVFile->SetLineColumn(lIter, m_pMap->m_nColTrackNumber - 1,		m_strColTrackNumber.c_str());
	if (m_bColTrackName)		pCSVFile->SetLineColumn(lIter, m_pMap->m_nColTrackName - 1,			m_strColTrackName.c_str());
}

void CSNCSVLine::GetFromCSVFile(const CCSVFile *pCSVFile, CCSVFile::const_lineIter lIter)
{
	if (0 != m_pMap->m_nColListName)			{ m_strColListName			= pCSVFile->GetLineColumn(lIter, m_pMap->m_nColListName - 1); }
	if (0 != m_pMap->m_nColSNDevName)			{ m_strColSNDevName			= pCSVFile->GetLineColumn(lIter, m_pMap->m_nColSNDevName - 1); }
	if (0 != m_pMap->m_nColArtistName)			{ m_strColArtistName		= pCSVFile->GetLineColumn(lIter, m_pMap->m_nColArtistName - 1); }
	if (0 != m_pMap->m_nColArtistShortName)		{ m_strColArtistShortName	= pCSVFile->GetLineColumn(lIter, m_pMap->m_nColArtistShortName - 1); }
	if (0 != m_pMap->m_nColArtistSortAsName)	{ m_strColArtistSortAsName	= pCSVFile->GetLineColumn(lIter, m_pMap->m_nColArtistSortAsName - 1); }
	if (0 != m_pMap->m_nColDiscNumber)			{ m_strColDiscNumber		= pCSVFile->GetLineColumn(lIter, m_pMap->m_nColDiscNumber - 1); }
	if (0 != m_pMap->m_nColDiscName)			{ m_strColDiscName			= pCSVFile->GetLineColumn(lIter, m_pMap->m_nColDiscName - 1); }
	if (0 != m_pMap->m_nColDiscShortName)		{ m_strColDiscShortName		= pCSVFile->GetLineColumn(lIter, m_pMap->m_nColDiscShortName - 1); }
	if (0 != m_pMap->m_nColDiscSortAsName)		{ m_strColDiscSortAsName	= pCSVFile->GetLineColumn(lIter, m_pMap->m_nColDiscSortAsName - 1); }
	if (0 != m_pMap->m_nColTrackNumber)			{ m_strColTrackNumber		= pCSVFile->GetLineColumn(lIter, m_pMap->m_nColTrackNumber - 1); }
	if (0 != m_pMap->m_nColTrackName)			{ m_strColTrackName			= pCSVFile->GetLineColumn(lIter, m_pMap->m_nColTrackName - 1); }

	m_bColListName			= (0 < m_strColListName.length());
	m_bColSNDevName			= (0 < m_strColSNDevName.length());
	m_bColArtistName		= (0 < m_strColArtistName.length());
	m_bColArtistShortName	= (0 < m_strColArtistShortName.length());
	m_bColArtistSortAsName	= (0 < m_strColArtistSortAsName.length());
	m_bColDiscNumber		= (0 < m_strColDiscNumber.length());
	m_bColDiscName			= (0 < m_strColDiscName.length());
	m_bColDiscShortName		= (0 < m_strColDiscShortName.length());
	m_bColDiscSortAsName	= (0 < m_strColDiscSortAsName.length());
	m_bColTrackNumber		= (0 < m_strColTrackNumber.length());
	m_bColTrackName			= (0 < m_strColTrackName.length());
}

bool CSNCSVLine::SetListName(const char *szPronto)
{
	if (0 != m_pMap->m_nColListName)
	{
		m_bColListName = true;
		m_strColListName = szPronto;
		return(true);
	}
	else
	{
		return(false);
	}
}

bool CSNCSVLine::SetSNDevName(const char *szPronto)
{
	if (0 != m_pMap->m_nColSNDevName)
	{
		m_bColSNDevName = true;
		m_strColSNDevName = szPronto;
		return(true);
	}
	else
	{
		return(false);
	}
}

bool CSNCSVLine::SetArtistName(const char *szPronto)
{
	if (0 != m_pMap->m_nColArtistName)
	{
		m_bColArtistName = true;
		m_strColArtistName = szPronto;
		return(true);
	}
	else
	{
		return(false);
	}
}

bool CSNCSVLine::SetArtistShortName(const char *szPronto)
{
	if (0 != m_pMap->m_nColArtistShortName)
	{
		m_bColArtistShortName = true;
		m_strColArtistShortName = szPronto;
		return(true);
	}
	else
	{
		return(false);
	}
}

bool CSNCSVLine::SetArtistSortAsName(const char *szPronto)
{
	if (0 != m_pMap->m_nColArtistSortAsName)
	{
		m_bColArtistSortAsName = true;
		m_strColArtistSortAsName = szPronto;
		return(true);
	}
	else
	{
		return(false);
	}
}

bool CSNCSVLine::SetDiscNumber(const char *szPronto)
{
	if (0 != m_pMap->m_nColDiscNumber)
	{
		m_bColDiscNumber = true;
		m_strColDiscNumber = szPronto;
		return(true);
	}
	else
	{
		return(false);
	}
}

bool CSNCSVLine::SetDiscName(const char *szPronto)
{
	if (0 != m_pMap->m_nColDiscName)
	{
		m_bColDiscName = true;
		m_strColDiscName = szPronto;
		return(true);
	}
	else
	{
		return(false);
	}
}

bool CSNCSVLine::SetDiscShortName(const char *szPronto)
{
	if (0 != m_pMap->m_nColDiscShortName)
	{
		m_bColDiscShortName = true;
		m_strColDiscShortName = szPronto;
		return(true);
	}
	else
	{
		return(false);
	}
}

bool CSNCSVLine::SetDiscSortAsName(const char *szPronto)
{
	if (0 != m_pMap->m_nColDiscSortAsName)
	{
		m_bColDiscSortAsName = true;
		m_strColDiscSortAsName = szPronto;
		return(true);
	}
	else
	{
		return(false);
	}
}

bool CSNCSVLine::SetTrackNumber(const char *szPronto)
{
	if (0 != m_pMap->m_nColTrackNumber)
	{
		m_bColTrackNumber = true;
		m_strColTrackNumber = szPronto;
		return(true);
	}
	else
	{
		return(false);
	}
}

bool CSNCSVLine::SetTrackName(const char *szPronto)
{
	if (0 != m_pMap->m_nColTrackName)
	{
		m_bColTrackName = true;
		m_strColTrackName = szPronto;
		return(true);
	}
	else
	{
		return(false);
	}
}

const char *CSNCSVLine::GetListName(void) const
{
	if (m_bColListName)
	{
		return(m_strColListName.c_str());
	}
	else
	{
		return(NULL);
	}
}

const char *CSNCSVLine::GetSNDevName(void) const
{
	if (m_bColSNDevName)
	{
		return(m_strColSNDevName.c_str());
	}
	else
	{
		return(NULL);
	}
}

const char *CSNCSVLine::GetArtistName(void) const
{
	if (m_bColArtistName)
	{
		return(m_strColArtistName.c_str());
	}
	else
	{
		return(NULL);
	}
}

const char *CSNCSVLine::GetArtistShortName(void) const
{
	if (m_bColArtistShortName)
	{
		return(m_strColArtistShortName.c_str());
	}
	else
	{
		return(NULL);
	}
}

const char *CSNCSVLine::GetArtistSortAsName(void) const
{
	if (m_bColArtistSortAsName)
	{
		return(m_strColArtistSortAsName.c_str());
	}
	else
	{
		return(NULL);
	}
}

const char *CSNCSVLine::GetDiscNumber(void) const
{
	if (m_bColDiscNumber)
	{
		return(m_strColDiscNumber.c_str());
	}
	else
	{
		return(NULL);
	}
}

const char *CSNCSVLine::GetDiscName(void) const
{
	if (m_bColDiscName)
	{
		return(m_strColDiscName.c_str());
	}
	else
	{
		return(NULL);
	}
}

const char *CSNCSVLine::GetDiscShortName(void) const
{
	if (m_bColDiscShortName)
	{
		return(m_strColDiscShortName.c_str());
	}
	else
	{
		return(NULL);
	}
}

const char *CSNCSVLine::GetDiscSortAsName(void) const
{
	if (m_bColDiscSortAsName)
	{
		return(m_strColDiscSortAsName.c_str());
	}
	else
	{
		return(NULL);
	}
}

const char *CSNCSVLine::GetTrackNumber(void) const
{
	if (m_bColTrackNumber)
	{
		return(m_strColTrackNumber.c_str());
	}
	else
	{
		return(NULL);
	}
}

const char *CSNCSVLine::GetTrackName(void) const
{
	if (m_bColTrackName)
	{
		return(m_strColTrackName.c_str());
	}
	else
	{
		return(NULL);
	}
}
