// CSVLine.h: interface for the CCSVLine class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SNCSVLINE_H__73600025_32AD_11D5_A054_000102E0AE12__INCLUDED_)
#define AFX_SNCSVLINE_H__73600025_32AD_11D5_A054_000102E0AE12__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CSVFile.h"

struct SSNCSVMap
{
	int m_nColListName;
	int m_nColSNDevName;
	int m_nColArtistName;
	int m_nColArtistShortName;
	int m_nColArtistSortAsName;
	int m_nColDiscNumber;
	int m_nColDiscName;
	int m_nColDiscShortName;
	int m_nColDiscSortAsName;
	int m_nColTrackNumber;
	int m_nColTrackName;

	int GetMaxCol(void) const;
	int GetFirstColWithDuplicates(void) const; // Returns zero if there are none.
};

class CSNCSVLine  
{
public:
	CSNCSVLine(const SSNCSVMap *pMap);
	virtual ~CSNCSVLine();

	// Unlike most classes in this project, you can also use the default assignment operator.
	void Set(const CSNCSVLine *pToCopy);

	bool IsReady(void) const;

	void AddToCSVFile(CCSVFile *pCSVFile) const;
	void GetFromCSVFile(const CCSVFile *pCSVFile, CCSVFile::const_lineIter lIter);

	bool SetListName(const char *szPronto);
	bool SetSNDevName(const char *szPronto);
	bool SetArtistName(const char *szPronto);
	bool SetArtistShortName(const char *szPronto);
	bool SetArtistSortAsName(const char *szPronto);
	bool SetDiscNumber(const char *szPronto);
	bool SetDiscName(const char *szPronto);
	bool SetDiscShortName(const char *szPronto);
	bool SetDiscSortAsName(const char *szPronto);
	bool SetTrackNumber(const char *szPronto);
	bool SetTrackName(const char *szPronto);

	const char *GetListName(void) const;
	const char *GetSNDevName(void) const;
	const char *GetArtistName(void) const;
	const char *GetArtistShortName(void) const;
	const char *GetArtistSortAsName(void) const;
	const char *GetDiscNumber(void) const;
	const char *GetDiscName(void) const;
	const char *GetDiscShortName(void) const;
	const char *GetDiscSortAsName(void) const;
	const char *GetTrackNumber(void) const;
	const char *GetTrackName(void) const;

protected:
	// All members must be assignable.

	const SSNCSVMap *m_pMap;

	bool m_bColListName;
	bool m_bColSNDevName;
	bool m_bColArtistName;
	bool m_bColArtistShortName;
	bool m_bColArtistSortAsName;
	bool m_bColDiscNumber;
	bool m_bColDiscName;
	bool m_bColDiscShortName;
	bool m_bColDiscSortAsName;
	bool m_bColTrackNumber;
	bool m_bColTrackName;

	string m_strColListName;
	string m_strColSNDevName;
	string m_strColArtistName;
	string m_strColArtistShortName;
	string m_strColArtistSortAsName;
	string m_strColDiscNumber;
	string m_strColDiscName;
	string m_strColDiscShortName;
	string m_strColDiscSortAsName;
	string m_strColTrackNumber;
	string m_strColTrackName;
};

#endif // !defined(AFX_SNCSVLINE_H__73600025_32AD_11D5_A054_000102E0AE12__INCLUDED_)
