
#ifndef __SNCONFIG_H_
#define __SNCONFIG_H_

// Registry paths

#define SN_REG_PATH_ROOT					"Software\\Nudel\\Nudelist"

#define SN_REG_VALUE_CONFIGANDTEMPAREA		"ConfigAndTempArea"
#define SN_REG_VALUE_INPUTCCF				"InputCCF"
#define SN_REG_VALUE_OUTPUTCCF				"OutputCCF"
#define SN_REG_VALUE_COMPRESSIMAGES			"CompressImages"
#define SN_REG_VALUE_PANELCAP				"PanelCap"
#define SN_REG_VALUE_WELCOMESHOWN			"WelcomeShown"
#define SN_REG_VALUE_EXPORTFILENAME			"ExportFileName"
#define SN_REG_VALUE_EXPORTFILETYPE			"ExportFileType"
#define SN_REG_VALUE_IMPORTFILENAME			"ImportFileName"
#define SN_REG_VALUE_IMPORTFILETYPE			"ImportFileType"

#define SN_REG_PATH_CSV						"Software\\Nudel\\Nudelist\\CSV"

#define SN_REG_VALUE_CSV_LISTNAME			"ListName"
#define SN_REG_VALUE_CSV_SNDEVNAME			"SNDevName"
#define SN_REG_VALUE_CSV_ARTISTNAME			"ArtistName"
#define SN_REG_VALUE_CSV_ARTISTSHORTNAME	"ArtistShortName"
#define SN_REG_VALUE_CSV_ARTISTSORTASNAME	"ArtistSortAsName"
#define SN_REG_VALUE_CSV_DISCNUMBER			"DiscNumber"	
#define SN_REG_VALUE_CSV_DISCNAME			"DiscName"
#define SN_REG_VALUE_CSV_DISCSHORTNAME		"DiscShortName"
#define SN_REG_VALUE_CSV_DISCSORTASNAME		"DiscSortAsName"
#define SN_REG_VALUE_CSV_TRACKNUMBER		"TrackNumber"
#define SN_REG_VALUE_CSV_TRACKNAME			"TrackName"

#define SN_REG_PATH_WINDOWPOS				"Software\\Nudel\\Nudelist\\WindowPos"

#define SN_REG_VALUE_WINDOWPOS_MAIN			"Main"
#define SN_REG_VALUE_WINDOWPOS_PROGRESS		"Progress"
#define SN_REG_VALUE_WINDOWPOS_ARTIST		"Artist"
#define SN_REG_VALUE_WINDOWPOS_ATSELECT		"ATSelect"
#define SN_REG_VALUE_WINDOWPOS_CSV			"CSV"
#define SN_REG_VALUE_WINDOWPOS_DEVADD		"DevAdd"
#define SN_REG_VALUE_WINDOWPOS_DEV			"Dev"
#define SN_REG_VALUE_WINDOWPOS_DEVS			"Devs"
#define SN_REG_VALUE_WINDOWPOS_DEVRES		"DevRes"
#define SN_REG_VALUE_WINDOWPOS_DISC			"Disc"
#define SN_REG_VALUE_WINDOWPOS_IMPORT		"Import"
#define SN_REG_VALUE_WINDOWPOS_LIST			"List"
#define SN_REG_VALUE_WINDOWPOS_LISTING		"Listing"
#define SN_REG_VALUE_WINDOWPOS_LISTS		"Lists"
#define SN_REG_VALUE_WINDOWPOS_REPORT		"Report"
#define SN_REG_VALUE_WINDOWPOS_TRACK		"Track"

// Possible values of SN_REG_VALUE_(IMPORT|EXPORT)FILETYPE
#define SN_REG_CONTENT_CSV					"CSV"
#define SN_REG_CONTENT_SNXML				"SNXML"
#define SN_REG_CONTENT_LEGACY				"Legacy"

// File system paths

#define SN_DIRECTORY_CONFIG				"SN_Config"
#define SN_FILE_DEVICES					"SN_Devices.xml"
#define SN_FILE_LIBRARY					"SN_Library.xml"
#define SN_DIRECTORY_TEMP				"SN_Temp"
#define SN_FILE_TEMPCSF					"SuperNudelist.csf"

// XML

#define SNXML_DOC_DEVICES				((const xmlChar *)"SuperNudelistDevices")
#define SNXML_DOC_LIBRARY				((const xmlChar *)"SuperNudelistLibrary")

#define SNXML_NODE_DEVICES				((const xmlChar *)"Devices")
#define SNXML_NODE_DEVICE				((const xmlChar *)"Device")
#define SNXML_NODE_LIBRARY				((const xmlChar *)"Library")
#define SNXML_NODE_VOLUME				((const xmlChar *)"Volume")
#define SNXML_NODE_ARTIST				((const xmlChar *)"Artist")
#define SNXML_NODE_DISC					((const xmlChar *)"Disc")
#define SNXML_NODE_TRACK				((const xmlChar *)"Track")
#define SNXML_NODE_CSFPATH				((const xmlChar *)"CSFPath")
#define SNXML_NODE_HARDBUTTONDEFINITION	((const xmlChar *)"HardButtonDefinition")

#define SNXML_PROP_VERSION				((const xmlChar *)"Version")
#define SNXML_PROP_NUMBER				((const xmlChar *)"Number")
#define SNXML_PROP_NAME					((const xmlChar *)"Name")
#define SNXML_PROP_LABEL				((const xmlChar *)"Label")
#define SNXML_PROP_SHORTNAME			((const xmlChar *)"ShortName")
#define SNXML_PROP_SORTASNAME			((const xmlChar *)"SortAsName")
#define SNXML_PROP_TYPE					((const xmlChar *)"Type")
#define SNXML_PROP_KEEPCHILDRENSORTED	((const xmlChar *)"KeepChildrenSorted")
#define SNXML_PROP_SHOWNUMBERS			((const xmlChar *)"ShowNumbers")
#define SNXML_PROP_GAPBREAKALWAYS		((const xmlChar *)"GapBreakAlways")
#define SNXML_PROP_GAPSPACE				((const xmlChar *)"GapSpace")
#define SNXML_PROP_GAPFIT				((const xmlChar *)"GapFit")
#define SNXML_PROP_SHOWLETTERS			((const xmlChar *)"ShowLetters")
#define SNXML_PROP_SHOWARTISTS			((const xmlChar *)"ShowArtists")
#define SNXML_PROP_SHOWDISCS			((const xmlChar *)"ShowDiscs")
#define SNXML_PROP_SHOWTRACKS			((const xmlChar *)"ShowTracks")
#define SNXML_PROP_HIDEPANELS			((const xmlChar *)"HidePanels")
#define SNXML_PROP_LARGERFONT			((const xmlChar *)"LargerFont")
#define SNXML_PROP_TRUNCATE				((const xmlChar *)"Truncate")
#define SNXML_PROP_LINKS				((const xmlChar *)"Links")
#define SNXML_PROP_DELAYDISCUNTILTRACK	((const xmlChar *)"DelayDiscUntilTrack")
#define SNXML_PROP_JUMPAFTERTRACK		((const xmlChar *)"JumpAfterTrack")
// DeviceName is used by CSNDiscs, not by CSNDevices, which use Name for their own name.
#define SNXML_PROP_DEVICENAME			((const xmlChar *)"DeviceName")
#define SNXML_PROP_CSFDEVICENAME		((const xmlChar *)"CSFDeviceName")
#define SNXML_PROP_CSFPANELNAME			((const xmlChar *)"CSFPanelName")
#define SNXML_PROP_CSFBUTTONNAME		((const xmlChar *)"CSFButtonName")
#define SNXML_PROP_DIGITSTOPADTO		((const xmlChar *)"DigitsToPadTo")
#define SNXML_PROP_TENTHSSECDELAYTIME	((const xmlChar *)"TenthsSecDelayTime")
#define SNXML_PROP_TENTHSSECDISCTOTRACKDELAYTIME ((const xmlChar*)"TenthsSecDiscToTrackDelayTime")
#define SNXML_PROP_DELAYONLYIDENTICAL	((const xmlChar *)"DelayOnlyIdentical")
#define SNXML_PROP_IGNORETRACKS			((const xmlChar *)"IgnoreTracks")

#define SNXML_VALUE_XML_VERSION			((const xmlChar *)XML_DEFAULT_VERSION)

#define SNXML_VALUE_0					((const xmlChar *)"0")
#define SNXML_VALUE_1					((const xmlChar *)"1")

#define SNXML_VALUE_DEVICES_VERSION		((const xmlChar *)"1")
#define SNXML_VALUE_LIBRARY_VERSION		((const xmlChar *)"1")

#define SNXML_VALUE_JUMPPANEL			((const xmlChar *)"JumpPanel")
#define SNXML_VALUE_BEFOREBUTTON		((const xmlChar *)"BeforeButton")
#define SNXML_VALUE_AFTERBUTTON			((const xmlChar *)"AfterButton")
#define SNXML_VALUE_BEFORETRACKBUTTON1D	((const xmlChar *)"BeforeTrackButton1Digit")
#define SNXML_VALUE_BEFORETRACKBUTTON2D	((const xmlChar *)"BeforeTrackButton2Digits")
#define SNXML_VALUE_AFTERTRACKBUTTON	((const xmlChar *)"AfterTrackButton")
#define SNXML_VALUE_AFTERTRACKBUTTON1D	((const xmlChar *)"AfterTrackButton1Digit")
#define SNXML_VALUE_AFTERTRACKBUTTON2D	((const xmlChar *)"AfterTrackButton2Digits")
#define SNXML_VALUE_NUMBERBUTTON		((const xmlChar *)"NumberButton")
#define SNXML_VALUE_LINKBUTTON			((const xmlChar *)"LinkButton")
#define SNXML_VALUE_BUTTONALIAS			((const xmlChar *)"ButtonAlias")

#define SNXML_VALUE_PANEL				((const xmlChar *)"Panel")
#define SNXML_VALUE_BUTTON				((const xmlChar *)"Button")

//

class CTypedError;
class CProgressDlg;
class CSNDeviceList;
class CSNLibrary;
class CSNDisc;
class CCSFAbstractTree;

class CSNConfig
{
public:
	enum { MAX_PANELCAP = 32767 }; // Piece of shit spin control seems to flake above this.

public:

	// -- Init stuff --

	CSNConfig(void);
	virtual ~CSNConfig(void);

	bool IsReady(CTypedError *pTError, bool bRequireOutput) const;

	bool ResolveCSFPaths(CTypedError *pTError, const CCSFAbstractTree *pAT);

	// Returns the set of discs which could not be resolved or NULL if there are none.
	// If non-NULL, the result should be deleted.
	set<CSNDisc *> *ResolveDevices(void);

	void SetConfigAndTempAreaPath(const char *path);
	bool SetConfigAndTempAreaPathDefault(CTypedError *pTError);
	void SetInputCCFPath(const char *path);
	void SetOutputCCFPath(const char *path);
	void SetCompressImages(bool bCompressImages);
	void SetPanelCap(int nPanCap);

	// Get functions return NULL if no value set.
	// The results of the get functions are invalid if the config is changed or deleted.
	const char *GetConfigAndTempAreaPath(void) const;
	const char *GetConfigPath(void) const;
	const char *GetDevicesFilePath(void) const;
	const char *GetLibraryFilePath(void) const;
	const char *GetTempPath(void) const;
	const char *GetTempCSFPath(void) const;
	const char *GetInputCCFPath(void) const;
	const char *GetOutputCCFPath(void) const;
	bool GetCompressImages(void) const;
	int GetPanelCap(void) const;
	const CSNDeviceList *GetDevices(void) const;
	CSNDeviceList *GetDevices(void);
	const CSNLibrary *GetLibrary(void) const;
	CSNLibrary *GetLibrary(void);

	bool Load(CProgressDlg *pProgressDlg, CTypedError *pTError, CStringList *pSLErrorDetails);

	bool LoadCCFPathsAndOptions(CTypedError *pTError);
	bool LoadDevices(CTypedError *pTError, CStringList *pSLErrorDetails);
	// Set szImportFilename to NULL to load to the config file rather than an import.
	bool LoadLibrary(CTypedError *pTError, CStringList *pSLErrorDetails, const char *szImportFilename);

	bool SaveCCFPathsAndOptions(CTypedError *pTError) const;
	bool SaveDevices(CTypedError *pTError) const;
	// Set szExportFilename to NULL to save to the config file rather than an export.
	bool SaveLibrary(CTypedError *pTError, const char *szExportFilename) const;

	// -- Environment --

	// Returns NULL on error.
	const char *CSNConfig::GetExePath(CTypedError *pTError) const;
	// Returns NULL on error.
	const char *CSNConfig::GetExeDirectoryPath(CTypedError *pTError) const;
	// Returns NULL on error.
	const char *CSNConfig::GetExeVersionString(CTypedError *pTError) const;

protected:
	mutable CRITICAL_SECTION m_CS;

	bool m_bConfigAndTempPathIsDefault;

	char *m_configAndTempPath;
	char *m_configPath;
	char *m_devicesFilePath;
	char *m_libraryFilePath;
	char *m_tempPath;
	char *m_tempCSFPath;
	char *m_inputCCFPath;
	char *m_outputCCFPath;
	bool m_bCompressImages;
	int m_nPanelCap;

	mutable char *m_exePath;
	mutable char *m_exeDirectoryPath;
	mutable char *m_exeVersionString;

	CSNDeviceList *m_pDeviceList;
	CSNLibrary *m_pLibrary;
};

#endif
