// SNHardButtonDefinition.h: interface for the CSNHardButtonDefinition class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SNHARDBUTTONDEFINITION_H__FDCC30B2_3089_460E_85CD_797EDB0DEDE3__INCLUDED_)
#define AFX_SNHARDBUTTONDEFINITION_H__FDCC30B2_3089_460E_85CD_797EDB0DEDE3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SNList.h"
#include "CSFPath.h"

class CCSFSection;

class CSNHardButtonDefinition : public CSNListObject
{
	friend class CSNList<CSNHardButtonDefinition>;
	friend class CSNUpdatableList<CSNHardButtonDefinition>;
	friend class CSNSetableList<CSNHardButtonDefinition>;

public:
	CSNHardButtonDefinition();
	CSNHardButtonDefinition(const char *szNamePronto, bool bHasLabel);
	virtual ~CSNHardButtonDefinition();

	const char *getTypeName(void) const;
	bool IsValid(CTypedError *pTError) const;
	int CompareForSort(const CSNHardButtonDefinition *pHBD) const;
	void Set(const CSNHardButtonDefinition *pHBD);

	bool IsNonEmpty(void) const;

	bool ResolveCSFPaths(CTypedError *pTError, const CCSFAbstractTree *pAT, const char *ownerType, const char *ownerName);

	const CProntoString *	GetName(void)					const;

	// GetLabel returns NULL if the hard button has no label (ever).
		  CProntoString *	GetLabel(void);
	const CProntoString *	GetLabel(void)					const;

	const CCSFPanelPath *	GetJumpPanel(void)				const;
	void SetJumpPanel(const CCSFPanelPath *pJumpPanel);

	CCSFButtonPathList *GetActionButtonPaths(void);
	const CCSFButtonPathList *GetActionButtonPaths(void) const;

	xmlNodePtr AddToXML(xmlNodePtr parentNode) const;
	bool BuildFromXML(CTypedError *pTError, CStringList *pSLErrorDetails, xmlNodePtr pNode, bool bIgnoreLabelIfNoneAlready);

	void AddToDeviceCSFSection(CCSFSection *pDeviceCSFSection) const;

protected:
	CProntoString m_name;
	CProntoString *m_pLabel;
	CCSFPanelPath *m_pJumpPanel;
	CCSFButtonPathList m_actionButtonPaths;

protected:
	void init(void);
};

class CSNHardButtonDefinitionList : public CSNSetableList<CSNHardButtonDefinition>
{
public:
	CSNHardButtonDefinitionList()
	{
	}

	virtual ~CSNHardButtonDefinitionList()
	{
	}
};

#endif // !defined(AFX_SNHARDBUTTONDEFINITION_H__FDCC30B2_3089_460E_85CD_797EDB0DEDE3__INCLUDED_)
