// SlotReport.h: interface for the CSlotReport class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SLOTREPORT_H__6C7FA04B_6644_49FC_B112_1AABA220C16A__INCLUDED_)
#define AFX_SLOTREPORT_H__6C7FA04B_6644_49FC_B112_1AABA220C16A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSNConfig;
class CSNDevice;

class CSlotReport  
{
public:

	// Trivial structure used to avoid problem where the const_devIter type has
	// a decorated name which is too long for the compiler to handle.
	// (Who puts a limit on the lengths of decorated names in the compiler for
	// a language with template types? FFS. :-))
	class VecOfDiscLists
	{
	public:
		VecOfDiscLists() {}
		vector< list<const CSNDisc *> > m_vecOfDiscLists;
	};

	typedef map<string, VecOfDiscLists>::const_iterator const_devIter;

public:
	CSlotReport(const CSNConfig *pConfig);
	virtual ~CSlotReport();

	void Generate(void); // Implicitly calls Reset before doing anything.

	void Reset(void);

	const_devIter DevBegin(void);
	const_devIter DevEnd(void);

protected:
	const CSNConfig *m_pConfig;

	// const version defined above.
	typedef map<string, VecOfDiscLists>::iterator devIter;

	map<string, VecOfDiscLists> m_mapDevs;
};

#endif // !defined(AFX_SLOTREPORT_H__6C7FA04B_6644_49FC_B112_1AABA220C16A__INCLUDED_)
