// SuperNudelist.h : main header file for the SUPERNUDELIST application
//

#if !defined(AFX_SUPERNUDELIST_H__D8347C84_7050_11D4_BF8F_0020AF872188__INCLUDED_)
#define AFX_SUPERNUDELIST_H__D8347C84_7050_11D4_BF8F_0020AF872188__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

#include "ProgressDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CSuperNudelistApp:
// See SuperNudelist.cpp for the implementation of this class
//

class CSuperNudelistApp : public CWinApp
{
public:
	CSuperNudelistApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSuperNudelistApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CSuperNudelistApp)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

protected:
	
	CFont *getProntoCFont(void);
	void freeProntoCFont(CFont *pFont);
	bool checkForProntoFont(HDC hdc, const char *faceName);
};

/////////////////////////////////////////////////////////////////////////////
// Start up Progress Dialog thread.

class CCCFWrapper;
class CSNConfig;
class CTypedError;
class CStringList;
class CSNDisc;

class CPDTStartUp : public CProgressDlgThread
{
public:

	CPDTStartUp(CSNConfig *pConfig, CCCFWrapper *pCCFWrapper, CTypedError *pTError,
				CStringList *pStringListErrors, bool *pbCCFDLLInitError);
	virtual ~CPDTStartUp(void);

	// Returns an ident for the thread.
	// Typically, each implementation of this class within a project will use a unique
	// ident. (-1) should not be used, but any other number is fine.
	// See CSuckLessDialog::OnThreadTermination().
	int GetIdent(void);

protected:
	CSNConfig *m_pConfig;
	CCCFWrapper *m_pCCFWrapper;
	CTypedError *m_pTError;
	CStringList *m_pStringListErrors;
	bool *m_pbCCFDLLInitError;

	// Overriden to provide functionality.
	void mainThreadSubClass(void);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SUPERNUDELIST_H__D8347C84_7050_11D4_BF8F_0020AF872188__INCLUDED_)
