// SuperNudelistDlg.h : header file
//

#if !defined(AFX_SUPERNUDELISTDLG_H__D8347C86_7050_11D4_BF8F_0020AF872188__INCLUDED_)
#define AFX_SUPERNUDELISTDLG_H__D8347C86_7050_11D4_BF8F_0020AF872188__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "SuckLessDialog.h"
#include "ProgressDlg.h"

class CSNConfig;
class CSNDisc;
class CCCFWrapper;

/////////////////////////////////////////////////////////////////////////////
// CSuperNudelistDlg dialog

class CSuperNudelistDlg : public CSuckLessDialog
{
// Construction
public:
	CSuperNudelistDlg(CSNConfig *pConfig, CCCFWrapper *pCCFWrapper, CWnd* pParent);
	virtual ~CSuperNudelistDlg();

// Dialog Data
	//{{AFX_DATA(CSuperNudelistDlg)
	enum { IDD = IDD_SUPERNUDELIST_DIALOG };
	CButton	m_ctrlCheckPanCap;
	CSpinButtonCtrl	m_ctrlSpinPanCap;
	CEdit	m_ctrlEditPanCap;
	CButton	m_ctrlButtonExecute;
	CButton	m_ctrlCheckCompressedImages;
	CString	m_editInputCCF;
	CString	m_editOutputCCF;
	BOOL	m_checkCompressImages;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSuperNudelistDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CSNConfig *m_pConfig;
	CCCFWrapper *m_pCCFWrapper;

	bool m_bDevResSuccess;

	bool m_bThreadResult;
	CStringList m_threadErrorList;
	CTypedError m_threadTError;

	CStringList m_threadEmptiesList;

	set<CSNDisc *> *m_pSetDiscsWithUnresolvedDevices;

	bool m_bUpdatingPanelCap;

	void updatePanelCap(int nPanCap, bool bUpdateEdit, bool bUpdateSpin);

	void updateConfig(void);
	bool askToRemoveDevices(void);

	// SuckLessDialog:
	void virtual OnPseudoModalChildClose(int sldIDD, LPARAM lparam);

	// Generated message map functions
	//{{AFX_MSG(CSuperNudelistDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnCancel();
	afx_msg void OnButtonInput();
	afx_msg void OnButtonOutput();
	afx_msg void OnButtonExecute();
	afx_msg void OnButtonAbout();
	afx_msg void OnNcDestroy();
	afx_msg void OnButtonDevices();
	afx_msg void OnButtonLists();
	afx_msg void OnCheckPancap();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnChangeEditPancap();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// Clean up Progress Dialog thread.

class CCCFWrapper;

class CPDTCleanUp : public CProgressDlgThread
{
public:

	CPDTCleanUp(const CSNConfig *pConfig, CCCFWrapper *pCCFWrapper); 
	virtual ~CPDTCleanUp(void);

	// Returns an ident for the thread.
	// Typically, each implementation of this class within a project will use a unique
	// ident. (-1) should not be used, but any other number is fine.
	// See CSuckLessDialog::OnThreadTermination().
	int GetIdent(void);

protected:
	const CSNConfig *m_pConfig;
	CCCFWrapper *m_pCCFWrapper;

	// Overriden to provide functionality.
	void mainThreadSubClass(void);
};

/////////////////////////////////////////////////////////////////////////////
// Decompile Progress Dialog thread.

class CPDTPrep : public CProgressDlgThread
{
public:

	CPDTPrep(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
					 CSNConfig *pConfig, CCCFWrapper *pCCFWrapper);
	virtual ~CPDTPrep(void);

	// Returns an ident for the thread.
	// Typically, each implementation of this class within a project will use a unique
	// ident. (-1) should not be used, but any other number is fine.
	// See CSuckLessDialog::OnThreadTermination().
	virtual int GetIdent(void) = 0;

protected:
	bool *m_pbThreadResult;
	CStringList *m_pStrLstLog;
	CTypedError *m_pThreadTError;

	CSNConfig *m_pConfig;
	CCCFWrapper *m_pCCFWrapper;

	// Overriden to provide functionality.
	virtual void mainThreadSubClass(void);
};

class CPDTPrepForDevs : public CPDTPrep
{
public:

	CPDTPrepForDevs(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
					 CSNConfig *pConfig, CCCFWrapper *pCCFWrapper);
	virtual ~CPDTPrepForDevs(void);

	virtual int GetIdent(void);

protected:
	// Overriden to provide functionality.
	virtual void mainThreadSubClass(void);
};

class CPDTPrepForLists : public CPDTPrep
{
public:

	CPDTPrepForLists(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
					 CSNConfig *pConfig, CCCFWrapper *pCCFWrapper);
	virtual ~CPDTPrepForLists(void);

	virtual int GetIdent(void);

protected:
	// Overriden to provide functionality.
	virtual void mainThreadSubClass(void);
};

class CPDTPrepForExec : public CPDTPrep
{
public:

	CPDTPrepForExec(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
					 CSNConfig *pConfig, CCCFWrapper *pCCFWrapper);
	virtual ~CPDTPrepForExec(void);

	virtual int GetIdent(void);

protected:
	// Overriden to provide functionality.
	virtual void mainThreadSubClass(void);
};

class CPDTResolveForExec : public CProgressDlgThread
{
public:
	CPDTResolveForExec(bool *pbThreadResult, CTypedError *pThreadTError,
					 CSNConfig *pConfig, CCCFWrapper *pCCFWrapper,
					 set<CSNDisc *> **ppSetDiscsWithUnresolvedDevices);
	virtual ~CPDTResolveForExec(void);

	virtual int GetIdent(void);

protected:
	bool *m_pbThreadResult;
	CTypedError *m_pThreadTError;

	CSNConfig *m_pConfig;
	CCCFWrapper *m_pCCFWrapper;

	set<CSNDisc *> **m_ppSetDiscsWithUnresolvedDevices;

	// Overriden to provide functionality.
	virtual void mainThreadSubClass(void);
};

class CPDTFinalExec : public CProgressDlgThread
{
public:
	CPDTFinalExec(bool *pbThreadResult, CStringList *pStrLstLog, CTypedError *pThreadTError,
					 CSNConfig *pConfig, CCCFWrapper *pCCFWrapper, CStringList *pStrLstEmpties);
	virtual ~CPDTFinalExec(void);

	virtual int GetIdent(void);

protected:
	bool *m_pbThreadResult;
	CStringList *m_pStrLstLog;
	CTypedError *m_pThreadTError;

	CStringList *m_pStrLstEmpties;

	CSNConfig *m_pConfig;
	CCCFWrapper *m_pCCFWrapper;

	// Overriden to provide functionality.
	virtual void mainThreadSubClass(void);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SUPERNUDELISTDLG_H__D8347C86_7050_11D4_BF8F_0020AF872188__INCLUDED_)
